
rem ============================================================================
rem                  Gnrateur de grilles de Sudoku
rem ============================================================================
rem Il existe un moyen facile de remplir un puzzle Sudoku complet - remplissage
rem de groupe et dcalage circulaire.
rem Remplissez la premire ligne avec neuf nombres diffrents.
rem Remplissez la deuxime ligne qui est un dcalage de la premire ligne de trois emplacements.
rem Remplissez la troisime ligne qui est un dcalage de la deuxime ligne de trois emplacements.
rem Remplissez la quatrime ligne qui est un dcalage de la troisime par un seul emplacement.
rem ============================================================================
rem Pour empcher lutilisateur de remarquer le motif vident, il peut tre judicieux de randomiser
rem lordre des lignes et des colonnes afin quil ny ait plus de motif.
rem Tant que les 9 numros de chaque ligne / colonne se dplacent ensemble en une seule unit,
rem la carte Sudoku restera toujours valide.
rem ============================================================================
dim vecteur(9), ligne$(9),i
label clic
caption 0,"Gnrateur de Sudoku"
application_title "Gnrateur de Sudoku"
button 100 : top 100,50 : left 100,400 : width 100,100
caption 100,"Nouveau Sudoku" : on_click 100,clic
button 110 : top 110,100 : left 110,400 : caption 110,"Info" : on_click 110,clic
button 120 : top 120,150 : left 120,400 : caption 120,"Quitter" : on_click 120,clic
color 0,100,150,200
Grille()
Sudoku()
end
rem ============================================================================
clic:
    select number_click
        case 100 : Sudoku()
        case 110 : Info()
        case 120 : terminate
    end_select
return
rem ============================================================================
SUB Grille()    
    dim_local ligne,colonne,objet,w,w1
    w = 20 : w1 = w+10
    for ligne = 1 to 9
        for colonne = 1 to 9
            objet = (ligne-1)*9 + colonne
            edit objet : left objet,10+colonne*w1 : top objet,10+ligne*w1
            width objet,w : height objet,w : color objet,100,250,200
            font_color objet,200,0,0 : font_bold objet
        next colonne
    next ligne

    2d_pen_width 4 : 2d_pen_color 255,0,0
    2d_rectangle w1+5,w1+5,w1*10+5,w1*10+10
    2d_line 4*w1+5,w1+5,4*w1+5,w1*10+7 : 2d_line 7*w1+5,w1+5,7*w1+5,w1*10+7
    2d_line w1+5,4*w1+7,w1*10+2,4*w1+7 : 2d_line w1+5,7*w1+7,w1*10+2,7*w1+7
END_SUB
rem ============================================================================

FNC Sudoku()
    for i = 1 to 9 : vecteur(i) = i : next i  : ' initialisation du vecteur tri
    ligne$(1) = Melanger_Vecteur$()           : ' mlanger les lments du vecteur
    ligne$(2) = Decaler$(ligne$(1),3)
    ligne$(3) = Decaler$(ligne$(2),3)
    ligne$(4) = Decaler$(ligne$(3),1)
    ligne$(5) = Decaler$(ligne$(4),3)
    ligne$(6) = Decaler$(ligne$(5),3)
    ligne$(7) = Decaler$(ligne$(6),1)
    ligne$(8) = Decaler$(ligne$(7),3)
    ligne$(9) = Decaler$(ligne$(8),3)

    for i = 1 to 9 : Afficher(ligne$(i),i) : next i
end
rem ============================================================================
' Mlanger les lments d'un tableau tri
FNC Melanger_Vecteur$()
    dim_local pos,sauve,hasard,ret$
    for pos = 9 to 1 step -1
        hasard = int(rnd(pos)+1)
        sauve  = vecteur(pos)
        vecteur(pos) = vecteur(hasard)
        vecteur(hasard) = sauve
    next pos
    for pos = 1 to 9 : ret$ = ret$ + str$(vecteur(pos)) : next pos
    result ret$
  
END_FNC
rem ============================================================================
' dcalage de n positions  gauche des lments d'une ligne (vecteur)
FNC Decaler$(l$,n)
    result right$(l$,9-n) + left$(l$,n)    
END_FNC
rem ============================================================================
' Affichage du Sudoku
SUB Afficher(ligne$,j)
    dim_local i,c$
    for i = 1 to 9
        c$ = mid$(ligne$,i,1) : text (j-1)*9+i," " + c$
    next i
END_SUB
rem ============================================================================
SUB Info()
    dim_local t$
    t$ = "Le but du jeu est de remplir la grille avec une srie de chiffres" +chr$(13)
    t$ = t$ + "(ou de lettres ou de symboles) tous diffrents, qui ne se trouvent jamais"+chr$(13)
    t$ = t$ + "plus dune fois sur une mme ligne, dans une mme colonne ou dans une mme"+chr$(13)
    t$ = t$ + "rgion (galement appele  bloc ,  groupe ,  secteur  ou  sous-grille )." +chr$(13)
    t$ = t$ + "La plupart du temps, les symboles sont des chiffres allant de 1  9,"+chr$(13)
    t$ = t$ + "les rgions tant alors des carrs de 3  3"
    
    message t$
END_SUB
rem ============================================================================