' ==============================================================================

'                 Programme RUBIK'S CUBE Ralis par Silverman   
               
'                                    -------                                                                    

'           Interface graphique et ramnagement du code par Minibug           

'                                    -------                                    

'                     Ralisation Septembre-Novembre 2022

' ==============================================================================

creation_label()
creation_variables()
creation_datas()
creation_scene()
creation_graphique() 
chargement_cube()

END

' ==============================================================================

' --------------------------- CREATION DES VARIABLES ---------------------------

SUB creation_label()

   LABEL clic , orienterCube , quitter

END_SUB

' --------------------------- CREATION DES VARIABLES ---------------------------

SUB creation_variables()

   DIM no% , clic%

   DIM form% , grid_original% , grid_sauvegarde% , scene% , panel%(15) , image%(15)
   
   DIM posX% , posY% , posZ%
   DIM Orientation_X% , Orientation_Y% , Orientation_Z%

   DIM I% , obj% , Angle_rot% , Angle% , x , y , z
   DIM Orientation_% , pos% , rot% , axe$ , face$ , tmp% , vitesse_rotation%
   DIM objX , objY , objZ

   DIM axe_new , face_new , axe_old , face_old

   DIM nombre_de_rotation%
   
   DIM x_souris% , y_souris% , n%
   DIM distanceCamera% , x_positionCamera% , y_positionCamera% , x% , y% , z%
   
   distanceCamera%=13 : x_positionCamera%=54 : y_positionCamera% = 25

   ' positions dans grid
   posX%=3 : posY%=4 : posZ%=5 : Orientation_X%=9 : Orientation_Y%=10 : Orientation_Z%=11

   vitesse_rotation%=3

END_SUB

' ----------------------------- CREATION DES DATAS -----------------------------

SUB creation_datas()

  DATA "Dplacement en profondeur de la couronne  gauche" 
  DATA "Dplacement en profondeur de la couronne au milieu"
  DATA "Dplacement en profondeur de la couronne  droite"
  
  DATA "Dplacement vertical de la couronne en avant"
  DATA "Dplacement vertical de la couronne au milieu"
  DATA "Dplacement vertical de la couronne en arrire"
  
  DATA "Dplacement horizontal de la couronne en haut"
  DATA "Dplacement horizontal de la couronne au milieu"
  DATA "Dplacement horizontal de la couronne en bas"
  
  DATA "Melange du cube de faon alatoire"
  DATA "Rinitialisation du cube"
  DATA "Repositionner le cube par defaut" 
 
  DATA "Information sur la ralisation de ce programme"
  DATA "Aide et explications pour l'utilisation du programme"
  DATA "Quitter le programme"   

END_SUB

' ---------------------------- CREATION DU SCENE_3D ----------------------------

SUB creation_scene()

   WIDTH no%,600 : HEIGHT no%,600 : COLOR no%,136,109,110 : ON_CLOSE no%,quitter
   CAPTION no%,"Rubik's cube - version 11.11.2022"
   LEFT no%,(SCREEN_X-600)/2 : TOP no%,(SCREEN_Y-600)/2 : form%=no% : no%=no%+1
   
   CREATE_HIDE
   
   ' donnes stockes dans un grid
   GRID no% : GRID_ROW no%,27 : GRID_ROW_FIXED no%,0 : GRID_COLUMN no%,11 : GRID_COLUMN_FIXED no%,0
   HIDE no% : grid_original%=no% :  no%=no%+1
  
   ' grid de sauvegarde
   GRID no% : GRID_ROW no%,27 : GRID_ROW_FIXED no%,0 : GRID_COLUMN no%,11 : GRID_COLUMN_FIXED no%,0
   HIDE no% : grid_sauvegarde%=no% :  no%=no%+1 
    
   CREATE_SHOW
      
   ' creation scne
   DEGREES
  
   SCENE3D no% : HEIGHT no%,HEIGHT_CLIENT(form%) : WIDTH no%,WIDTH_CLIENT(form%)
      COLOR no%,136,109,110 : ON_MOUSE_DOWN no%,orienterCube : scene%=no% : no%=no%+1

   ' la camra est cre en 0,0,5 / On la dplace pour voir 3 faces du cube
   CAM_POSITION -10,6,6 : LIGHT_POSITION -10,6,6   
   
   x_positionCamera%=145
   y_positionCamera%=25
   
   ' on cre 27 cubes texturs
   FOR obj%=1 TO 27
      3D_MESH obj% : 3D_LOAD_OBJECT obj%,"cube.3DS" : 3D_LOAD_TEXTURE obj%,"Cube.bmp"
   NEXT obj%
  
   ' X axe rouge, sens de rotation anti-horaire
   ' Y axe vert, sens de rotation horaire
   ' Z axe bleu, sens de rotation horaire

   ' placement et donnes des objets
   obj%=0
   FOR x=-2 TO 2 STEP 2
      FOR y=-2 TO 2 STEP 2
         FOR z=-2 TO 2 STEP 2
            obj%=obj%+1
            ' placer les cubes
            3D_POSITION obj%,x,y,z
            
            ' position et orientation mmorises dans un grid
            ' grid_write grid_original%,obj%,1,str$(obj%)
            GRID_WRITE grid_original%,obj%,posX%,STR$(x)
            GRID_WRITE grid_original%,obj%,posY%,STR$(y)
            GRID_WRITE grid_original%,obj%,posZ%,STR$(z)
            '
            GRID_WRITE grid_original%,obj%,Orientation_X%,"1"
            GRID_WRITE grid_original%,obj%,Orientation_Y%,"2"
            GRID_WRITE grid_original%,obj%,Orientation_Z%,"3"
         NEXT z
      NEXT y
   NEXT x
   
   ' pointeur pour reset
   3D_CUBE 28,0.0000001
   
END_SUB

' ----------------------------- CREATION GRAPHIQUE -----------------------------

SUB creation_graphique()  

   DIM_LOCAL t$

   ' Cration des boutons
   FOR i%=1 TO 15
      PANEL no% : WIDTH no%,70 : HEIGHT no%,70 : panel%(I%)=no% : no%=no%+1
      PICTURE no% : PARENT no%,no%-1 : WIDTH no%,70 : HEIGHT no%,70
         READ t$ : HINT no%,t$ : STRETCH_ON no% : ON_CLICK no%,clic
         image%(i%)=no% : no%=no%+1
   NEXT i%
  
   ' Rotation Z
   LEFT panel%(1),20 : TOP panel%(1),20 : FILE_LOAD image%(1),"Z1.bmp" 
   LEFT panel%(2),20 : TOP panel%(2),100 : FILE_LOAD image%(2),"Z2.bmp"
   LEFT panel%(3),20 : TOP panel%(3),180 : FILE_LOAD image%(3),"Z3.bmp"

   ' Rotation X
   LEFT panel%(4),150 : TOP panel%(4),20 : FILE_LOAD image%(4),"Y1.bmp" 
   LEFT panel%(5),250 : TOP panel%(5),20 : FILE_LOAD image%(5),"Y2.bmp"
   LEFT panel%(6),350 : TOP panel%(6),20 : FILE_LOAD image%(6),"Y3.bmp"
  
   ' Rotation Y
   LEFT panel%(7),480 : TOP panel%(7),20 : FILE_LOAD image%(7),"X1.bmp" 
   LEFT panel%(8),480 : TOP panel%(8),100 : FILE_LOAD image%(8),"X2.bmp"
   LEFT panel%(9),480 : TOP panel%(9),180 : FILE_LOAD image%(9),"X3.bmp"
  
   ' Mlange
   LEFT panel%(10),20 : TOP panel%(10),400 : FILE_LOAD image%(10),"Melange.bmp"
 
   ' Reset
   LEFT panel%(11),20 : TOP panel%(11),480 : FILE_LOAD image%(11),"Reset.bmp"  

   ' Positionnement
   LEFT panel%(12),20 : TOP panel%(12),320 : FILE_LOAD image%(12),"Position.bmp"  

   ' Infos
   LEFT panel%(13),480 : TOP panel%(13),320 : FILE_LOAD image%(13),"Infos.bmp"
  
   ' Aide
   LEFT panel%(14),480 : TOP panel%(14),400 : FILE_LOAD image%(14),"Aide.bmp"
  
   ' Quitter
   LEFT panel%(15),480 : TOP panel%(15),480 : FILE_LOAD image%(15),"Quitter.bmp"        
  
   ' Message 
   PANEL no% : LEFT no%,140 : TOP no%,510 : WIDTH no%,300 : HEIGHT no%,40
      FONT_COLOR no%,255,255,255 : COLOR no%,136,109,110 : FONT_BOLD no% : FONT_SIZE no%,12
      CAPTION no%,"Cliquez sur l'icone de votre choix"
      no%=no%+1

END_SUB

' -------------------- CHARGEMENT DU POSITIONEMENT DU CUBE ---------------------
 
SUB chargement_cube()

   IF FILE_EXISTS("sauvegarde.cub")=1
      restaurer_datas_cube()
      affiche_cube(grid_sauvegarde%)
      FILE_DELETE "sauvegarde.cub"
   END_IF

END_SUB

' --------------------------- ROTATION DES COURONNES ---------------------------

SUB rotation_couronne(Angle_rot%,axe$,face$)

   IF MOD(Angle_rot%,360)=0
      EXIT_SUB
   ELSE
      Angle_rot%=MOD(Angle_rot%,360)
   END_IF
   
   axe$=LOWER$(axe$)
   
   IF axe$<>"x" AND axe$<>"y" AND axe$<>"z" THEN EXIT_SUB
   IF axe$="x" THEN pos%=posX%
   IF axe$="y" THEN pos%=posY%
   IF axe$="z" THEN pos%=posZ%
   IF face$<>"-2" AND face$<>"0" AND face$<>"2" THEN EXIT_SUB

   Orientation_%=pos%+6
   rot%=pos%-2

   FOR Angle%=0 TO Angle_rot% STEP SGN(Angle_rot%)*vitesse_rotation%
      IF Angle%<>0
         FOR obj%=1 TO 27
            IF GRID_READ$(grid_original%,obj%,pos%)=face$
    
               ' positions
               objX=VAL(GRID_READ$(grid_original%,obj%,posX%))
               objY=VAL(GRID_READ$(grid_original%,obj%,posY%))
               objZ=VAL(GRID_READ$(grid_original%,obj%,posZ%))
               Matrice_Rotation(objX,objY,objZ,Angle%,rot%)
               3D_POSITION obj%,x,y,z
               
               ' sens de rotation
               tmp%=VAL(GRID_READ$(grid_original%,obj%,Orientation_X%))
               IF tmp%=(Orientation_%-8) OR tmp%=(8-Orientation_%)
                   tmp%=1*SGN(tmp%)
               ELSE
                  tmp%=val(GRID_READ$(grid_original%,obj%,Orientation_Y%))
                  if tmp%=(Orientation_%-8) OR tmp%=(8-Orientation_%)
                      tmp%=2*SGN(tmp%)
                  ELSE
                      tmp%=VAL(GRID_READ$(grid_original%,obj%,Orientation_Z%))
                      tmp%=3*SGN(tmp%)
                  END_IF
               END_IF
            
               IF Orientation_%=Orientation_X% AND ABS(tmp%)>1 THEN tmp%=0-tmp%
               IF Orientation_%=Orientation_Y% AND ABS(tmp%)=1 THEN tmp%=0-tmp%
               IF Orientation_%=Orientation_Z% AND ABS(tmp%)=1 THEN tmp%=0-tmp%
   
               SELECT tmp%
                  CASE -3: 3D_Z_ROTATE obj%,O3D_Z_ROTATE(obj%)-vitesse_rotation%*SGN(Angle_rot%)
                  CASE -2: 3D_Y_ROTATE obj%,O3D_Y_ROTATE(obj%)-vitesse_rotation%*SGN(Angle_rot%)
                  CASE -1: 3D_X_ROTATE obj%,O3D_X_ROTATE(obj%)-vitesse_rotation%*SGN(Angle_rot%)
                  CASE 1 : 3D_X_ROTATE obj%,O3D_X_ROTATE(obj%)+vitesse_rotation%*SGN(Angle_rot%)
                  CASE 2 : 3D_Y_ROTATE obj%,O3D_Y_ROTATE(obj%)+vitesse_rotation%*SGN(Angle_rot%)
                  CASE 3 : 3D_Z_ROTATE obj%,O3D_Z_ROTATE(obj%)+vitesse_rotation%*SGN(Angle_rot%)
               END_SELECT
            END_IF
         NEXT obj%
      
         DISPLAY
      
      END_IF
   NEXT Angle%

   ' mise  jour des donnes
   FOR obj%=1 to 27
      IF GRID_READ$(grid_original%,obj%,pos%)=face$
         '
         ' positions
         objX=VAL(GRID_READ$(grid_original%,obj%,posX%))
         objY=VAL(GRID_READ$(grid_original%,obj%,posY%))
         objZ=VAL(GRID_READ$(grid_original%,obj%,posZ%))
         Matrice_Rotation(objX,objY,objZ,Angle_rot%,rot%)
         GRID_WRITE grid_original%,obj%,posX%,STR$(x)
         GRID_WRITE grid_original%,obj%,posY%,STR$(y)
         GRID_WRITE grid_original%,obj%,posZ%,STR$(z)
         '
         ' sens de rotation
         tmp%=VAL(GRID_READ$(grid_original%,obj%,Orientation_X%))
         IF tmp%=(Orientation_%-8) OR tmp%=(8-Orientation_%)
             tmp%=1*SGN(tmp%)
         ELSE
            tmp%=VAL(GRID_READ$(grid_original%,obj%,Orientation_Y%))
            IF tmp%=(Orientation_%-8) OR tmp%=(8-Orientation_%)
                tmp%=2*SGN(tmp%)
            ELSE
                tmp%=VAL(GRID_READ$(grid_original%,obj%,Orientation_Z%))
                tmp%=3*SGN(tmp%)
            END_IF
         END_IF
         '
         IF Orientation_%=Orientation_X% AND ABS(tmp%)>1 THEN tmp%=0-tmp%
         IF Orientation_%=Orientation_Y% AND ABS(tmp%)=1 THEN tmp%=0-tmp%
         IF Orientation_%=Orientation_Z% AND ABS(tmp%)=1 THEN tmp%=0-tmp%
         '
         objX=VAL(GRID_READ$(grid_original%,obj%,Orientation_X%))
         objY=VAL(GRID_READ$(grid_original%,obj%,Orientation_Y%))
         objZ=VAL(GRID_READ$(grid_original%,obj%,Orientation_Z%))
         '            
         SELECT tmp%
            CASE -3 : Matrice_Rotation(objX,objY,objZ,Angle_rot%,0-tmp%)
            CASE -2 : Matrice_Rotation(objX,objY,objZ,Angle_rot%,0-tmp%)
            CASE -1 : Matrice_Rotation(objX,objY,objZ,Angle_rot%,0-tmp%)
            CASE  1 : Matrice_Rotation(objX,objY,objZ,0-Angle_rot%,tmp%)
            CASE  2 : Matrice_Rotation(objX,objY,objZ,0-Angle_rot%,tmp%)
            CASE  3 : Matrice_Rotation(objX,objY,objZ,0-Angle_rot%,tmp%)
         END_SELECT
         
         GRID_WRITE grid_original%,obj%,Orientation_X%,STR$(x)
         GRID_WRITE grid_original%,obj%,Orientation_Y%,STR$(y)
         GRID_WRITE grid_original%,obj%,Orientation_Z%,STR$(z)
         '
      END_IF
   NEXT obj%
   
END_SUB

' --------------------- ROTATION DES COURONNES INVISIBLES ----------------------

SUB rotation_invisible_couronne(Angle_rot%,axe$,face$)

   IF MOD(Angle_rot%,360)=0
      EXIT_SUB
   ELSE
      Angle_rot%=MOD(Angle_rot%,360)
   END_IF
   axe$=LOWER$(axe$)
   IF axe$<>"x" AND axe$<>"y" AND axe$<>"z" THEN EXIT_SUB
   IF axe$="x" THEN pos%=posX%
   IF axe$="y" THEN pos%=posY%
   IF axe$="z" THEN pos%=posZ%
   IF face$<>"-2" AND face$<>"0" AND face$<>"2" THEN EXIT_SUB
   
   Orientation_%=pos%+6
   rot%=pos%-2
   
   ' mise  jour des donnes
   FOR obj%=1 TO 27
   
      IF GRID_READ$(grid_original%,obj%,pos%)=face$
         '
         ' positions
         objX=VAL(GRID_READ$(grid_original%,obj%,posX%))
         objY=VAL(GRID_READ$(grid_original%,obj%,posY%))
         objZ=VAL(GRID_READ$(grid_original%,obj%,posZ%))
         Matrice_Rotation(objX,objY,objZ,Angle_rot%,rot%)
         GRID_WRITE grid_original%,obj%,posX%,STR$(x)
         GRID_WRITE grid_original%,obj%,posY%,STR$(y)
         GRID_WRITE grid_original%,obj%,posZ%,STR$(z)
    
         ' sens de rotation
         tmp%=VAL(GRID_READ$(grid_original%,obj%,Orientation_X%))
         
         IF tmp%=(Orientation_%-8) OR tmp%=(8-Orientation_%)
             tmp%=1*SGN(tmp%)
         ELSE
            tmp%=VAL(GRID_READ$(grid_original%,obj%,Orientation_Y%))
            IF tmp%=(Orientation_%-8) OR tmp%=(8-Orientation_%)
                tmp%=2*SGN(tmp%)
            ELSE
                tmp%=VAL(GRID_READ$(grid_original%,obj%,Orientation_Z%))
                tmp%=3*SGN(tmp%)
            END_IF
         END_IF

         IF Orientation_%=Orientation_X% AND ABS(tmp%)>1 THEN tmp%=0-tmp%
         IF Orientation_%=Orientation_Y% AND ABS(tmp%)=1 THEN tmp%=0-tmp%
         IF Orientation_%=Orientation_Z% AND ABS(tmp%)=1 THEN tmp%=0-tmp%

         objX=VAL(GRID_READ$(grid_original%,obj%,Orientation_X%))
         objY=VAL(GRID_READ$(grid_original%,obj%,Orientation_Y%))
         objZ=VAL(GRID_READ$(grid_original%,obj%,Orientation_Z%))
     
         SELECT tmp%
            CASE -3 : Matrice_Rotation(objX,objY,objZ,Angle_rot%,0-tmp%)
            CASE -2 : Matrice_Rotation(objX,objY,objZ,Angle_rot%,0-tmp%)
            CASE -1 : Matrice_Rotation(objX,objY,objZ,Angle_rot%,0-tmp%)
            CASE  1 : Matrice_Rotation(objX,objY,objZ,0-Angle_rot%,tmp%)
            CASE  2 : Matrice_Rotation(objX,objY,objZ,0-Angle_rot%,tmp%)
            CASE  3 : Matrice_Rotation(objX,objY,objZ,0-Angle_rot%,tmp%)
         END_SELECT
     
         GRID_WRITE grid_original%,obj%,Orientation_X%,STR$(x)
         GRID_WRITE grid_original%,obj%,Orientation_Y%,STR$(y)
         GRID_WRITE grid_original%,obj%,Orientation_Z%,STR$(z)
         
      END_IF
   NEXT obj%
   
END_SUB

' --------------------------- RESET DES FACES DU CUBE --------------------------

SUB reset_cube()

   obj%=0
   
   FOR x=-2 TO 2 STEP 2
      FOR y=-2 TO 2 STEP 2
         FOR z=-2 TO 2 STEP 2
         
            obj%=obj%+1
            
            ' position et orientation mmorises dans un grid
            3D_POSITION obj%,x,y,z
            
            3D_ROTATE obj%,0,0,0 : troisD_point_position(obj%,0,0,0) : troisD_point_position(obj%,0,0,1) : ' RAZ cube  
            
            ' positions et orientations initiales mmorises dans un grid
            ' grid_write 1,obj%,1,str$(obj%)
            GRID_WRITE grid_original%,obj%,posX%,STR$(x)
            GRID_WRITE grid_original%,obj%,posY%,STR$(y)
            GRID_WRITE grid_original%,obj%,posZ%,STR$(z)
            
            GRID_WRITE grid_original%,obj%,Orientation_X%,"1"
            GRID_WRITE grid_original%,obj%,Orientation_Y%,"2"
            GRID_WRITE grid_original%,obj%,Orientation_Z%,"3"
         NEXT z
      NEXT y
   NEXT x
   
   DISPLAY
   
END_SUB

' ------------------------------ AFFICHAGE DU CUBE -----------------------------

SUB affiche_cube(grd%)

   FOR obj%=1 TO 27
   
      ' RAZ
      3D_ROTATE obj%,0,0,0 : troisD_point_position(obj%,0,0,0) : troisD_point_position(obj%,0,0,1) : ' RAZ cube

      ' orienter
      objx=VAL(GRID_READ$(grd%,obj%,Orientation_X%))
      objz=VAL(GRID_READ$(grd%,obj%,Orientation_Z%))
      orienter(obj%,objx,objz)

      ' positionner
      3D_POSITION obj%,VAL(GRID_READ$(grd%,obj%,posX%)),VAL(GRID_READ$(grd%,obj%,posY%)),VAL(GRID_READ$(grd%,obj%,posZ%))
   NEXT obj%
   
   DISPLAY
   
END_SUB

' ----------------------- SAUVEGARDE DES DONNEES DU CUBE -----------------------

SUB sauvegarder_datas_cube()

   FOR obj%=1 TO 27
      FOR I%=1 TO Orientation_Z%
            GRID_WRITE grid_sauvegarde%,obj%,I%,GRID_READ$(grid_original%,obj%,I%)
      NEXT I%
   NEXT obj%
   
   GRID_SAVE grid_sauvegarde%,27,Orientation_Z%,"sauvegarde.cub"
   
END_SUB

' ---------------------- RESTAURATION DES DONNEES DU CUBE ----------------------

SUB restaurer_datas_cube()

   GRID_LOAD grid_sauvegarde%,"sauvegarde.cub"

   FOR obj%=1 TO 27
      FOR I%=1 TO Orientation_Z%
            GRID_WRITE grid_original%,obj%,I%,GRID_READ$(grid_sauvegarde%,obj%,I%)
      NEXT I%
   NEXT obj%

END_SUB

' ------------------------- ORIENTER LE CUBE A LA SOURIS -----------------------

orienterCube:

    OFF_MOUSE_DOWN scene%

    ' on quitte le sous-programme si c'est le bouton droit de la souris qui est enfonc
    IF MOUSE_RIGHT_DOWN(scene%)=1
        ON_MOUSE_DOWN scene%,orienterCube
        RETURN
    END_IF

    x_souris%=MOUSE_X_POSITION(scene%)
    y_souris%=MOUSE_Y_POSITION(scene%)   

    WHILE MOUSE_LEFT_UP(scene%)=0
    
        x%=MOUSE_X_POSITION(scene%)-x_souris%+x_positionCamera%
        y%=MOUSE_Y_POSITION(scene%)-y_souris%+y_positionCamera%
        
        y%=MOD(y%,360)

        ' limitation du dplacement camra vers le bas
        IF y%>63
            y%=63
            y_positionCamera%=63
            y_souris%=MOUSE_Y_POSITION(scene%)
         END_IF
        
        ' limitation du dplacement camra vers le haut
        IF y%<-63
            y%=-63
            y_positionCamera%=-63
            y_souris%=MOUSE_Y_POSITION(scene%)
        END_IF
        
        CAM_X_POSITION COS(x%)*COS(y%)*distanceCamera%
        CAM_Z_POSITION SIN(x%)*COS(y%)*(distanceCamera%)
        CAM_Y_POSITION SIN(y%)*(distanceCamera%)
                
        PAUSE 20
    
    END_WHILE

    ' mmorisation de la nouvelle position de la camra
    x_positionCamera%=MOUSE_X_POSITION(scene%)-x_souris%+x_positionCamera%
    y_positionCamera%=MOUSE_Y_POSITION(scene%)-y_souris%+y_positionCamera%
                                            
    ON_MOUSE_DOWN scene%,orienterCube
    
return

' ==============================================================================
'                     P R O C E D U R E S   I N T E R N E S                    
' ==============================================================================

' -------------------------------- ORIENTATION ---------------------------------

SUB orienter(obj%,x,z)

   SELECT z
   
      CASE -1 : 3D_Y_ROTATE obj%,270
         SELECT x
            CASE 3 : 3D_Z_ROTATE obj%,0
            CASE 2 : 3D_Z_ROTATE obj%,90
            CASE -3: 3D_Z_ROTATE obj%,180
            CASE -2: 3D_Z_ROTATE obj%,270
         END_SELECT
             
      CASE 1 : 3D_Y_ROTATE obj%,90
         SELECT x
            CASE -3: 3D_Z_ROTATE obj%,0
            CASE 2 : 3D_Z_ROTATE obj%,90
            CASE 3 : 3D_Z_ROTATE obj%,180
            CASE -2: 3D_Z_ROTATE obj%,270
         END_SELECT
             
      CASE -2 : 3D_X_ROTATE obj%,270
         SELECT x
            CASE 1 : 3D_Z_ROTATE obj%,0
            CASE 3 : 3D_Z_ROTATE obj%,90
            CASE -1: 3D_Z_ROTATE obj%,180
            CASE -3: 3D_Z_ROTATE obj%,270
         END_SELECT
             
      CASE 2 : 3D_X_ROTATE obj%,90
         SELECT x
            CASE 1 : 3D_Z_ROTATE obj%,0
            CASE -3: 3D_Z_ROTATE obj%,90
            CASE -1: 3D_Z_ROTATE obj%,180
            CASE 3 : 3D_Z_ROTATE obj%,270
         END_SELECT
             
      CASE -3 : 3D_X_ROTATE obj%,180
         SELECT x
            CASE 1 : 3D_Z_ROTATE obj%,0
            CASE -2: 3D_Z_ROTATE obj%,90
            CASE -1: 3D_Z_ROTATE obj%,180
            CASE 2 : 3D_Z_ROTATE obj%,270
         END_SELECT
             
      CASE 3 : 3D_X_ROTATE obj%,0
         SELECT x
            CASE 1 : 3D_Z_ROTATE obj%,0
            CASE 2 : 3D_Z_ROTATE obj%,90
            CASE -1: 3D_Z_ROTATE obj%,180
            CASE -2: 3D_Z_ROTATE obj%,270
         END_SELECT
             
   END_SELECT
   
END_SUB

' ------------------------------ MATRICE ROTATION ------------------------------

sub Matrice_Rotation(px,py,pz,ang,axe)

   SELECT axe
      CASE 1: ' matrice de rotation X en sens anti horaire
             x = px*1 +py*0        +pz*0
             y = px*0 +py*COS(0-ang) -pz*SIN(0-ang)
             z = px*0 +py*SIN(0-ang) +pz*COS(0-ang)
      CASE 2: ' matrice de rotation Y en sens horaire
             x = px*COS(ang)     +py*0 +pz*SIN(ang)
             y = px*0            +py*1 -pz*0
             z = px*(0-SIN(ang)) +py*0 +pz*COS(ang)
      CASE 3: ' matrice de rotation Z en sens horaire
             x = px*COS(ang) -py*SIN(ang) +pz*0
             y = px*SIN(ang) +py*COS(ang) +pz*0
             z = px*0        +py*0        +pz*1
   END_SELECT
   
   x=round_float(x,3)
   y=round_float(y,3)
   z=round_float(z,3)
   
END_SUB

' -------------------------------- ROUND FLOAT ---------------------------------

FNC round_float(round_float_mon_nb,round_float_decimales%)
   
   DIM_LOCAL round_float_tmp%
   
   ' arrondi 'float'
   round_float_tmp%=round_float_mon_nb*POWER(10,round_float_decimales%)
   round_float_mon_nb=round_float_tmp%/(POWER(10,round_float_decimales%))
   RESULT round_float_mon_nb
   
END_FNC

' ------------------------------ 3D POINT POSITION -----------------------------

sub troisD_point_position(N%,x,y,z)

      3D_POSITION 28,x+O3D_X_POSITION(N%),y+O3D_Y_POSITION(N%),z+O3D_Z_POSITION(N%)
      3D_POINT_OBJECT N%,28
      
end_sub

' ---------------------------------- ALEATOIRE ---------------------------------

FNC aleatoire%(aleatoire_mini,aleatoire_maxi)

   RESULT INT(RND((aleatoire_maxi-aleatoire_mini)+0.999999999))+aleatoire_mini
   
END_FNC

' ------------------------------ GESTION DES CLICS -----------------------------

clic:
   
   INACTIVE scene%
   OFF_MOUSE_DOWN scene%
   
   FOR I%=1 TO 13
      OFF_CLICK image%(I%)
   NEXT I%

   clic%=NUMBER_CLICK
   
   IF clic%=image%(1) 
      IF MOUSE_Y_POSITION(image%(1))>25
         rotation_couronne(90,"z",-2) 
      ELSE
         rotation_couronne(-90,"z",-2) 
      END_IF
   END_IF   
   
   IF clic%=image%(2) 
      IF MOUSE_Y_POSITION(image%(2))>25
         rotation_couronne(90,"z",0)
      ELSE
         rotation_couronne(-90,"z",0)
      END_IF
   END_IF
   
   IF clic%=image%(3) 
      IF MOUSE_Y_POSITION(image%(3))>25
         rotation_couronne(90,"z",2)
      ELSE
         rotation_couronne(-90,"z",2)
      END_IF
   END_IF
   
      
   IF clic%=image%(4) 
      IF MOUSE_X_POSITION(image%(4))>25
         rotation_couronne(-90,"x",-2) 
      ELSE
         rotation_couronne(90,"x",-2) 
      END_IF
   END_IF      
      
   IF clic%=image%(5)
      IF MOUSE_X_POSITION(image%(5))>25
         rotation_couronne(-90,"x",0)
      ELSE
         rotation_couronne(90,"x",0)
      END_IF
   END_IF
         
   IF clic%=image%(6)
      IF MOUSE_X_POSITION(image%(6))>25
         rotation_couronne(-90,"x",2)
      ELSE
         rotation_couronne(90,"x",2)  
      END_IF    
   END_IF
   
   
   IF clic%=image%(7)
      IF MOUSE_X_POSITION(image%(7))>25
         rotation_couronne(90,"y",2) 
      ELSE
         rotation_couronne(-90,"y",2)      
      END_IF    
   END_IF
            
   IF clic%=image%(8)
      IF MOUSE_X_POSITION(image%(8))>25
         rotation_couronne(90,"y",0)
      ELSE
         rotation_couronne(-90,"y",0) 
      END_IF    
   END_IF         
         
   IF clic%=image%(9)
      IF MOUSE_X_POSITION(image%(9))>25
         rotation_couronne(90,"y",-2)
      ELSE
         rotation_couronne(-90,"y",-2)   
      END_IF    
   END_IF
   
   
   IF clic%=image%(10) THEN melanger_cube()
   IF clic%=image%(11) THEN reset_cube()
   IF clic%=image%(12) THEN position_cube()
   
   
   IF clic%=image%(13) THEN afficher_infos()
   IF clic%=image%(14) THEN afficher_aide()
   IF clic%=image%(15) THEN quitter_programme()

      
   FOR I%=1 TO 13
      ON_CLICK image%(I%),clic
   NEXT I%
   
   ACTIVE scene%
   ON_MOUSE_DOWN scene%,orienterCube
   
   n%=MOUSE_LEFT_DOWN(scene%)
   n%=MOUSE_LEFT_UP(scene%)
   
RETURN

' ------------------------------ MELANGE DU CUBE -------------------------------

SUB melanger_cube()

   ' mlanger 3 fois
   FOR nombre_de_rotation% = 1 TO 3
      
      Angle_rot% = aleatoire%(1,3) * 90 * SGN(RND(1)-0.5)

      axe_old = axe_new : ' pas 2 fois le mme axe

      REPEAT
         axe_new = aleatoire%(1,3)
      UNTIL axe_new <> axe_old
      
      SELECT axe_new
         CASE 1: axe$="x"
         CASE 2: axe$="y"
         CASE 3: axe$="z"
      END_SELECT
      
      SELECT aleatoire%(1,3)
         CASE 1: face$="-2"
         CASE 2: face$="0"
         CASE 3: face$="2"
      END_SELECT

      rotation_invisible_couronne(Angle_rot%,axe$,face$) : ' rotations invisibles
      
   NEXT nombre_de_rotation%

   affiche_cube(grid_original%)

END_SUB

' ---------------------- REINITIALISER LA POSITION DU CUBE ---------------------                              

SUB position_cube()

   CAM_POSITION -10,6,6
   
   x_positionCamera%=145
   y_positionCamera%=25
   
END_SUB

' ----------------------------- AFFICHAGE DE L'INFO ----------------------------                              
   
SUB afficher_infos()

   DIM_LOCAL t$
   
   t$="                                          Informations sur la ralisation du programme Rubik's cube"+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Ce programme est ralis grace au langage Panoramic basic cr par Jack."+CHR$(13)
   t$=t$+"Ce language inclus des instructions 2D et 3D qui ont permis cette ralisation."+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Pour plus d'informations sur le language Panoramic basic, vous pouvez aller sur le forum  l'adresse suivante :"+CHR$(13)
   t$=t$+"https://panoramic.1fr1.net/"+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Ce programme est une ralisation collaborative :"+CHR$(13)
   t$=t$+"- La base du programme avec le moteur 3D est l'oeuvre de Silverman."+CHR$(13)
   t$=t$+"- Le dplacement du cube dans l'espace par la souris est sign Marc."+CHR$(13)
   t$=t$+"- L'interface utilisateur et les icnes ont t ralises par Minibug."+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Merci  Jack, Minstorm et Papydall qui ont apports leurs contributions."+CHR$(13)
   t$=t$+"Merci aussi  tous les panoramiciens pour l'intrt et le soutien  ce projet."+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"En esprant vous retrouver bientt sur le forum Panoramic !"+CHR$(13)
   
   MESSAGE t$

END_SUB

' ----------------------------- AFFICHAGE DE L'AIDE ----------------------------                              

SUB afficher_aide()

   DIM_LOCAL t$
   
   t$="                                                              Bienvenue dans l'aide du Rubik's cube !"+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Le principe est trs simple. Vous devez reconstituer chaque face d'une mme couleur."+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Pour cela vous avez 9 icnes  votre dispositions pour dplacer les diffrentes couronnes."+CHR$(13)
   t$=t$+"En fonction de la position de votre souris pour pouvez faire tourner la couronne dans un sens ou dans l'autre."+CHR$(13)
   t$=t$+"La couronne est identifie sur l'icne par les couleurs de ces faces."+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Vous avez aussi  votre disposition 6 icnes disposes sur le bas gauche et droit de la fentre de jeu."+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Les 3 icnes  gauche permettent :"+CHR$(13)
   t$=t$+" - De mlanger le cube alatoirement."+CHR$(13)
   t$=t$+" - De remettre Le cube  sa position initiale."+CHR$(13)   
   t$=t$+" - De rinitialiser les 6 faces du cube."+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Les 3 icnes  droite permettent :"+CHR$(13)
   t$=t$+" - De consulter la fentre d'information."+CHR$(13)
   t$=t$+" - De consulter la fentre d'aide."+CHR$(13)
   t$=t$+" - De quitter le jeu. Dans ce cas vous devez confirmer votre choix avant de sortir."+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"Dernire chose : une sauvegarde automatique est installe. Vous pouvez donc quitter le programme"+CHR$(13)
   t$=t$+" n'importe quel moment. Vous retrouverez automatiquement le cube l ou vous l'avez laiss !"+CHR$(13)
   t$=t$+""+CHR$(13)
   t$=t$+"bonne chance et bon jeu !"+CHR$(13)
   
   MESSAGE t$
   
END_SUB

' ----------------------------- SORTIE DU PROGRAMME ---------------------------- 

SUB quitter_programme()

   IF MESSAGE_CONFIRMATION_YES_NO("Voulez vous vraiment quitter le programme ?")=1
      GOSUB quitter
   END_IF
   
END_SUB 

quitter:

   sauvegarder_datas_cube()
   TERMINATE

END_SUB  

' ==============================================================================