' calcul crc-16 pour Modbus RTU
' Marc - mai 2021 - https://panoramic.1fr1.net/

' Entre en hexadcimal ! ! !


dim trame$
caption 0,"Calcul CRC pour modbus RTU."


' chaine hexadcimale test
trame$ = "01 03 EF 12 01 00"


' affichage
trame$ = upper$(trame$)
print trame$
print trame$ + "    " + crc16$(trame$)

end


fnc crc16$(tr$)
    dim_local crc, crc16$, i%, j%, c$, p%, pFort$, pFaible$, t$

    ' suppression des espaces dans la trame reue en paramtre
    for p% = 1 to len(tr$)
        c$ = mid$(tr$,p%,1)
        if c$ <> " "
            t$ = t$ + c$
        end_if
    next p%

    ' vrification de la chaine hexadcimale reue par la fonction
    if mod(len(t$),2) = 0
        for p% = 1 to len(t$)
            c$ = mid$(t$,p%,1)
            if instr("0123456789ABCDEFabcdef",c$) = 0
                message "Le caractre ''" + c$ + "'' n'est pas une valeur hexadcimale !"
                exit_fnc
            end_if
        next p%
    else
        message "Le nombre de charactres, sans compter les espaces, doit tre pair."
        exit_fnc
    end_if

    ' calcul du crc16
    p% = 1
    crc = hex("FFFF")
    for i% = len(t$) to 1 step -2
        c$ = mid$(t$,p%,2)
        crc = bin_xor(crc,hex(c$))
        p% = P% + 2
        for j% = 0 to 7
            if bin_and(crc,hex("0001")) = 1
                crc = bin_xor(int(crc/2),hex("A001"))
            else
                crc = int(crc/2)
            end_if
        next j%
    next i%

    ' inversion des 2 octets (little-endian)
    crc16$ = hex$(crc)

    while len(crc16$) < 4
        crc16$ = "0" + crc16$
    end_while

    pFort$ = left$(crc16$,2)
    pFaible$ = right$(crc16$,2)
    crc16$ = pFaible$ + " " + pFort$

    result crc16$    
end_fnc
