' Convertisseur CP-1252 <--> UTF-8
' Marc - 21 octobre 2020
' http://panoramic.1fr1.net/

dim texteOriginal$, texteTraduit$
dim langage%, sensTranscodage%, bom%
dim reponseUtilisateur%
dim messageUtilisateur$(7)

' langage% = 1 => francais
' langage% = 2 => anglais
' sensTranscodage% = 1 => CP-1252 vers UTF-8
' sensTranscodage% = 2 => UTF-8 vers CP-1252
' bom% = 1 => avec BOM
' bom% = 2 => sans BOM

label redimensionner, langue, francais, english, utf8_cp1252, cp1252_utf8, sensConversion, quitter
label ouvrir, convertir, nouveau, enregistrer
label avecBom, sansBom, choixBom
label legendeTextesSansPoids

creerFenetrePrincipale()

set_focus 0

end
' ----------------------------------------------------------------------
convertir:
    
    set_focus 0
    
    if text$(15) <> ""
        reponseUtilisateur% = message_confirmation_yes_no(messageUtilisateur$(1))
        if reponseUtilisateur% = 0 or reponseUtilisateur% = 2
            return
        end_if
    end_if

    conversion()
    
return
' ----------------------------------------------------------------------
sub conversion()

    text 15, chr$(13)+chr$(10) + "   " + messageUtilisateur$(2)

    inactive 0
    
    if sensTranscodage% = 1
        texteOriginal$ = text$(13)
        texteTraduit$ = Ansi_to_Utf8$(texteOriginal$,bom%)
    else
        texteOriginal$ = text$(13)
        texteTraduit$ = Utf8_To_Ansi$(texteOriginal$)
    end_if

    clear 15

    text 15,texteTraduit$

    legendeTextesAvecPoids()

    active 0

    set_focus 0

end_sub
' ----------------------------------------------------------------------
fnc Format$(nombre$,separateur$)
   dim_local p
   p=len(nombre$)+1
   while p>4
      p=p-3
      nombre$=insert$(nombre$,separateur$,p)
   end_while
   result nombre$
end_fnc
' ----------------------------------------------------------------------
fnc Utf8_To_Ansi$(utf8$)
    dim_local texteAnsi$, index%, bom$, longueurUTF8%, caracterecourant$, caracteresuivant$

    longueurUTF8% = len(utf8$)

    index% = 1

    ' suppression entete BOM (EF BB BF) s'il existe
    bom$ = chr$(239) + chr$(187) + chr$(191)
    if instr(utf8$,bom$) = 1
        index% = index% + 3
    end_if

    while index% <= longueurUTF8%

        caracterecourant$ = mid$(utf8$,index%,1)
        caracteresuivant$ = mid$(utf8$,index%+1,1)

    if asc(caracterecourant$) = 10 or asc(caracterecourant$) = 13  
        if asc(caracterecourant$) = 10 and asc(caracteresuivant$) = 13
            texteAnsi$ = texteAnsi$ + chr$(13) + chr$(10)
            index% = index% + 1
        else
            if asc(caracterecourant$) = 13 and asc(caracteresuivant$) = 10
                texteAnsi$ = texteAnsi$ + chr$(13) + chr$(10)
                index% = index% + 1
            else
                if asc(caracterecourant$) = 10 and asc(caracteresuivant$) = 10
                texteAnsi$ = texteAnsi$ + chr$(13) + chr$(10) + chr$(13) + chr$(10)
                index% = index% + 1
                else
                    if asc(caracterecourant$) = 13 and asc(caracteresuivant$) = 13
                        texteAnsi$ = texteAnsi$ + chr$(13) + chr$(10) + chr$(13) + chr$(10)
                        index% = index% + 1
                    else
                        if asc(caracterecourant$) = 10 and asc(caracteresuivant$) <> 13 and asc(caracteresuivant$) <> 10
                        texteAnsi$ = texteAnsi$ + chr$(13) + chr$(10)
                        else
                            if asc(caracterecourant$) = 13 and asc(caracteresuivant$) <> 13 and asc(caracteresuivant$) <> 10
                                texteAnsi$ = texteAnsi$ + chr$(13) + chr$(10)
                            end_if
                        end_if
                    end_if    
                end_if
            end_if
        end_if
    else
        if asc(caracterecourant$) < 128
            texteAnsi$ = texteAnsi$ + caracterecourant$
        else
            if asc(caractereCourant$) = 226 and asc(caracteresuivant$) = 130 and asc(mid$(utf8$,index%+2,1)) = 172
                texteAnsi$ = texteAnsi$ + chr$(128)
                index% = index% + 2
            else
                if asc(caracterecourant$) = 194
                    index% = index% + 1
                    caracterecourant$ = MID$(utf8$,index%,1)
                    texteAnsi$ = texteAnsi$ + caracterecourant$
                else
                    if asc(caracterecourant$) = 195
                        index% = index% + 1
                        caracterecourant$ = MID$(utf8$,index%,1)
                        texteAnsi$ = texteAnsi$ + chr$(ASC(caracterecourant$) + 64)
                    else
                        texteAnsi$ = texteAnsi$ + caracterecourant$
                    end_if
                end_if    
            end_if              
        end_if
    end_if
        index% = index% + 1
    end_while    
        
    result texteAnsi$

end_fnc
' ----------------------------------------------------------------------
fnc Ansi_to_Utf8$(texteAnsi$,BOM%)
    dim_local texteUtf8$, index%, bom$, longueurAnsi%, caracterecourant$, caracteresuivant$

    longueurAnsi% = len(texteAnsi$)

    index% = 1
    
    if BOM% = 1
        texteUtf8$ = chr$(239) + chr$(187) + chr$(191)
    end_if

    while index% <= longueurAnsi%

        caracterecourant$ = mid$(texteAnsi$,index%,1)
        
        if asc(caracterecourant$) < 128
            texteUtf8$ = texteUtf8$ + caracterecourant$
        else
            if asc(caracterecourant$) = 128 :' encodage caractere EURO
                texteUtf8$ = texteUtf8$ + chr$(226) + chr$(130) + chr$(172)      
            else
                if asc(caracterecourant$) < 192
                    texteUtf8$ = texteUtf8$ + chr$(194) + caracterecourant$
                else
                    texteUtf8$ = texteUtf8$ + chr$(195) + chr$(asc(caracterecourant$) - 64)
                end_if            
            end_if
        end_if
    
    index% = index% + 1

    end_while        

    result texteUtf8$

end_fnc
' ----------------------------------------------------------------------
ouvrir:
    SubOuvrirFichier()
return
' ----------------------------------------------------------------------
sub SubOuvrirFichier()
    dim_local fichier$

    if text$(15) <> ""
        reponseUtilisateur% = message_confirmation_yes_no(messageUtilisateur$(3))
        if reponseUtilisateur% = 0
            exit_sub
        end_if
        if reponseUtilisateur% = 1
             enregistrement()
             exit_sub
        end_if
    end_if

    CLEAR 13
    CLEAR 15

    legendeTextesAvecPoids()

    if object_exists(30) = 0
        open_dialog 30
    end_if

'    DIR_DIALOG 30,
'    FILTER 30,"Fichiers .bas .txt|*.txt;*.bas"
    fichier$ = FILE_name$(30)

    if fichier$ = "_"
        exit_sub
    end_if

    file_load 13,fichier$
END_sub
' ----------------------------------------------------------------------
nouveau:
    if text$(15) <> ""
        reponseUtilisateur% = message_confirmation_yes_no(messageUtilisateur$(4))

        if reponseUtilisateur% = 0
            return
        end_if

        if reponseUtilisateur% = 1
             enregistrement()
        end_if
    end_if

    clear 13
    clear 15

    legendeTextesAvecPoids()

    set_focus 0
return
' ----------------------------------------------------------------------
enregistrer:
    enregistrement()
return
' ----------------------------------------------------------------------
sub enregistrement()
    dim_local a$
    
    if object_exists(31) = 0
        save_dialog 31
    end_if

        if text$(15) = ""
            message messageUtilisateur$(5)
            exit_sub
        end_if
'        FILTER 31,
'        DIR_DIALOG 31,
'        FILE_DIALOG 31,
        a$ = FILE_name$(31)
        if a$ = "_" OR a$ = "" then exit_sub
        if FILE_EXISTS(a$) = 1
            if message_confirmation_yes_no(messageUtilisateur$(6)) <> 1 then exit_sub
        end_if

        file_save 15,a$
    
END_sub
' ----------------------------------------------------------------------
sub creerFenetrePrincipale()
    width 0,1200
    height 0,750
    left 0,(SCREEN_X - width(0))/2
    top 0,(SCREEN_Y - height(0))/2
    color 0,100,150,200
    on_resize 0,Redimensionner

    ' commutateur de gauche
    picture 1
    left 1,45
    top 1,20
    height 1,50
    width 1,20
    color 1,100,150,200
    2d_target_is 1
    2d_PEN_color 255,255,255
    2d_line 8,0,12,0
    2d_line 6,1,14,1
    2d_line 4,2,16,2
    2d_line 3,3,17,3
    2d_rectangle 2,4,18,6
    2d_rectangle 1,6,19,8
    2d_rectangle 0,8,20,42
    2d_rectangle 1,42,19,44
    2d_rectangle 2,44,18,46
    2d_line 3,46,17,46
    2d_line 4,47,16,47
    2d_line 6,48,14,48
    2d_line 8,49,12,49
    2d_pen_color 30,30,30
    2d_fill_color 30,30,30
    2d_circle 10,10,8
    cursor_point 1
    on_click 1,sensConversion

    alpha 2
    left 2,70
    top 2,22
    color 2,100,150,200
    font_color 2,0,0,0
    font_size 2,10
    caption 2,"CP-1252 -> UTF-8"
    cursor_point 2
    on_click 2,cp1252_utf8
    
    alpha 3
    left 3,70
    top 3,52
    color 3,100,150,200
    font_color 3,0,0,0
    font_size 3,10
    caption 3,"UTF-8 -> CP-1252"
    cursor_point 3
    on_click 3,utf8_cp1252

    ' contacteur de droite Fr/En
    picture 4
    top 4,20
    height 4,50
    width 4,20
    color 4,100,150,200
    2d_target_is 4
    2d_PEN_color 255,255,255
    2d_line 8,0,12,0
    2d_line 6,1,14,1
    2d_line 4,2,16,2
    2d_line 3,3,17,3
    2d_rectangle 2,4,18,6
    2d_rectangle 1,6,19,8
    2d_rectangle 0,8,20,42
    2d_rectangle 1,42,19,44
    2d_rectangle 2,44,18,46
    2d_line 3,46,17,46
    2d_line 4,47,16,47
    2d_line 6,48,14,48
    2d_line 8,49,12,49
    2d_pen_color 30,30,30
    2d_fill_color 30,30,30
    2d_circle 10,10,8
    cursor_point 4
    on_click 4, langue

    alpha 5
    top 5,22
    color 5,100,150,200
    font_color 5,0,0,0
    font_size 5,10
    caption 5,"En"
    cursor_point 5
    on_click 5,english
    
    alpha 6
    top 6,52
    color 6,100,150,200
    font_color 6,0,0,0
    font_size 6,10
    caption 6,"Fr"
    cursor_point 6
    on_click 6,francais

    ' commutateur BOM
    picture 7
    top 7,20
    height 7,50
    width 7,20
    color 7,100,150,200
    2d_target_is 7
    2d_PEN_color 255,255,255
    2d_line 8,0,12,0
    2d_line 6,1,14,1
    2d_line 4,2,16,2
    2d_line 3,3,17,3
    2d_rectangle 2,4,18,6
    2d_rectangle 1,6,19,8
    2d_rectangle 0,8,20,42
    2d_rectangle 1,42,19,44
    2d_rectangle 2,44,18,46
    2d_line 3,46,17,46
    2d_line 4,47,16,47
    2d_line 6,48,14,48
    2d_line 8,49,12,49
    2d_pen_color 30,30,30
    2d_fill_color 30,30,30
    2d_circle 10,10,8
    cursor_point 7
    on_click 7,choixBom

    alpha 8
    top 8,22
    color 8,100,150,200
    font_color 8,0,0,0
    font_size 8,10
    cursor_point 8
    on_click 8,sansBom
    
    alpha 9
    top 9,52
    color 9,100,150,200
    font_color 9,0,0,0
    font_size 9,10
    cursor_point 9
    on_click 9, avecBom

    ' lgende memo du haut
    alpha 11
    color 11,100,150,200
    top 11,80
    font_size 11,12
    left 11,30
    font_color 11,255,255,255

    ' memo du haut texte original
    memo 13
    left 13,25
    top 13,105
    bar_both 13
    color 13,20,20,20
    font_color 13,255,255,255
    font_name 13,"Calibri"
    font_size 13,12
    on_change 13,legendeTextesSansPoids

    ' legende memo du bas
    alpha 14
    color 14,100,150,200
    font_size 14,12
    left 14,30
    font_color 14,255,255,255
 
    ' memo du bas texte traduit
    memo 15
    left 15,25
    bar_both 15
    color 15,20,20,20
    font_color 15,255,255,255
    font_name 15,"Calibri"
    font_size 15,12
    on_change 15,legendeTextesSansPoids

    ' bouton Ouvrir
    button 16
    left 16,50
    font_size 16,10
    cursor_point 16
    on_click 16,ouvrir

    ' bouton Nouveau
    button 17
    left 17,125
    font_size 17,10
    cursor_point 17
    on_click 17,nouveau
 
    ' bouton Convertir
    button 18
    left 18,200
    font_size 18,10
    cursor_point 18
    on_click 18,convertir

    ' bouton Enregistrer
    button 19
    left 19,275
    font_size 19,10
    cursor_point 19
    on_click 19,enregistrer

    alpha 20
    font_color 20,255,255,255
    font_size 20,10
    caption 20,"Marc - http://panoramic.1fr1.net"
    
    ' titre 1/2
    alpha 21
    color 21,100,150,200
    font_color 21,255,255,255

    ' titre 2/2
    alpha 22
    color 22,100,150,200
    font_color 22,255,255,255

    on_close 0,quitter

    sensTranscodage% = 1 :' CP-1252 vers UTF8 par defaut

    langage% = 1 :' Francais par defaut

    subLangue()

    actualiserAffichage()
  
END_sub
' ----------------------------------------------------------------------
avecBom:
    bom% = 1
    actualiserAffichage()
    
    if text$(15) <> ""
        conversion()
    end_if
    
return
' ----------------------------------------------------------------------
sansBom:
    bom% = 2
    actualiserAffichage()
    
    if text$(15) <> ""
        conversion()
    end_if

return
' ----------------------------------------------------------------------
choixBom:
    if bom% = 1
        bom% = 2
    else
        bom% = 1
    end_if
    actualiserAffichage()
    
    if text$(15) <> ""
        conversion()
    end_if
          
return
' ----------------------------------------------------------------------
utf8_cp1252:

    if text$(15) <> ""
        reponseUtilisateur% = message_confirmation_yes_no(messageUtilisateur$(4))
        if reponseUtilisateur% = 0
            return
        end_if

        if reponseUtilisateur% = 1
             enregistrement()
        end_if
    end_if

    text 15,""

    set_focus 0

    sensTranscodage% = 2
    actualiserAffichage()
return
' ----------------------------------------------------------------------
cp1252_utf8:

    if text$(15) <> ""
        reponseUtilisateur% = message_confirmation_yes_no(messageUtilisateur$(4))
        if reponseUtilisateur% = 0
            return
        end_if

        if reponseUtilisateur% = 1
             enregistrement()
        end_if
    end_if

    text 15,""

    set_focus 0

    sensTranscodage% = 1
    actualiserAffichage()
return
' ----------------------------------------------------------------------
sensConversion:

    if text$(15) <> ""
        reponseUtilisateur% = message_confirmation_yes_no(messageUtilisateur$(4))
        if reponseUtilisateur% = 0
            return
        end_if

        if reponseUtilisateur% = 1
             enregistrement()
        end_if
    end_if

    text 15,""

    set_focus 0

    if sensTranscodage% = 1
        sensTranscodage% = 2
    else    
        sensTranscodage% = 1
    end_if
    actualiserAffichage()    
return
' ----------------------------------------------------------------------
francais:
    langage% = 1
    subLangue()
return
' ----------------------------------------------------------------------
english:
    langage% = 2
    subLangue()
return
' ----------------------------------------------------------------------
langue:

    if langage% = 1
        langage% = 2
        subLangue()
    else
        langage% = 1
        subLangue()
    end_if
        
return
' ----------------------------------------------------------------------
sub subLangue()
    
    if langage% = 1 :' francais
        caption 9,"Avec BOM"
        caption 8,"Sans BOM"
        caption 16,"Ouvrir"
        caption 17,"Nouveau"
        caption 18,"Convertir"
        caption 19,"Enregistrer"

      
        application_title "Convertisseur CP1252 <-> UTF-8"
        caption 0,"Convertisseur CP1252 <-> UTF-8"
        
        2d_target_is 4
        2d_pen_color 30,30,30
        2d_fill_color 30,30,30
        2d_circle 10,40,8
        2d_pen_color 255,255,255
        2d_fill_color 255,255,255
        2d_circle 10,10,8

        messageUtilisateur$(1) = "Souhaitez-vous recommencer la conversion du fichier ?"
        messageUtilisateur$(2) = "Patientez SVP, traitement en cours..."
        messageUtilisateur$(3) = "Souhaitez-vous enregistrer le projet en cours avant d'en ouvrir un nouveau ?"
        messageUtilisateur$(4) = "Souhaitez-vous enregistrer le projet en cours ?"
        messageUtilisateur$(5) = "Enregistrement impossible : Votre projet est vide !"
        messageUtilisateur$(6) = "Le fichier existe. Le remplacer ?"
        messageUtilisateur$(7) = "Souhaitez-vous enregistrer le projet en cours avant de quitter ?"

    else
        caption 9,"With BOM"
        caption 8,"Without BOM"
        caption 16,"Load"
        caption 17,"New"
        caption 18,"Convert"
        caption 19,"Save"

        APPLICATION_TITLE "CP1252 <-> UTF-8 Converter"
        caption 0,"CP1252 <-> UTF-8 Converter"

        2d_target_is 4
        2d_pen_color 30,30,30
        2d_fill_color 30,30,30
        2d_circle 10,10,8
        2d_pen_color 255,255,255
        2d_fill_color 255,255,255
        2d_circle 10,40,8

        messageUtilisateur$(1) = "Do you want to start converting the file again?"
        messageUtilisateur$(2) = "Please wait, processing in progress ..."
        messageUtilisateur$(3) = "Do you want to save the current project before opening a new one?"
        messageUtilisateur$(4) = "Do you want to save the current project?"
        messageUtilisateur$(5) = "Cannot save: Your project is empty!"
        messageUtilisateur$(6) = "The file exists. Replace it ?"
        messageUtilisateur$(7) = "Would you like to save the current project before exiting?"

    end_if

    legendeTextesAvecPoids()
    actualiserAffichage()

end_sub
' ----------------------------------------------------------------------
sub legendeTextesAvecPoids()

    if langage% = 1 :' francais
        if len(text$(13)) < 2
            caption 11,"Texte original : " + str$(len(text$(13))) + " octet"
        else
            caption 11,"Texte original : " + str$(len(text$(13))) + " octets"
        end_if    

        if len(text$(15)) < 2
            caption 14,"Aperu texte converti : " + str$(len(text$(15)))+" octet"
        else    
            caption 14,"Aperu texte converti : " + str$(len(text$(15)))+" octets"
        end_if    
    else
        if len(text$(13)) < 2
            caption 11,"Original text: " + str$(len(text$(13))) + " byte"
        else
            caption 11,"Original text: " + str$(len(text$(13))) + " bytes"
        end_if    

        if len(text$(15)) < 2
            caption 14,"Preview converted text: " + str$(len(text$(15)))+" byte"
        else    
            caption 14,"Preview converted text: " + str$(len(text$(15)))+" bytes"
        end_if    
    end_if

end_sub
' ----------------------------------------------------------------------
legendeTextesSansPoids:

    if langage% = 1 :' francais
        caption 11,"Texte original : "
        caption 14,"Aperu texte converti : "
    else
        caption 11,"Original text: "
        caption 14,"Preview converted text: "
     end_if

return
' ----------------------------------------------------------------------
Redimensionner:
    actualiserAffichage()
return
' ----------------------------------------------------------------------
sub actualiserAffichage()
    dim_local titre1$, titre2$
    
    off_resize 0

    if sensTranscodage% = 1

        show 7
        show 8
        show 9

        2d_target_is 1
        2d_pen_color 30,30,30
        2d_fill_color 30,30,30
        2d_circle 10,10,8
        2d_pen_color 255,255,255
        2d_fill_color 255,255,255
        2d_circle 10,40,8

        if langage% = 1
            titre1$ = "Conversion"
            titre2$ = "CP-1252 vers UTF-8"
            left 8,width_client(0) - 188
        else
            titre1$ = "CP-1252 to UTF-8"
            titre2$ = "Conversion"
           left 8,width_client(0) - 206
        end_if

    else

        hide 7
        hide 8
        hide 9

        2d_target_is 1
        2d_pen_color 30,30,30
        2d_fill_color 30,30,30
        2d_circle 10,40,8
        2d_pen_color 255,255,255
        2d_fill_color 255,255,255
        2d_circle 10,10,8

        if langage% = 1
            titre1$ = "Conversion"
            titre2$ = "UTF-8 vers CP-1252"
        else
            titre1$ = "UTF-8 to CP-1252"
            titre2$ = "Conversion"
        end_if    

    end_if
    
    if bom% = 1
        2d_target_is 7
        2d_pen_color 30,30,30
        2d_fill_color 30,30,30
        2d_circle 10,40,8
        2d_pen_color 255,255,255
        2d_fill_color 255,255,255
        2d_circle 10,10,8
    else
        2d_target_is 7
        2d_pen_color 30,30,30
        2d_fill_color 30,30,30
        2d_circle 10,10,8
        2d_pen_color 255,255,255
        2d_fill_color 255,255,255
        2d_circle 10,40,8
    end_if
    
    if width(0) < 680
        width 0,680
    end_if

    if height(0) < 400
        height 0,400
    end_if
    
    if width_client(0) < 1080
        font_size 21,20
        top 21,16
        left 21,(width_client(0) - text_width(titre1$,21))/2
        caption 21,titre1$
        
        show 22
        font_size 22,20
        top 22,55
        left 22,(width_client(0) - text_width(titre2$,22))/2
        caption 22,titre2$
    else
        hide 22
        font_size 21,30
        top 21,24
        left 21,(width_client(0) - text_width(titre1$ + " " + titre2$,21))/2
        caption 21,titre1$ + " " + titre2$
    end_if

    width 13,width_client(0)-50
    width 15,width_client(0)-50

    left 20,width_client(0) - text_width("Marc - http://panoramic.1fr1.net",20) - 10
    top 20,height_client(0)-20

    left 4,width_client(0) - 65
    left 5,width_client(0) - 83
    left 6,width_client(0) - 83
    left 7,width_client(0) - 125
    left 9,width_client(0) - 188

    top 16,height_client(0)-50
    top 17,height_client(0)-50
    top 18,height_client(0)-50
    top 19,height_client(0)-50


    height 13,(height_client(0)-225)/2
    height 15,(height_client(0)-225)/2
    top 15,height(13)+150

    top 14,105 + height(13) + 20


    on_resize 0,Redimensionner
end_sub
' ----------------------------------------------------------------------
quitter:
    CLOSE_INACTIVE
    if text$(15) <> ""
        reponseUtilisateur% = message_confirmation_yes_no(messageUtilisateur$(7))
        if reponseUtilisateur% = 0
            return
        end_if
        if reponseUtilisateur% = 1
            enregistrement()
            terminate
        end_if
    end_if
    CLOSE_ACTIVE
return