' Trac de rectangles  coins arrondis
' Marc - Octobre 2022
' Ecrit en langage Panoramic 0.9.29.i9
' ------------------------------------------------------------------------------

' La  syntaxe : rectangle_arrondi(X1,Y1,X2,Y2,R).
' Dessine un rectangle entre deux coordonnes X1,Y1 et X2,Y2.
' Les coordonnes de dpart et d'arrives sont incluses dans le trac.
' R est le rayon en pixels des angles arrondis.  

rectangle_arrondi(5,7,45,80,9)
end
' ------------------------------------------------------------------------------
sub rectangle_arrondi(xr1%,yr1%,xr2%,yr2%,rayon%)
    dim_local x%, y%, m%, cx%, cy%, x1%, y1%, x2%, y2%

    ' traitement des coordonnes si elles sont inverses
    if xr1% < xr2%
        x1% = xr1% : x2% = xr2%
    else
        x1% = xr2% : x2% = xr1%
    end_if
    
    if yr1% < yr2%
        y1% = yr1% : y2% = yr2%
    else
        y1% = yr2% : y2% = yr1%
    end_if
        
    ' tracer le trait du haut
    2d_line x1%+rayon%, y1%, x2%-rayon%, y1%
    ' tracer le trait du bas
    2d_line x1%+rayon%, y2%, x2%-rayon%, y2%
    ' tracer le trait de gauche
    2d_line x1%, y1%+rayon%, x1%, y2%-rayon%
    ' traver le trait de droite
    2d_line x2%, y1%+rayon%, x2%, y2%-rayon%
    
    ' dessiner l'angle suprieur gauche
    cx% = x1%+rayon% : cy% = y1%+rayon%
    x% = 0 : y% = rayon% : m% = 5 - 4*rayon%      
    while x% <= y%
        2d_point x%*(-1)+cx%,y%*(-1)+cy% : 2d_point y%*(-1)+cx%,x%*(-1)+cy%
        if m% > 0 then y% = y% - 1 : m% = m% - 8*y%
        x% = x% + 1 : m% = m% + 8*x% + 4
    end_while

    ' dessiner l'angle suprieur droit
    cx% = x2%-rayon% : cy% = y1%+rayon%
    x% = 0 : y% = rayon% : m% = 5 - 4*rayon%      
    while x% <= y%
        2d_point x%+cx%,y%*(-1)+cy% : 2d_point y%+cx%,x%*(-1)+cy%
        if m% > 0 then y% = y% - 1 : m% = m% - 8*y%
        x% = x% + 1 : m% = m% + 8*x% + 4
    end_while

    ' dessiner l'angle infrieur droit
    cx% = x2%-rayon% : cy% = y2%-rayon%
    x% = 0 : y% = rayon% : m% = 5 - 4*rayon%      
    while x% <= y%
        2d_point x%+cx%,y%+cy% : 2d_point y%+cx%,x%+cy%
        if m% > 0 then y% = y% - 1 : m% = m% - 8*y%
        x% = x% + 1 : m% = m% + 8*x% + 4
    end_while

    ' dessiner l'angle infrieur gauche
    cx% = x1%+rayon% : cy% = y2%-rayon%
    x% = 0 : y% = rayon% : m% = 5 - 4*rayon%      
    while x% <= y%
        2d_point x%*(-1)+cx%,y%+cy%
        2d_point y%*(-1)+cx%,x%+cy%
        if m% > 0 then y% = y% - 1 : m% = m% - 8*y%
        x% = x% + 1 : m% = m% + 8*x% + 4
    end_while
end_sub