
rem ============================================================================
rem       Trac darc de cercle par lalorithme de Bresenham
rem        Le trac se fait par octant (c--d 1/8 de cercle)
rem     Les numros des octants suivent le sens trigonomtrique
rem ============================================================================
dim i
' trac des axes
2d_pen_color 255,0,0 : 2d_line 20,200,500,200 : 2d_line 250,20,250,400
2d_pen_color 0,0,255
for i = 1 to 8
    caption 0,"Octant : " + str$(i)  
    Tracer_Octant(250,200,100,i) : pause 1000 : ' La pause pour observer le trac
next i
caption 0,"Et maintenant les 8 octants d'un trait formant un cercle complet"
2d_pen_color 255,0,255 : 2d_fill_off
for i = 1 to 8
    Tracer_Octant(250,200,90,i)
next i
end

rem ============================================================================
' Tracer un arc de cercle : un huitime de cercle
' x_centre,y_centre : coordonnes du centre du cercle
' rayon : rayon du cercle
' octant : numro de l'octant de 1  8 dans le sens trigonomtrique
' octant = 1 : angle compris entre 0      et pi/4   rad soit entre 0   et 45
' octant = 2 : angle compris entre pi/4   et pi/2   rad soit entre 45  et 90
' octant = 3 : angle compris entre pi/2   et 3*pi/4 rad soit entre 90  et 135
' octant = 4 : angle compris entre 3*pi/4 et pi     rad soit entre 135 et 180
' octant = 5 : angle compris entre pi     et 5*pi/4 rad soit entre 180 et 225
' octant = 6 : angle compris entre 5*pi/4 et 3*pi/2 rad soit entre 225 et 270
' octant = 7 : angle compris entre 3*pi/2 et 7*pi/4 rad soit entre 270 et 315
' octant = 8 : angle compris entre 7*pi/4 et 2*pi   rad soit entre 315 et 360

SUB Tracer_Octant(x_centre,y_centre,rayon,octant)
    dim_local x, y, m, xp, yp
    x = 0 : y = rayon : m = 5 - 4*rayon
    while x <= y
       select octant
          case 1 : xp = x_centre + y : yp = y_centre - x
          case 2 : xp = x_centre + x : yp = y_centre - y
          case 3 : xp = x_centre - x : yp = y_centre - y
          case 4 : xp = x_centre - y : yp = y_centre - x
          case 5 : xp = x_centre - y : yp = y_centre + x
          case 6 : xp = x_centre - x : yp = y_centre + y
          case 7 : xp = x_centre + x : yp = y_centre + y
          case 8 : xp = x_centre + y : yp = y_centre + x
       end_select
       2d_point xp,yp
       if  m > 0 then y = y - 1 : m = m - 8 * y
       x = x + 1 : m = m + 8 * x + 4
    end_while
    
END_SUB
rem ============================================================================