
rem ============================================================================
rem               Lnigme du flocon de Von Koch
rem                 Papydall le 29 / 04 / 2020
rem ============================================================================
label choix
dim x(4*65536),y(4*65536)
dim sin60,cos60, maxx,generation,puissance4
dim l, longueur, aire

GUI()
Init()
Afficher_Poeme()
Debut()

end
rem ============================================================================
SUB GUI()
    width 0,1000 : height 0,800
    picture 10 : width 10,550 : height 10,650 : top 10,20 : left 10,20 : 2d_target_is 10
    font_bold 10 : font_size 10,14 : 2d_fill_color 200,100,20 : print_target_is 10
    font_size 10,10 : 2d_fill_color 255,255,255 : 2d_pen_width 2 : 2d_pen_color 255,0,0
    button 20 : top 20,700 : left 20,050 : caption 20,"&Prcdent" : on_click 20,choix
    button 30 : top 30,700 : left 30,225 : caption 30,"&Suivant"   : on_click 30,choix
    button 40 : top 40,700 : left 40,400 : caption 40,"&Quitter"   : on_click 40,choix
    alpha 99 : top 99,50 : left 99,650 : font_bold 99 : font_size 99,12
    font_color 99,20,100,200
    caption 0,"Flocon de Von Koch."    
END_SUB
rem ============================================================================
SUB Init()        
    L = 400       : ' longueur en pixels du ct du triangle initial
    longueur = 3  : ' primtre du triangle de dpart de ct 1
    maxx = width_client(10)
    sin60 = sqr(3)/2       : ' sin(60) pour les dplacements
    cos60 = 0.5            : ' cos(60)
    x(0) = (maxx-L) / 2    : '  1er point
    y(0) = (maxx-4*L*Sin60/3) / 2+L*Sin60
    x(1) = x(0)+L*Cos60    : '  2eme point
    y(1) = y(0)-L*Sin60
    x(2) = x(0)+L          : '  3eme point
    y(2) = y(0)
    x(3) = x(0)
    y(3) = y(0)
    generation  = 1  : puissance4 = 1
END_SUB
rem ============================================================================
SUB Afficher_Poeme()
    dim_local a$,t$  
    read a$
    while a$ <> "FIN"
       t$ = t$ + a$ + chr$(13)
       read a$
    end_while
    caption 99,t$
END_SUB
rem ============================================================================
Choix:
    select number_click
        case 20 : Precedent()
        case 30 : Suivant()
        case 40 : Quitter()
    end_select
return
rem ============================================================================
SUB Debut()
    cls
    Dessiner(1)
END_SUB
rem ============================================================================
SUB Generer(generation)
    dim_local i,j,dx,dy
    for j = puissance4 * 3 to 1 step -1 : ' On dcale les points pour intercaler les 3 nouveaux points  
        x(j*4) = x(j) : y(j*4) = y(j)
    next j
    for j = 0 to puissance4 * 3 - 1     : ' On intercale les 3 nouveaux points
        i = 4*j
        dx = (x(i+4)-x(i))/3 : dy = (y(i+4)-y(i))/3 : ' on coupe en 3
        x(i+1) = x(i)+dx : y(i+1) = y(i)+dy         : ' on part du 1/3 et on termine aux 2/3
        x(i+2) = x(i+1)+cos60*dx+sin60*dy           : ' on obtient le nouveau point,
        y(i+2) = y(i+1)-sin60*dx+cos60*dy           : ' sommet du triangle quiltral
        x(i+3) = x(i)+2*dx : y(i+3) = y(i)+2*dy    
    next j
END_SUB
rem ============================================================================
SUB Dessiner(generation)
    dim_local i
    cls
    2d_poly_from x(0),y(0)   : ' on se positionne sur le 1er point
    for i = 1 to 3*puissance4
        2d_poly_to x(i),y(i) : ' on trace de point en point
    next i
    Afficher()
END_SUB
rem ============================================================================
SUB Afficher()
    dim_local s$
    2d_fill_color 200,100,20
    2d_rectangle 10,518,maxx-2,640
    2d_fill_off
    print_locate 150,10 : print "Flocon de Von Koch par Papydall."
    print_locate 020,520 : print "Gnration : " + str$(generation-1) + "     "
    s$ = "Nombre de cts : " + str$(3*puissance4) + "     "
    print_locate 300,520 : print s$
    longueur = 3*power(4/3,generation-1)  
    print_locate 020,540 : print "Primtre = " + str$(longueur)
    aire = 2*sqr(3)/5 - (3*sqr(3)/20) * power(4/9,generation-1)
    print_locate 300,540 : print "Aire = " + str$(aire)
    print_locate 020,560 : print "Le primtre tend vers l'infini lorsque le nombre de gnrations tend vers l'infini."
    print_locate 020,580 : print "L'aire du flocon est finie et tend vers les 8/5 de l'aire du triangle de dpart."
    print_locate 020,600 : print "Pour un triangle initial de ct 1, l'aire du flocon tend vers "+ str$(2*sqr(3)/5)
    print_locate 100,620 : print "La Dimension fractale est : " + str$(log(4)/log(3))
END_SUB
rem ============================================================================
SUB Suivant()
    if puissance4 >= 1024 : ' on se limite  la gnration 5; au-dela les calculs...
       message "On se limite  la gnration 5 !"
       inactive 30
       exit_sub       : ' ... deviennent chronophages et il n'y a plus de ...
    end_if            : ' ... diffrences sensibles entre une courbe et la suivante
    inactive 20 : inactive 30 : ' pour calmer Mr Bourrin
    puissance4 = puissance4 * 4
    generation = generation + 1
    Generer(generation)
    Dessiner(generation)
    active 20 : active 30     : ' Mr Bourrin peut se dfouler
END_SUB
rem ============================================================================
SUB Precedent()
    dim_local j
    if puissance4 = 1
       message "Il n'y a pas de prcdent pour la gnration 0 !!!"
       inactive 20
       exit_sub
    end_if
    cls
    inactive 20 : inactive 30 : ' pour calmer Mr. Bourrin
    FOR j = 1 TO puissance4*3 : ' On dcale les points pour suppimer les 3 nouveaux points
        x(j) = x(j*4)
        y(j) = y(j*4)
    next j
    puissance4 = puissance4 / 4
    generation = generation - 1
    Dessiner(generation)
    active 20 : active 30  
END_SUB
rem ============================================================================
SUB Quitter()
    if message_confirmation_yes_no("Vous voulez vraiment quitter ?") = 1
       terminate
    end_if
END_SUB
rem ============================================================================
data "       E N I G M E"
data ""
data "Au jardin des mathmatiques,"
data "Un triangle aspirait  l'infini."
data "Ses cts trop isomtriques"
data "Entravaient ses rves inassouvis"
data "Et l'agaaient de leur musique :"
data "Ton primtre, il est fini ... fini."
data ""
data "Un jour, un ange bucolique"
data "Lui greffa, bien au centre des cts"
data "Deux tiers de segments en oblique."
data "Cet ange tait excellent jardinier"
data "Et bientt, surgeons identiques,"
data "Trois bbs trigones bourgeonnaient."
data ""
data "Voyant qu'ainsi le primtre"
data "S'agrandissant en belle proportion,"
data "Il suivit son art de gomtre,"
data "Sautant de division en division."
data "Cela fit une belle toile"
data "Et tous les triangles  l'unisson,"
data "Se festonnrent de fractales"
data "Qui rivalisaient en perfection."
data ""
data "Auteur inconnu"
data "FIN"
rem ============================================================================