rem ============================================================================
rem                            3D 
rem ============================================================================
rem ------------------------ Cubemap -------------------------------------------
rem Un cubemap est une texture qui contient 6 textures 2D individuelles qui 
rem forment chacune un ct dun cube : un cube textur.
rem Les 6 textures :
rem droite : X positif : right
rem gauche : X ngatif : left
rem haut   : Y positif : top
rem bas    : Y ngatif : bottom
rem arrire: Z positif : back
rem face   : Z ngatif : front
rem ============================================================================
rem ------------------------ Skybox --------------------------------------------
rem Une skybox est un (grand) cube qui englobe toute la scne et contient 6 images
rem dun environnement donnant lillusion que lenvironnement est en fait beaucoup
rem plus grand quil ne lest en ralit.
rem ============================================================================
rem La Skybox est gnralement un cube textur avec un dcor de ciel.
rem Cette boite aura des largeur, longueur et hauteur identiques.
rem Toutes les faces du cube seront diriges vers lintrieur.
rem Chacune des faces du cube correspondra aux vues du Nord, Sud, Est, Ouest de
rem la camra ainsi que le Haut et le Bas.
rem ============================================================================
rem La texture qui sera applique sur chacune delles correspondra  ce que lon
rem pourrait voir  une distance infinie, lhorizon.
rem Le cube sera positionn de part et dautre de la camra dans toutes les directions.
rem La boite aura donc une position fixe, quelle que soit la position de la camra.
rem Dun point de vue de lorientation, et contrairement  sa position, la boite
rem sera aligne sur les trois axes X, Y et Z du monde.
rem Lorientation sera, videmment, indpendante de la direction de la camra.
rem ============================================================================
rem Nous placerons, par exemple, 
rem les faces Est et Ouest sur laxe X,
rem Haut et Bas sur laxe Y et 
rem Nord et Sud sur laxe Z.
rem Ainsi, pour un cube de taille T, les faces opposes seront sur les positions
rem -T/2 et +T/2 sur laxe dalignement.
rem ============================================================================
rem Maintenant on doit mettre une texture  notre skybox.
rem Cette texture peut se reprsenter comme un cube compos de six faces.
rem Chacune des faces correspond  une direction par rapport au centre du cube 
rem soit les faces :
rem X positif, X ngatif,
rem Y positif, Y ngatif,
rem Z positif, Z ngatif.

rem ============================================================================
rem Il y a suffisamment de ressources en ligne o vous pouvez trouvez des skybox.
rem Ces images skybox ont gnralement le model suivant :
rem ------------------- Model cubemape skybox ----------------------------------
rem ============================================================================
rem                  __________
rem                 |          |
rem                 |          |
rem                 |   haut   |
rem                 |          |
rem       __________|__________|____________________
rem      |          |          |          |         |
rem      |          |          |          |         |
rem      |  gauche  |   face   |  droite  | arrire |
rem      |          |          |          |         |
rem      |__________|__________|__________|_________|
rem                 |          |
rem                 |          |
rem                 |    bas   |
rem                 |          |
rem                 |__________|
rem ============================================================================
rem Si vous pliez ces 6 cts dans un cube, vous obtiendrez le cube entirement
rem textur qui simule un grand paysage.
rem Certaines ressources fournissent la skybox dans un format comme celui-ci, 
rem auquel cas vous devrez extraire manuellement les 6 images, mais dans la 
rem plupart des cas, elles sont fournies sous forme de 6 images  texture unique.
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
dim bh,rot,vd,vrot
label move
' dir_change "D:\Langages\Panoramic\Test_Skybox\Skansen3\" : ' adapter le chemin

Init()
Scene()
Explore()

end
rem ============================================================================
SUB Init()
    dim_local t$
    caption 0 ,"Utilisez les flches de direction pour explorer le paysage ..."
    width 0,screen_x : height 0,screen_y 
    t$ = "Patientez, chargement en cours..."
    font_size 0,30 : font_bold 0 : font_color 0,255,0,0
    print_locate screen_x/2-text_width(t$,0)/2,screen_y/2-3*text_height(t$,0)/2
    print t$
    
END_SUB
rem ============================================================================
SUB Scene()
    scene3d 1 : full_space 1 : hide 1 : cursor_hide 1
    3d_skybox 1     
    3d_load_texture_top 1,"posy.jpg"        : ' y+
    3d_load_texture_left 1,"negx.jpg"      : ' x-
    3d_load_texture_back 1,"negz.jpg"      : ' z-
    3d_load_texture_front 1,"posz.jpg"    : ' z+
    3d_load_texture_right 1,"posx.jpg"    : ' x+
    3d_load_texture_bottom 1,"negy.jpg"  : ' y-
    
END_SUB
rem ============================================================================
SUB Explore()
    3d_cube 10,1 : 3d_mesh 20 : vrot = 1 : vd = .5
    3d_hide 10   : 3d_move 10,-20 
    show 1
    timer 30 : timer_interval 30,1 : on_timer 30,move
END_SUB
rem ============================================================================
move: 
   select scancode
      case 27 : terminate  
      case 37 : rot = rot + vrot : 3d_y_rotate 10,rot
      case 39 : rot = rot - vrot : 3d_y_rotate 10,rot
      case 38 : bh  = bh  - .025 : if bh < -11 then bh = -11
      case 40 : bh  = bh  + .025 : if bh >  11 then bh = 11
   end_select

   3d_position 20,o3d_x_position(10),o3d_y_position(10),o3d_z_position(10)
   3d_rotate 20,o3d_x_rotate(10),o3d_y_rotate(10),o3d_z_rotate(10)
   3d_move 20,1
   cam_position o3d_x_position(10),sin(bh/6.28)+16.5,o3d_z_position(10)
   point_position o3d_x_position(20),16.5,o3d_z_position(20)

return
rem ============================================================================



