
rem ============================================================================
rem             Algorithme de trac de cercle dAndres
rem Ref :
rem https://fr.wikipedia.org/wiki/Algorithme_de_trac%C3%A9_de_cercle_d%27Andres
rem ============================================================================
dim xc,yc,r
xc = 250 : yc = 200 : r = 100
' Trac des axes
2d_pen_color 255,0,0 : 2d_line 20,yc,500,yc : 2d_line xc,20,xc,400
' Trac de l'octant N 7  (r = 100)
2d_pen_color 0,0,255 : Octant(xc,yc,r) : pause 1000
' Trac du cercle complet
2d_pen_color 0,0,0 : Cercle(xc,yc,r+50) : ' r = 150
end
rem ============================================================================
' Trac de l'octant N 7
SUB Octant(xc,yc,r)
    dim_local x,y,d
    x = 0 : y = r : d = r-1
    while y >= x
        2d_point xc+x,yc+y      
        if d >= 2*x
           d = d-2*x-1 : x = x+1
        else
           if d < 2*(r-y)
              d = d+2*y-1 : y = y-1
           else
              d = d+2*(y-x-1) : y = y-1 : x = x+1
           end_if
        end_if
    end_while
END_SUB
rem ============================================================================
' Trac du cercle complet par octants
SUB Cercle(xc,yc,r)
    dim_local x,y,d
    x = 0 : y = r : d = r-1
    while y >= x
        2d_point xc + y , yc - x   : ' Octant N 1
        2d_point xc + x , yc - y   : ' Octant N 2
        2d_point xc - x , yc - y   : ' Octant N 3
        2d_point xc - y , yc - x   : ' Octant N 4
        2d_point xc - y , yc + x   : ' Octant N 5
        2d_point xc - x , yc + y   : ' Octant N 6
        2d_point xc + x , yc + y   : ' Octant N 7
        2d_point xc + y , yc + x   : ' Octant N 8
        
        if d >= 2*x
           d = d-2*x-1 : x = x+1
        else
           if d < 2*(r-y)
              d = d+2*y-1 : y = y-1
           else
              d = d+2*(y-x-1) : y = y-1 : x = x+1
           end_if
        end_if        
    end_while
END_SUB
rem ============================================================================
