
rem ============================================================================
' Panoramic V 0.9.27i3
rem ============================================================================
rem      Trac des polygones vides ou pleins
rem ============================================================================
 Polygone(120,200,100,8,0,0)           : ' octogone (8 cts) vide
 Polygone(120,200,50,8,0,1,255,255,0)  : ' octogone (8 cts) rempli
 Polygone(300,200,50,6,0,1,100,150,20) : ' hexagone (6 cts) rempli
 Polygone(470,200,100,10,0,1,255,0,0)  : ' dcagone (10 cts) rempli
 Polygone(470,200,50,4,0,1,0,255,255)  : ' carr (4 cts) rempli
 
rem ============================================================================

Polygone(120,400,20,3,180,1,255,0,255) : ' triangle dont le centre est 120,400
                                         ' tourn de 180 pour avoir sa pointe
                                         ' dirige vers la gauche
Polygone(200,400,20,3,90,1,255,0,255)  : ' triangle dont le centre est 200,400
                                         ' tourn de 90 pour avoir sa pointe
                                         ' dirige vers le bas
Polygone(280,400,20,3,-90,1,255,0,255) : ' triangle dont le centre est 280,400
                                         ' tourn de -90 pour avoir sa pointe
                                         ' dirige vers le haut
Polygone(360,400,20,3,0,1,255,0,255)   : ' triangle dont le centre est 360,400
                                         ' tourn de 0 pour avoir sa pointe
                                         ' dirige vers le bas
rem ============================================================================

end
rem ============================================================================
' Trac d'un polygone
' xcentre, ycentre : coordonnes du centre du polygone
' rayon : rayon du cercle circonscrint au polygone
' nb_cotes : nombre des cts du polygones
' angle_debut : angle de depart du trac en degrs : a permet de faire tourner la figure
' plein : flag indiquant si le polygone doit tre plein ou vide
' plein = 1 (ou toute autre valeur positive) <--- le polygone est plein avec la couleur r,g,b
' plein = 0 <--- le polygone sera vide : dans ce cas, on peut omettre les paramtre r,g,b
rem ============================================================================
SUB Polygone(xcentre,ycentre,rayon,nb_cotes,angle_debut,plein,r,g,b)
    dim_local xp,yp,i
    degrees
    xp = rayon * Cos(angle_debut) + xcentre
    yp = rayon * Sin(angle_debut) + ycentre
    2d_poly_from xp,yp
    for i = 1 to nb_cotes
        xp = xcentre + rayon * Cos(angle_debut + 360 * i / nb_cotes)
        yp = ycentre + rayon * sin(angle_debut + 360 * i / nb_cotes)
        2D_poly_to xp,yp
    next i
    if plein > 0 then 2d_flood xcentre,ycentre,r,g,b
END_SUB
rem ============================================================================