
rem ============================================================================
REM       Art-ithmtique pour vous faire aimer les maths
REM       Les faces caches des tables de multiplication
rem                 Par Papydall
rem     Ref : https://www.youtube.com/watch?v=-X49VQgi86E
REM ============================================================================
' Reprsentation graphique des tables de multiplications :
' Soit un cercle de centre O et de rayon R.
' Sur ce cercle plaons un certain nombre de points quitablement repartis.
' Par exemple 10 points numrots de 0  9 (0 en haut du cercle, puis en
' tournant dans le sens des aiguilles d'une montre,les nombres 1,2,3,jusqu  9.
' Si on veut continuer cette numrotation au-del de 9,le 10 se trouverait au
' mme endroit que le 0, le 11 au mme endroit que le 1, le 12 au mme endroit
' que le 2 et ainsi de suite.
' Cette faon de reprsenter les nombres de faon cyclique reprsente ce qu'on
' appelle l'arithmtique modulaire. C'est--dire une arithmtique dans laquelle
' les nombres tournent en rond.
' Dans cet exemple on a 10 points et les nombres tournent avec un cycle de 10.
' On dit que l'on a reprsent les nombres modulo 10.
' Sur ce cercle on va reprsenter nos tables de multiplication.
' Commenons par la plus simple : la table de 2.
' Pour reprsenter dans ce cercle la table de 2, nous allons relier chaque nombre
'  son rsultat par la multiplication par 2.
' Par exemple, le nombre 1, si on fait 1 fois 2 on obtient 2. Nous allons relier
' le nombre 1 au nombre 2; puis 2 fois 2, a fait 4. Nous allons donc relier
' le 2 au 4.
' 3 fois 2, a fait 6, nous relions donc le 3 au 6.
' 4 fois 2, a fait 8, nous relions le 4 au 8.
' 5 fois 2, a fait 10 et rappelons-nous que le 10 se trouve au mme endroit que
' le 0, nous relions donc le 5 au 0 et ainsi de suite avec tous les nombres du
' cercle.
' On a donc obtenu la reprsentation de la table de 2 modulo 10.
' Mais rien ne nous empche de reprsenter la table de 2 modulo 11 ou modulo 12
' ou modulo un nombre aussi grand que l'on veut.
' Pour un nombre grand, la figure obtenue semble sortir de nulle part puisque
' d'aprs notre procd de construction, ce dessin ne contient que des lignes droites.
' C'est donc une illusion d'optique et que l'enchevtrement de toutes ces lignes
' droites  nous donne l'impression de cette figure courbe qui apparait.
' Avec la table de 3, on obtient une figure qui semble compose de deux ptales.
' Avec la table de 4, trois ptales; avec la table de 5, quatre ptales;
' avec la table de 6, cinq ptales.
' On peut conclure que pour une table d'un nombre n , on obtient une sorte de
' fleur ayant une ptale de moins que le nombre de la table de multiplication.
' Tout a est beau et mme trs beau, mais pourquoi nous n'essayons pas avec
' des tables des nombres non pas entiers mais dcimaux comme par exemple
' la table de 2.3 ou 2.5 ?
' Servez-vous! Donnez libre court  votre imagination!
rem ============================================================================

Run()

END
REM ============================================================================
SUB Run()
    dim xc,yc,r,twopi,halfpi,modulo,multiplicande,increment,t$
    full_space 0
    picture 10 : height 10,height(0)-100 : width 10,height(10)
    top 10,30 : left 10,(width(0)-width(10))/2 : 2d_target_is 10 : print_target_is 10
    color 10,100,150,0
    alpha 20 : top 20,050 : left 20,10 : font_bold 20 : font_size 20,14
    alpha 30 : top 30,100 : left 30,10 : font_bold 30 : font_size 30,14
    xc = width(10)/2 : yc = height(10)/2 : r = width(10)/2 - 50
    twopi = 2*pi : halfpi = pi/2
    caption 0,"Art-ithmtique"
    t$ = t$ + chr$(13) + chr$(13) + "A R T - I T H M E T I Q U E"
    t$ = t$ + chr$(13) + chr$(13) + "Rappelez-vous que toutes ces figures" +chr$(13)
    t$ = t$ + "ont t obtenues uniquement" + chr$(13)
    t$ = t$ + "avec des droites !!!"+chr$(13)
    t$ = t$ + "Les formes courbes que vous voyez"+chr$(13)
    t$ = t$ + "ne sont que des illusions d'optique."+chr$(13)
    t$ = t$ + "Votre cerveau vous joue des tours !!!!"  +chr$(13) + chr$(13)
    t$ = t$ + "<CLICK> Pour arrter ....."
    caption 30,t$
    modulo        = 500 : ' essayer avec 1000
    multiplicande = 2
    increment     = 1   : ' essayer avec 0.1 ou 0.01
    repeat
        Cercle(modulo,multiplicande)  : multiplicande = multiplicande + increment
        pause 500   : ' Vous pouvez virer purement et simplement cette pause
    until scancode <> 0
END_SUB
REM ============================================================================
SUB Cercle(modulo,multiplicande)
    dim_local i,a,x,y,x1,y1,x2,y2
    a = twopi/modulo
    t$ = "Table de multiplication de :"+chr$(13) + str$(multiplicande)+ " modulo " +str$(modulo)
    caption 20,t$
    2d_fill_on : 2d_fill_color 255,0,0 : 2d_pen_color 255,255,0 : 2d_circle xc,yc,r
    for i = 0 to modulo-1
        x1 = xc+r*cos(halfpi-a*i) : y1 = yc-r*sin(halfpi-a*i)
        x2 = xc+r*cos(halfpi-a*i*multiplicande) : y2 = yc-r*sin(halfpi-a*i*multiplicande)
        2d_line x1,y1,x2,y2
    next i
END_SUB
REM ============================================================================