
rem ============================================================================
rem            Spirale de Ulam
rem              Par Papydall
rem ============================================================================
rem Stanislas Marcin Ulam assistait  une confrence fort ennuyeuse et longue.
rem Pour tromper l ennui, il prit son crayon et crivit les entiers naturels en
rem colimaon en utilisant les carreaux de sa page.
rem Puis il noircit les cases occupes par les nombres premiers.
rem Il s apperut que d tranges alignements apparaissaient qu il fallait expliquer.
rem La spirale qui porte son nom tait ne.
rem On lappelle aussi spirale des nombres premiers ou horloge dUlam.
rem ============================================================================
rem En effet, ces alignements correspondent  des polynmes du 2me degr du type:
rem                ______________________
rem               |                      |
rem               |  y = a.x + b.x + c  |
rem               |______________________|                      |
rem
rem ============================================================================
rem Dj Euler avait propos la formule n - n + 41 qui, pour n compris entre 1
rem et 40 ne donne que des nombres premiers.
rem Les plus clbres sont les suivantes:
rem                _________________________
rem               |                         |
rem               |  y = 4x + 4x   + 3     |
rem               |  y = 4x + 18x  + 26    |
rem               |  y = 4x + 24x  + 43    |
rem               |  y = 4x + 12x  + 7     |
rem               |  y = 4x + 162x + 1681  |
rem               |  y = x  + x    + 17    |
rem               |  y = x  + x    + 41    | <---- Formule dcouverte par Euler
rem               |_________________________|
rem ============================================================================
Init()
' Excutez successivement ces deux Spirales
 Spirale_Ulam(12)
' Spirale_Ulam_2(70)
caption 0,"Termin"
end
rem ============================================================================
SUB Init()
    dim prem, p, q, c1, c2, i, j, n$
    width 0,screen_y : height 0,screen_y
    picture 10 : width 10,width(0)-50 : height 10,height(0)-50
    top 10,10  : left 10,25 : color 10,0,0,0
    print_target_is 10 : 2d_target_is 10 : font_color 10,0,0,0 : font_bold 10
    c1 = width(10)/2-40  : c2 = height(10)/2-40+30
    2d_pen_color 255,0,0 : 2d_fill_on
    alpha 20 : top 20,20 : left 20,150 : font_bold 20 : font_size 20,14: font_color 20,200,100,50
    hide 20
END_SUB
rem ============================================================================
' Calculer la position d'un entier q quelconque
SUB placer(q)
    dim_local d : ' d est la distance entre le nombre q et le plus petit nombre de la couronne p.
    dim_local e : ' e+1 est le numro du cot de la couronne o se trouve q.
    d = q - 2 * p * 2 * p - 1
    e = Int(d / (1 + 2 * p))
    select e
        case 0 : i = 0 + 4 * p * p + p - q + 1 : j = 0 - p
        case 1 : i = 0 - p : j = 0 - 4 * p * p - 3 * p - 1 + q
        case 2 : i = 0 - 4 * p * p - 5 * p - 2 + q : j = 0 + p + 1
        case 3 : i = 0 + p + 1 : j = 0 + 4 * p * p + 7 * p + 4 - q
    end_select
End_Sub
rem ============================================================================
' Dterminer si q est premier
SUB premier(q)
    dim_local a,m
    prem = 1
    m = 2 : a = 1
    While ((m * m <= q) And (a <> 0))
        a = mod(q,m) : m = m + 1
    end_while
    If ((a <> 0) And (q > 1))
       prem = 1
    Else
       prem = 0
    end_if
END_SUB
rem ============================================================================
SUB Spirale_Ulam(couronne)
    for p = 0 to couronne
        caption 0,"Couronne : " + str$(p)+ " / " + str$(couronne)
        for q = 4*p*p+1 to (2*p+2)*(2*p+2)
            n$ = str$(q)
            while len(n$) < 3 : n$ = "0" + n$ : end_while
            Premier(q) : Placer(q)
            if prem = 1
              2d_fill_color 255,0,0 : 2d_circle 10+c1+30*i,8+c2+30*j,15
            end_if
            if n$ = "001"
               font_color 10,255,255,255 : 2d_fill_color 0,0,255
            else
               font_color 10,000,000,000 : 2d_fill_color 255,255,0
            end_if
            print_locate c1+30*i,c2+30*j : print n$
       next q
    next p
    caption 20," Les cercles rouges contiennent les nombres premiers " : show 20
END_SUB
rem ============================================================================
SUB Spirale_Ulam_2(couronne)
    for p = 0 to couronne
        caption 0,"Couronne : " + str$(p)+ " / " + str$(couronne)
        for q = 4*p*p+1 to (2*p+2)*(2*p+2)
            n$ = str$(q)
            while len(n$) < 3 : n$ = "0" + n$ : end_while
            Premier(q) : Placer(q)
            if prem = 1
                2d_pen_color 255,0,0 : 2d_circle c1+4*i,c2+4*j,2
            end_if
       next q
    next p
    caption 20," Observez ces alignements des nombres premiers " : show 20
END_SUB
rem ============================================================================