
rem ============================================================================
rem                     Systme plantaire
rem ============================================================================
rem Une courbe paramtrique est l ensemble des positions prises (x,y) par un
rem point M(x,y) dont les coordonnes sont fonctions d un paramtre :
rem M = (x(t),y(t)).
rem Si ce paramtre est le temps, il s agit alors de la trajectoire du point.
rem ============================================================================
rem Rappel :
rem Un point M se dplaant  une vitesse f sur un cercle de rayon R centr en
rem (x0,y0) a pour coordonnes :
rem          _______________________
rem         |                       |
rem         |  x = x0 + R*cos(f*t)  |
rem         |  y = y0 + R*sin(f*t)  |
rem         |_______________________|
rem
rem ============================================================================
rem On souhaite reprsenter les trajectoires de trois points P1, P2 et P3 :
rem P3 tournant autour de P2, P2 tournant autour de P1, lui-mme en rotation
rem autour de l origine.
rem P1 tourne autour de O  avec un rayon R1 et une vitesse f1
rem P2 tourne autour de P1 avec un rayon R2 et une vitesse f2
rem P3 tourne autour de P2 avec un rayon R3 et une vitesse f3
rem On en dduit les coordonnes  en fonction du temps t:

rem Les coordonnes de P1
rem                    x1 = x0 + R1*cos(f1*t)
rem                    y1 = y0 + R1*sin(f1*t)
rem Les coordonnes de P2
rem                    x2 = x0 + x1 + R2*cos(f2*t)
rem                    y2 = y0 + y1 + R2*sin(f2*t)
rem Les coordonnes de P3
rem                    x3 = x0 + x2 + R3*cos(f3*t)
rem                    y3 = y0 + y2 + R3*sin(f3*t)

rem On fait varier t entre 0 et 360 (soit 2*pi rad).
rem Les rayons et vitesses respectives sont des paramtres transmis  la SUB
rem ============================================================================
dim xc,yc
width 0,800 : height 0,600
picture 10 : full_space 10 : 2d_target_is 10 : color 10,0,0,0
xc = width(10)/1.7 : yc = height(10)/2
caption 0,"Systme plantaire"
alpha 20 : top 20,050 : font_color 20,255,000,0 : font_size 20,16 : color 20, 0,0,128
      caption 20,"Trajectoire de P1" : hide 20
alpha 30 : top 30,100 : font_color 30,000,255,0 : font_size 30,16 : color 30, 0,0,128
      caption 30,"Trajectoire de P2" : hide 30
alpha 40 : top 40,150 : font_color 40,255,255,0 : font_size 40,16 : color 40, 0,0,128
      caption 40,"Trajectoire de P3" : hide 40
alpha 50 : top 50,500 : font_color 50,255,255,255 : font_size 50,12 : color 50, 0,0,128
      caption 50,"P3 tournant autour de P2, P2 tournant autour de P1, lui-mme en rotation autour de l'origine."
      font_name 50,"tahoma" : font_bold 50 : left 50,10 :  hide 50
' ------------------------------------------------------------------------------
Systeme_Planetaire(xc,yc,100,3,60,11,40,3)
' ------------------------------------------------------------------------------
end
rem ============================================================================
SUB Systeme_Planetaire(x0,y0,r1,f1,r2,f2,r3,f3)
    dim_local t, x1,y1,x2,y2,x3,y3,xd,yd
    degrees
    2d_circle x0,y0,5+5
    for t = 0 to 360 step .05
        x1 = x0 + R1*cos(f1*t) : y1 = y0 + R1*sin(f1*t) : ' Les coordonnes de P1
        x2 = x1 + R2*cos(f2*t) : y2 = y1 + R2*sin(f2*t) : ' Les coordonnes de P2
        x3 = x2 + R3*cos(f3*t) : y3 = y2 + R3*sin(f3*t) : ' Les coordonnes de P2
        2d_pen_color 255,000,000 : 2d_circle x1,y1,1
        2d_pen_color 000,255,000 : 2d_circle x2,y2,1
        2d_pen_color 255,255,000 : 2d_circle x3,y3,1
        display
    next t
    2d_flood 10,10,0,0,128
    show 20 : show 30 : show 40 : show 50
END_SUB
rem ============================================================================