
rem ============================================================================
rem                  JEU DE LA VIE
rem ============================================================================
' Les cellules meurent ou naissent suivant 3 lois :
' Parmi les cellules adjacentes,
' 1) si plus de 3 sont vivantes  ==> la cellule meurt d'touffement;
' 2) si moins de 2 sont vivantes ==> la cellule meurt d'isolement;
' 3) si 2 ou 3 vivantes          ==> la cellule reste en l'tat;
' 4) si 2 vivantes               ==> la cellule nat (si elle tait morte)
rem ============================================================================
' On rencontre des structures remarquables :
' * Figure stable
' * Figure 2-priodiques et fixe et sa rotation de 90
' * Figure 5-priodiques et se dplaant (appele "planeurs" et ses images par rotation
rem ============================================================================

Jeu_De_La_Vie()
terminate

END
rem ============================================================================
SUB Jeu_De_La_Vie()
    Init()
    Grille_De_Jeu()
' Essayez N_Periodiques() puis Clown()
  '  N_Periodiques()
    Clown()
    repeat
       Evolution()
       Affichage()
    until scancode = 27
END_SUB
REM ============================================================================
SUB Init()
    dim w,h   : w = 800 : h = 800
    dim NbLigne, NbColonne : NbLigne = 30 : NbColonne = 30  : ' Nombre de cellules
    dim centre : centre = (NbLigne*NbColonne + NbColonne)/2 : ' Centre de la grille
    dim wc,hc : wc = (w-100)/NbColonne-2 : hc = wc : ' dimensions d'une cellule
    dim matrice(NbColonne+1,NbLigne+1)
    dim ligne,colonne,x,y,r
    dim generation
    width 0,w : height 0,h : color 0,200,150,50
    alpha 9999 : top 9999,5 : left 9999,200 : font_bold 9999 : font_size 9999,18
    font_color 9999,0,0,255 : caption 9999,"J E U   D E   L A   V I E"
    panel 9998 :width 9998,width(0)-100 : height 9998,height(0)-100
    top 9998,50 :left 9998,50

END_SUB
rem ============================================================================
SUB Grille_De_Jeu()
    dim_local ligne,colonne,n
    hide 9998
    for ligne = 1 to NbLigne
        for colonne = 1 to NbColonne
            n = (ligne-1)*NbColonne + colonne
            picture n : parent n,9998 : width n,wc : height n,hc : color n,0,255,255
            top n,8+ligne+(ligne-1)*hc : left n,8+colonne+(colonne-1)*wc
            2d_target_is n : x = wc/2 : y = hc/2 : r = x : 2d_circle x,y,r
            matrice(ligne,colonne) = 0 : ' cellule initialement morte
        next colonne
    next ligne
    show 9998
END_SUB
rem ============================================================================
SUB N_Periodiques()
    dim_local i,l,c,d,f
    2d_fill_on
' Essayez  ces n-priodiques
   ' d = 308 : f = d+2  : ' 2-Priodiques
   ' d = 308 : f = d+4  : ' 8-Priodiques
    d = 308 : f = d+10 : ' 15-Priodiques
    for i = d to f
        2d_target_is i : 2d_fill_color 0,0,0 : 2d_circle x,y,r
        l = int(i/NbLigne) + 1
        c = mod(i,NbColonne) : if c = 0 then c = NbColonne
        matrice(c,l) = 1 : ' cellule vivante
        display
    next i
END_SUB
rem ============================================================================
SUB Evolution()
    Dim_local Hg, Hm, Hd, Mg, Md, Bg, Bm, Bd, Som :  ' ce sont les 8 cases adjacentes
    dim_local x,y,mat(Nbcolonne,NbLigne)
    caption 0,"J E U    D E    L A    V I E      Gnration : " + str$(generation) + "  <ESC> pour arrter"
    generation = generation + 1
    For X = 1 To NBColonne
        For Y = 1 To NbLigne
            ' variables ayant l'tat des cellules adjacentes
            Hg = Matrice(X - 1, Y - 1)
            Hm = Matrice(X, Y - 1)
            Hd = Matrice(X + 1, Y - 1)
            Mg = Matrice(X - 1, Y)
            Md = Matrice(X + 1, Y)
            Bg = Matrice(X - 1, Y + 1)
            Bm = Matrice(X, Y + 1)
            Bd = Matrice(X + 1, Y + 1)
            Som = Hg + Hm + Hd + Mg + Md + Bg + Bd + Bm : ' nombre de cellules vivantes adjacentes
            If (Som < 2) Or (Som > 3)
               ' alors la cellule crve soit par isolement, soit par touffement
               Mat(X, Y) = 0
            End_If
            
            If Som = 3 then mat(x,y) = 1
            if (som = 2) and (matrice(x,y) = 1) then mat(x,y) = 1

        Next Y
    Next X
    
    ' maintenant, on copie Mat dans Matrice
    For X = 1 To NbColonne
        For Y = 1 To NbLigne : Matrice(X, Y) = Mat(X, Y) : Next Y
    Next X
END_SUB
rem ============================================================================
SUB Affichage()
    dim_local l,c,n

    For c = 1 To NBColonne
        For l = 1 To NbLigne
            n =  (l-1)*NbColonne + c : 2d_target_is n
            If Matrice(c,l) = 1  : ' alors  cellule vivante
               2d_fill_color 0,0,0
            else
               2d_fill_color 255,255,255 : ' cellule morte
            End_If
            2d_circle x,y,r : ' afficher la cellule
        Next l
    Next c

END_SUB
rem ============================================================================
SUB Clown()
    dim_local i,d,f,l,c
    2d_fill_on
    d = centre-1 : f = d+2

    for i = d to f step 2
        2d_target_is i : 2d_fill_color 0,0,0 : 2d_circle x,y,r
        l = int(i/NbLigne) + 1
        c = mod(i,NbColonne) : if c = 0 then c = NbColonne
        matrice(c,l) = 1 : ' cellule vivante
    next i
    d = d + NbColonne : f = d+2
    for i =  d to f step 2
        2d_target_is i : 2d_fill_color 0,0,0 : 2d_circle x,y,r
        l = int(i/NbLigne) + 1
        c = mod(i,NbColonne) : if c = 0 then c = NbColonne
        matrice(c,l) = 1 : ' cellule vivante
    next i
    d = d + NbColonne : f = d+2
    for i = d to f
        2d_target_is i : 2d_fill_color 0,0,0 : 2d_circle x,y,r
        l = int(i/NbLigne) + 1
        c = mod(i,NbColonne) : if c = 0 then c = NbColonne
        matrice(c,l) = 1 : ' cellule vivante
    next i
END_SUB
rem ============================================================================