
rem ============================================================================
rem     Zoom sur  Mandelbrot
rem ============================================================================
Init()
t = number_ticks
Draw()

t = number_ticks -t
caption 20,caption$(20) + " : " +str$(t/1000) + " s"
end
rem ============================================================================
SUB Init()

    dim sz,kt,m,xmin,xmax,ymin,ymax,dx,dy,r%,g%,b%,t
    width 0,700 : height 0,700
    sz = width(0)-100
    picture 10 : full_space 10 : width 10,sz : height 10,sz
    top 10,50 : left 10,50
    2d_target_is 10 : print_target_is 10 : color 10,0,0,0
    alpha 20 : top 20,10 : left 20,200 : font_bold 20 : font_name 20,"tahoma"
    font_size 20,14 : font_color 20,0,0,255 : caption 20,"Zoom sur Mandelbrot"
    caption 0,"<ESC> pour arrter"
    kt = 50 : m = 4
   xmin = -0.50 : xmax = 0000 : ymin = 0.50 : ymax = 1
'   xmin = -0.15 : xmax = -.05 : ymin = 0.90 : ymax = 1
'   xmin = -0.14 : xmax = -.13 : ymin = 0.98 : ymax = .99
END_SUB
rem ============================================================================
SUB Draw()
    dim_local a,b,d,k%,n,tx,x,y

    dx = (xmax-xmin)/sz : dy = (ymax-ymin)/sz
    for x = xmin to xmax step dx
        for y = ymin to ymax step dy
            k% = 0 : a = 0 : b = 0
            repeat
               tx = a*a-b*b+x : b = 2*b*a+y : a = tx: d = a*a+b*b : k% = k%+1
            until not ((d <= m) and (k% < kt))

            k% = k%*5000 : Integer2RGB(k%)
            2d_pen_color r%,g%,b%
            2d_point (x-xmin)/dx,(ymax-y)/dy
            if scancode = 27 then exit_sub
        next y
    next x

    2d_pen_color 0,0,0
    for n = 0 to 9
        2d_line n*sz/10,sz,n*sz/10,0
        print_locate n*sz/10,5 : print xmin+(xmax-xmin)*n/10
        print_locate 5,n*sz/10 : print ymax-(ymax-ymin)*n/10
        2d_line sz,n*sz/10,0,n*sz/10
    next n

END_SUB
rem ============================================================================
' Convertir une couleur de valeur entire en couleur RGB
SUB Integer2RGB(couleur%)
    R% = int(mod(Couleur%,256))
    G% = int(mod(Couleur%,65536)/256)
    B% = int(couleur%/65536)
END_SUB
rem ============================================================================