
rem ============================================================================
rem                    Biomorphe de Pickover
rem                     Papydall 23/09/2018
rem        Ref : http://www.madteddy.com/biomorph.htm
rem ============================================================================
rem                   Z + Constante Complexe
rem             z = (x+iy) = (x - 3xy) + (3xy - y)i
rem              Constante complexe : C = real + (imag)i
rem ============================================================================
' Pour obtenir le symbole de l'exposant  taper <ALT> + 252
rem  Appel : Z_Cube(xmax,ymax,real,imag)
rem  Vous pouvez jouer sur les valeurs xmax, ymax et/ou sur la constante complexe (real, imag)
rem ============================================================================
Init()
 Z_Cube(2.5125,1.88,0.5,0)
' Z_Cube(2,2,0.5,0.5)
' Z_Cube(2.5,2,0,0)
' Z_Cube(2.45,1.5,0.5,0.1)
end
rem ============================================================================
SUB Init()
    dim h,w  : h = 350 : w = h*4/3 : ' Taille de l'image
    picture 10 : width 10,w : height 10,h : 2d_target_is 10
    top 10, (height_client(0) - height(10))/2 + 20
    left 10,(width_client(0) - width(10))/2
    alpha 20 : top 20,20 : left 20,100 : font_bold 20 : font_size 20,18
    font_color 20,0,100,250 : font_name 20,"tahoma"
END_SUB
rem ============================================================================
' z = (x+iy) = (x - 3xy) + (3xy - y)i
SUB Z_Cube(xmax,ymax,real,imag)
    dim_local ymin : ymin = -1*ymax
    dim_local xmin : xmin = -1*xmax
    dim_local ilimit : ilimit = h-1
    dim_local jlimit : jlimit = w-1
    dim_local x,y,x0,y0,xx,yy,i,j,n,s$
    if imag >= 0 then s$ = "+"
    caption 20,"Z + C avec C = " + str$(real) + " " + s$ + str$(imag) +" i"
    caption 0, "Biomorphe de Pickover ... Trac en cours ... <ESC> pour arrter ..."
    FOR i = 0 TO ilimit
        FOR j = 0 TO jlimit
            x0 = xmin + (xmax - xmin) * j / jlimit
            y0 = -1*ymin - (ymax - ymin) * i / ilimit
            x = x0 : y = y0
            FOR n = 1 TO 100
                xx = x * (x * x - 3 * y * y) + real : ' Cette ligne et la suivante donnent
                yy = y * (3 * x * x - y * y) + imag : ' le cube du nombre, plus une constante
                x = xx : y = yy
                IF (ABS(x) > 10) OR (ABS(y) > 10) or ((x*x + y*y) > 100)  THEN exit_for        
            NEXT n
            IF (ABS(x) > 10) and (ABS(y) > 10)
               2d_pen_color 0,0,0
            else
               if (abs(x) > 10) and (abs(y) <= 10)
                  2d_pen_color 255,0,0
               else
                  if (abs(x) <= 10) and (abs(y) > 10)
                     2d_pen_color 0,255,0
                  else
                     2d_pen_color 255,255,0
                  end_if
               end_if
            end_if      
            2d_point j, i : display
            if scancode = 27 then terminate
        NEXT j
    NEXT i
    caption 0,"Termin"
END_SUB
rem ============================================================================