
rem ============================================================================
rem Fonctions priodiques : Triangle, Carre, Dents de scie, Sinusode redresse
rem ============================================================================
 Fonction_Triangle_Sin(20,100,25,3,1)
 Fonction_Triangle_Cos(20,300,25,3,1)
' ------------------------------------------------------------------------------
' Fonction_Carree_Cos(20,100,20,4,1)
' Fonction_Carree_Sin(20,300,20,4,1)
' ------------------------------------------------------------------------------
' Fonction_Dents_De_Scie(20,100,20,4,1)
' Fonction_Dents_De_Scie(20,300,10,8,1)
' ------------------------------------------------------------------------------
' Fonction_Sinusoide_Redressee(20,100,30,5,1)
' Fonction_Sinusoide_Redressee(20,300,10,15,1)
end
rem ============================================================================
SUB Axes(x,y,a,n)
    dim_local b : b = 2*a
    2d_pen_color 255,0,0
    2d_line x,y,x+2*n*a*pi,y
    2d_line x,y-b,x,y+b
    2d_pen_color 0,0,0

END_SUB
rem ============================================================================
' Paramtres :
' x,y : coordonnes du debut du trac
' a   : unit du trac  
' n   : nombre de (triangles / carrs / dents de scie / alternances)
' ax  : pour tracer ou non les axes (= 1 tracer les axes)
SUB Fonction_Triangle_Sin(x,y,a,n,ax)
    dim_local b,y1,t,p
    b = 2*a
    if ax = 1 then Axes(x,y,a,n)
    p = pi/180
    2d_poly_from x,y
    for t = p to 2*n*pi step p
        y1 = 2/pi*asin(sin(t)) : ' La formule de l'quation "Triangle"
        2d_poly_to x+a*t,y - b*y1
    next t
END_SUB
rem ============================================================================
' Autre forme de fonction triangle
SUB Fonction_Triangle_Cos(x,y,a,n,ax)
    dim_local b,y1,t,p
    b = 2*a
    if ax = 1 then Axes(x,y,a,n)
    p = pi/180
    2d_poly_from x,y-b
    for t = p to 2*n*pi step p
        y1 = 2/pi*asin(cos(t)) : ' La formule de l'quation "Triangle"
        2d_poly_to x+a*t,y - b*y1
    next t
END_SUB
rem ============================================================================
' Fonction carre
SUB Fonction_Carree_Cos(x,y,a,n,ax)
    dim_local b,y1,t,p
    b = 2*a
    if ax = 1 then Axes(x,y,a,n)
    p = pi/180
    2d_poly_from x,y-b
    for t = p to 2*n*pi step p
        y1 = sgn(cos(t)) : ' La formule de l'quation "carre"
        2d_poly_to x+a*t,y - b*y1
    next t
END_SUB
rem ============================================================================
' Autre forme de fonction carre
SUB Fonction_Carree_Sin(x,y,a,n,ax)
    dim_local b,y1,t,p
    b = 2*a
    if ax = 1 then Axes(x,y,a,n)
    p = pi/180
    2d_poly_from x,y-b
    for t = p to 2*n*pi step p
        y1 = sgn(sin(t)) : ' La formule de l'quation "carre"
        2d_poly_to x+a*t,y - b*y1
    next t
END_SUB
rem ============================================================================
' Fonction dents de scie
SUB Fonction_Dents_De_Scie(x,y,a,n,ax)
    dim_local b,y1,t,p
    b = 2*a
    if ax = 1 then Axes(x,y,a,n)
    p = pi/180
    2d_poly_from x,y
    for t = p to 2*n*pi step p
        y1 = 1/pi*atn(tan((t-pi)/2))+1/2 : ' La formule de l'quation "Dents de scie"
        2d_poly_to x+a*t,y - b*y1
    next t
END_SUB
rem ============================================================================
' Fonction sinusode redresse
' n : nombre d'alternances
SUB Fonction_Sinusoide_Redressee(x,y,a,n,ax)
    dim_local b,y1,t,p
    b = 2*a
    n = n/2
    if ax = 1 then Axes(x,y,a,n)
    p = pi/180
    2d_poly_from x,y
    for t = p to n*2*pi+p step p
        y1 = abs(sin(t)) : ' La formule de l'quation "sinusode redresse"
        2d_poly_to x+a*t,y - b*y1
    next t
END_SUB
rem ============================================================================