' Solitaire anglais version 1.00
' Marc - novembre 2022
' Ecrit en langage PANORAMIC 0.9.29i9

' matrice du jeu
'  0   0   3   4   5   0   0
'  0   0  10  11  12   0   0
' 15  16  17  18  19  20  21
' 22  23  24  25  26  27  28
' 29  30  31  32  33  34  35
'  0   0  38  39  40   0   0
'  0   0  45  46  47   0   0

' tableau de variables trou%(49,3)
' trou%(n,0) = numro du sprite dans le trou n
' trou%(n,1) = prsence d'une bille=1 ou absence=0 dans le trou n
' trou%(n,2) = coordonne x en pixels du trou n
' trou%(n,3) = coordonne y en pixels du trou n

dim trou%(49,3), jeu%, case%, x%, y%, null%, depart%, arrivee%
dim x_trou_depart%, y_trou_depart%, x_trou_arrivee%, y_trou_arrivee%
dim x_derivee%, y_derivee%, billeAdjacente%

label jouer, afficherApropos, fermerApropos, afficherReglesJeu, nouvellePartie
label forumPanoramic, survol0, survol11, survol12, survol13, survol20
label redim0, redim55, quitter

' les lignes DATAs renseignent squentiellement les coordonnes x,y des trous
' ligne 1
data 1000,1000,1000,1000,263,58,350,58,437,58,1000,1000,1000,1000
' ligne 2
data 1000,1000,1000,1000,262,124,350,124,438,124,1000,1000,1000,1000
' ligne 3
data 81,190,171,190,261,190,350,190,439,190,529,190,619,190
' ligne 4 (ligne centrale)
data 80,256,170,256,260,256,350,256,440,256,530,256,620,256
' ligne 5
data 79,322,169,322,259,322,350,322,441,322,531,322,621,322
' ligne 6
data 1000,1000,1000,1000,258,388,350,388,442,388,1000,1000,1000,1000
' ligne 7
data 1000,1000,1000,1000,257,454,350,454,443,454,1000,1000,1000,1000

interfaceUtilisateur()

on_mouse_down 3,jouer

' animation des boutons lors du survol par la souris
on_mouse_move 0,survol0
on_mouse_move 11,survol11
on_mouse_move 12,survol12
on_mouse_move 13,survol13
on_mouse_move 20,survol20

caption 0,"PANORAMIC : Jeu du Solitaire anglais"

end
' ------------------------------------------------------------------------------
jouer:
    off_mouse_down 3
    
    ' on quitte le sous-programme si le bouton droit de la souris qui est enfonc
    if mouse_right_down(3) = 1
        on_mouse_down 3,jouer
        return
    end_if

    ' position de la souris sur la scne 2D
    x% = mouse_x_position(3)
    y% = mouse_y_position(3)

    ' dlimitation de la zone cliquable
    if x% < 75 or x% > 675 or y% < 40 or y% > 495
        on_mouse_down 3,jouer
        return
    end_if 

    ' identifier la case clique pour oprer une action
    identifierCase()
    depart% = case%

    ' annuler si clic sur une case vide
    if trou%(depart%,0) = 0 
        on_mouse_down 3,jouer
        return
    end_if

    ' Dpart du jeu : Oter une bille du plateau pour commencer le jeu
    if jeu% = 0
        jeu% = 1
        trou%(depart%,1) = 0
        trou%(depart%,0) = 0 
        sprite_hide depart%
        on_mouse_down 3,jouer
        return
    end_if

    ' rafraichir l'tat des boutons de la souris
    null% = mouse_left_up(3)
    null% = mouse_left_down(3)

    ' mettre au premier plan le sprite qui reprsente la bille clique
    if trou%(depart%,1) = 1
        sprite_delete trou%(depart%,0)
        sprite trou%(depart%,0)
        sprite_image_load trou%(depart%,0),2
        sprite_position trou%(depart%,0),x%-26,y%-26
        sprite_show trou%(depart%,0)
    else
        on_mouse_down 3,jouer
        return
    end_if

    ' dplacer la bille clique tant que le bouton gauche de la souris est enfonc
    ' la bille suit le dplacement de la souris
    repeat 
        x% = mouse_x_position(3)
        y% = mouse_y_position(3)
        ' dlimitation de la zone de jeux
        if x% < 75 or x% > 675 or y% < 40 or y% > 495
            deplacerBille(depart%)
            on_mouse_down 3,jouer
            return
        end_if 
        sprite_position trou%(depart%,0),x%-26,y%-26
        pause 20
    until mouse_left_up(3) = 1
    
    ' le bouton gauche de la souris  t relch
    identifierCase()
    arrivee% = case%
    
    x_trou_depart% = mod((depart%-1),7)
    y_trou_depart% = int((depart%-1)/7)
    
    x_trou_arrivee% = mod((arrivee%-1),7)
    y_trou_arrivee% = int((arrivee%-1)/7)
    
    x_derivee% = x_trou_arrivee% - x_trou_depart%
    y_derivee% = y_trou_arrivee% - y_trou_depart%


    ' annuler le dplacement si la progression est nulle
    if x_trou_depart% = x_trou_arrivee% and y_trou_depart% = y_trou_arrivee%
        deplacerBille(depart%)
        on_mouse_down 3,jouer
        return
    end_if
    
    ' annuler le dplacement s'il est effectu en diagonale
    if x_trou_depart% <> x_trou_arrivee% and y_trou_depart% <> y_trou_arrivee%
         deplacerBille(depart%)
         on_mouse_down 3,jouer
         return
    end_if

    ' annuler le dplacement si case d'arrive est occupe par une bille
    if trou%(arrivee%,1) = 1
        deplacerBille(depart%)
        on_mouse_down 3,jouer
        return
    end_if
    
    ' annuler le dplacement si l'cart [dpart,arrive] n'est pas de deux cases 
    if abs(x_derivee%) <> 2 and abs(y_derivee%) <> 2
        deplacerBille(depart%)
        on_mouse_down 3,jouer
        return
    end_if

    ' annuler le dplacement s'il n'y a pas de bille adjacente 
    billeAdjacente% = (x_trou_depart% + 1 + x_derivee%/2) + ((y_trou_depart% + y_derivee%/2)*7)
    if trou%(billeAdjacente%,1) = 0
        deplacerBille(depart%)
        on_mouse_down 3,jouer
        return
    end_if
         
    ' MISE A JOUR DU TABLEAU DE JEU
    ' affecter le n de la bille de la case de dpart dans la case arrive
    trou%(arrivee%,0) = trou%(depart%,0)
    ' effacer n de de la bille de la case de dpart
    trou%(depart%,0) = 0
    ' mettre  0 le flag de prsence d'une bille dans le trou de dpart
    trou%(depart%,1) = 0
    ' mettre  1 le flag de prsence d'une bille dans le trou d'arrive
    trou%(arrivee%,1) = 1
    ' suppression de la bille adjacente saute
    sprite_hide trou%(billeAdjacente%,0)
    trou%(billeAdjacente%,1) = 0
    trou%(billeAdjacente%,0) = 0

    deplacerBille(arrivee%) 
    
    on_mouse_down 3,jouer
return
' ------------------------------------------------------------------------------
sub deplacerBille(destination%)
    sprite_position trou%(destination%,0),trou%(destination%,2),trou%(destination%,3)-14
end_sub
' ------------------------------------------------------------------------------
sub identifierCase()
    x% = (x%-15)/90
    x% = mod(x%,8)

    y% = (y%-2)/66
    y% = mod(y%,8)

    case% = (y%-1)*7 + x%
end_sub
' ------------------------------------------------------------------------------
sub interfaceUtilisateur()
    ' dimensions utiles de la fentre du jeu : FORM 0
    width 0,width(0) - width_client(0) + 984
    height 0,height(0) - height_client(0) + 650

    ' centrer la fentre sur l'cran
    top 0,(screen_y - height(0))/2
    left 0,(screen_x - width(0))/2 
    caption 0,"SOLITAIRE   - - - - - Initialisation du jeu... Patientez ! - - - - -"
    color 0,0,100,0
    on_close 0,quitter
    on_resize 0,redim0

    picture 1 :' Planche  dessins non visible
    2d_target_is 1
    hide 1

    image 2 :' mmoire pour copier/coller les dessins effectus

    creerRegleDujeu()
    dessinerPlateauDeJeu()
    dessinerBilles()
    dessinerCommandes()
    creerApropos()
end_sub
' ------------------------------------------------------------------------------
sub creerApropos()
    dim_local x%, y%, m%, cx%, cy%, rayon%
    create_show
    panel 40
    top 40,175
    left 40,328
    width 40,328
    height 40,300
    
    ' habillage fond d'image du PANEL 40
    picture 41
    parent 41,40
    full_space 41
    color 41,230,230,230
    print_target_is 41
    2d_target_is 41

    ' bannire
    2d_fill_color 0,100,0
    2d_pen_color 0,100,0
    2d_rectangle 15,15,311,90
 
    font_size 41, 45
    font_name 41,"Calibri"
    font_color 41,255,255,0
    print_locate 36,16
    print "S"
    print_locate 110,16
    print "LITAIRE"

    ' lettre "O" du mot SOLITAIRE 
    picture 42
    parent 42,40
    width 42,47
    height 42,47
    top 42,31
    left 42,65
    color 42,0,100,0
    2d_target_is 42
    2d_pen_color 248,225,194
    cx% = 23
    cy% = 23
    x% = 0
    y% = 23             
    m% = 5 - 4*rayon%       
    while x% <= y%
        2d_point x%+cx%,y%+cy%
        2d_point x%*(-1)+cx%,y%+cy%
        2d_point x%+cx%,y%*(-1)+cy%
        2d_point x%*(-1)+cx%,y%*(-1)+cy%
        2d_point y%+cx%,x%+cy%
        2d_point y%+cx%,x%*(-1)+cy%
        2d_point y%*(-1)+cx%,x%+cy%
        2d_point y%*(-1)+cx%,x%*(-1)+cy%
        if m% > 0	
            y% = y% - 1
            m% = m% - 8*y%
        end_if
        x% = x% + 1
        m% = m% + 8*x% + 4
    end_while
    2d_flood 11,11,248,225,194
    2d_pen_color 100,50,0
    2d_fill_color 100,50,0
    2d_rectangle 17,7,30,10
    2d_rectangle 17,12,30,15
    2d_rectangle 7,17,40,20
    2d_rectangle 7,22,40,25
    2d_rectangle 7,27,40,30
    2d_rectangle 17,32,30,35
    2d_rectangle 17,37,30,40
    2d_pen_color 248,225,194
    2d_fill_color 248,225,194
    2d_rectangle 10,17,12,30 
    2d_rectangle 15,17,17,30
    2d_rectangle 20,7,22,40
    2d_rectangle 25,7,27,40
    2d_rectangle 30,17,32,30
    2d_rectangle 35,17,37,30
    2d_rectangle 22,22,25,25
    
    ' texte sous la bannire
    2d_target_is 41
    2d_fill_color 230,230,230
    font_name 41,"Arial"
    font_size 41,12
    font_bold 41
    font_color 41,0,0,0
    print_locate 20,130
    print "Solitaire Anglais"
    font_bold_off 41
    font_size 41,10
    print_locate 20,152
    print "Version 1.00 - 22/11/2022"

    ' adresse Internet du forum
    alpha 43
    parent 43,40
    top 43,172
    left 43,20
    color 43,230,230,230
    font_name 43,"Calibri"
    font_size 43,11
    font_color 43,20,20,255
    font_underline 43
    caption 43,"https://panoramic.1fr1.net/"
    cursor_point 43
    on_click 43,forumPanoramic     

    ' ligne de sparation
    x% = 50
    y% = 217
    for m% = 230 to 255
        2d_pen_color m%,m%,m%
        2d_point x%,y%
        2d_point 325-x%,y%
        x% = x% + 1
    next m%
    2d_pen_color 255,255,255
    2d_line 75,y%,250,y%

    ' texte en bas de la fentre
    print_locate 20,243
    print "Jeu crit par Marc en langage"
    print_locate 20,260
    print "Panoramic Basic V.0.9.29i9"

    ' bouton "Ok"
    button 44
    top 44,246
    left 44,229
    height 44,30
    parent 44,40
    caption 44,"Ok"
    on_click 44,fermerApropos

    hide 40
end_sub
' ------------------------------------------------------------------------------
sub creerRegleDujeu()
    form 55
    border_small 55
    top 55,20
    left 55, 20
    width 55,455
    height 55,685
    caption 55,"Rgle du jeu"
    on_resize 55,redim55

    ' Placer le FORM 0 en avant plan
    to_foreground 0

    ' habillage FORM 55
    picture 57
    parent 57,55
    full_space 57
    color 57,230,230,250
    2d_target_is 57

    2d_fill_color 230,230,250
    print_target_is 57
    font_color 57,0,0,130
    font_name 57,"Calibri"
    font_size 57,22
    print_locate 90,20
    print "PANORAMIC Solitaire"

    font_size 57,11
    print_locate 20,70
    print "Jeu de casse-tte, le Solitaire est un jeu ancestral qui se pratique"
    print_locate 20,90
    print "seul. Il n'y a pas d'adversaire. Plusieurs versions existent. Celui-ci"
    print_locate 20,110
    print "est la version anglaise qui possde 33 trous."

    font_size 57,14
    print_locate 20,150
    font_color 57,0,0,70
    print "L'objectif :"

    font_color 57,0,0,130
    font_size 57,11
    print_locate 20,175
    print "Ne conserver qu'une seule bille et l'amener de prfrence dans"
    print_locate 20,195
    print "le premier trou libr au dpart." 

    font_size 57,14
    print_locate 20,235
    font_color 57,0,0,70
    print "Le fonctionnement :"

    font_color 57,0,0,130
    font_size 57,11
    print_locate 20,260
    print "Le jeu se joue exclusivement avec la souris de votre ordinateur."
    print_locate 20,280
    print "Utilisez le cliquer-glisser pour dplacer une bille."

    font_size 57,14
    print_locate 20,320
    font_color 57,0,0,70
    print "Le droulement :"

    font_color 57,0,0,130
    font_size 57,11
    print_locate 20,345
    print "Au dpart, tous les trous sont occups par une bille."
    print_locate 20,365
    print "Pour commencer une partie, cliquez sur une bille pour librer"
    print_locate 20,385
    print "un trou."
    print_locate 20,405
    print "Ensuite, pour supprimer une bille, il faut que deux billes soient"
    print_locate 20,425
    print "adjacentes et suivies d'une case vide. La premire bille saute"
    print_locate 20,445
    print "par-dessus la deuxime et rejoint la case vide. La bille saute"
    print_locate 20,465
    print "est alors retire du plateau."
    print_locate 20,485
    print "Une bille ne peut sauter qu'horizontalement ou verticalement"
    print_locate 20,505
    print "et une seule bille  la fois."

    font_size 57,14
    print_locate 20,545
    font_color 57,0,0,70
    print "Fin de partie :"

    font_color 57,0,0,130
    font_size 57,11
    print_locate 20,570
    print "La partie est gagne lorsqu'il ne reste plus qu'une seule bille"
    print_locate 20,590
    print "sur le plateau. L'idal serait que cette dernire bille termine"
    print_locate 20,610
    print "dans le trou libr au dpart de la partie."
    hide 55
end_sub
' ------------------------------------------------------------------------------
sub dessinerPlateauDeJeu()
    dim_local n%, i%, x%, y%
    width 1,753
    height 1,586

    2d_target_is 1
    2d_pen_color 243,208,188
    2d_fill_color 243,208,188
    2d_ellipse 0,0,753,586

    2d_pen_color 248,225,194
    2d_fill_color 248,225,194
    2d_ellipse 6,0,745,547

    ' crer une texture
    for n% = 1 to 6000
        2d_pen_color 213 + rnd(20),183+rnd(20),158+rnd(20)
        x% = rnd(754)
        y% = rnd(586)
        2d_line x%,y%,x%+rnd(20),y%
    next n%
    
    ' effacer texture autour du plateau de jeu
    2d_fill_off
    2d_pen_color 0,100,0
    2d_pen_width 2
    for n% = 1 to 140 
        2d_ellipse 0-n%,0-n%,753+n%,586+n%
    next n% 
    2d_pen_width 1

    ' initialisation du tableau des coordonnes des trous
    for n% = 1 to 49
         read x%
         trou%(n%,2) = x%
         read y%
         trou%(n%,3) = y%
    next n%

    ' dessiner et placer les trous du plateau de jeu
    for i% = 1 to 49
        x% = trou%(i%,2)
        y% = trou%(i%,3)
        for n% = 0 to 20
            2d_pen_color 203+(n%*2),168+(n%*2),148+(n%*2)
            2d_fill_color 203+(n%*2),168+(n%*2),148+(n%*2)
            2d_ellipse x%+n%,y%,53+x%-n%,39+y%-n%
        next n%
    next i%
    
    ' mise en memoire du dessin du plateau de jeu cr
    2d_image_copy 2,0,0,753,586

    ' crer une scne 2D
    scene2d 3
    width 3,753
    height 3,586
    top 3,32
    left 3,32
       
    ' tapisser la scne 2D avec le dessin du plateau de jeu
    sprite 50
    sprite_image_load 50,2
end_sub
' ------------------------------------------------------------------------------
sub dessinerBilles()
    dim_local c, i, n%

    ' dessiner un modle de bille
    width 1,53
    height 1,53
    color 1,0,0,0 :' couleur de tranparence pour les sprites
    2d_fill_off
    2d_pen_width 1

    for n% = 0 to 20
        2d_pen_color 100+(n%*4),50+(n%*4),0
        2d_fill_color 100+(n%*4),50+(n%*4),0
        2d_circle 26,26-n%,26-n%
    next n%

    ' mise en mmoire du modle de bille
    2d_image_copy 2,0,0,53,53
    
    ' crer et placer les 33 billes 
    sprite_create_hide
    for n% = 1 to 49
        sprite n%
        sprite_image_load n%,2
        sprite_position n%,trou%(n%,2),trou%(n%,3)-14
        sprite_show n%
        trou%(n%,0) = n% :' numro du sprite occupant le trou
        trou%(n%,1) = 1 :' bille prsente dans le trou
    next n%
    
    ' cacher les billes des trous inexistants
    sprite_hide 1
    sprite_hide 2
    sprite_hide 6
    sprite_hide 7
    sprite_hide 8
    sprite_hide 9
    sprite_hide 13
    sprite_hide 14
    sprite_hide 36
    sprite_hide 37
    sprite_hide 41
    sprite_hide 42
    sprite_hide 43
    sprite_hide 44
    sprite_hide 48
    sprite_hide 49
    trou%(1,0) = 0
    trou%(2,0) = 0
    trou%(6,0) = 0
    trou%(7,0) = 0
    trou%(8,0) = 0
    trou%(9,0) = 0
    trou%(13,0) = 0
    trou%(14,0) = 0
    trou%(36,0) = 0
    trou%(37,0) = 0
    trou%(41,0) = 0
    trou%(42,0) = 0
    trou%(43,0) = 0
    trou%(44,0) = 0
    trou%(48,0) = 0
    trou%(49,0) = 0
end_sub
' ------------------------------------------------------------------------------
sub dessinerCommandes()
    create_hide
    ' titre
    picture 10
    top 10,35
    left 10,810
    width 10,135
    height 10,75
    color 10,0,100,0
    2d_target_is 10
    2d_fill_color 0,100,0
    print_target_is 10
    font_name 10,"Calibri"
    font_size 10,30
    font_color 10,255,255,0
    print "Solitaire"
    font_size 10,14
    font_italic 10
    print_locate 74,43
    print "Anglais" 
    show 10
    
    ' bouton "Nouvelle partie"
    picture 11
    top 11,200
    left 11,835
    width 11,100
    height 11,53
    color 11,0,110,0
    2d_target_is 11
    2d_fill_color 0,110,0
    print_target_is 11
    font_color 11,255,255,255
    font_name 11,"Arial"
    font_size 11,14
    font_color 10,255,255,255
    print_locate 14,2
    print "Nouvelle"
    print_locate 27,25
    print "partie"
    show 11
    cursor_point 11
    on_click 11,nouvellePartie 
    
    ' bouton "Rgle du jeu"
    picture 12
    top 12,280
    left 12,835
    width 12,100
    height 12,53
    color 12,0,110,0
    2d_target_is 12
    2d_fill_color 0,110,0
    print_target_is 12
    font_color 12,255,255,255
    font_name 12,"Arial"
    font_size 12,14
    font_color 12,255,255,255
    print_locate 12,2
    print "Rgle du"
    print_locate 38,25
    print "jeu"
    show 12
    cursor_point 12
    on_click 12,afficherReglesJeu

    ' bouton "A-propos"
    picture 13
    top 13,360
    left 13,835
    width 13,100
    height 13,53
    color 13,0,110,0
    2d_target_is 13
    2d_fill_color 0,110,0
    print_target_is 13
    font_color 13,255,255,255
    font_name 13,"Arial"
    font_size 13,14
    font_color 13,255,255,255
    print_locate 12,15
    print "A-propos"
    show 13
    cursor_point 13
    on_click 13,afficherApropos

    dessinerLogoPanoramic(840,507)
end_sub
' ------------------------------------------------------------------------------
sub dessinerLogoPanoramic(x%,y%)
    picture 20
    height 20,90
    width 20,90
    top 20,y%
    left 20,x%
    color 20,255,255,255
    hint 20,"https://panoramic.1fr1.net/" 
    2d_target_is 20
    cursor_point 20
    
    ' cadre priphrique
    2d_pen_color 0,100,0
    2d_fill_off
    2d_rectangle 0,0,90,90

    ' dessin des cercles rouges
    2d_fill_color 255,255,255
    2d_pen_width 4
    2d_pen_color 255,0,0
    2d_circle 45,45,39
    2d_circle 45,45,29

    ' dessin du "P" en bleu
    2d_pen_width 1
    2d_pen_color 51,52,153
    2d_fill_color 51,52,153
    2d_rectangle 32,32,55,34
    2d_rectangle 37,34,43,59
    2d_rectangle 42,47,55,49
    2d_rectangle 53,36,60,45
    2d_line 35,34,37,34
    2d_point 36,35
    2d_line 35,58,37,58
    2d_point 36,57
    2d_point 43,57
    2d_line 42,58,45,58
    2d_rectangle 32,59,50,61
    2d_line 55,33,57,33
    2d_line 50,34,58,34
    2d_line 51,35,59,35
    2d_line 52,36,52,38
    2d_line 60,38,60,43
    2d_line 52,43,52,45
    2d_line 51,45,59,45
    2d_line 50,46,58,46
    2d_line 55,47,57,47
    show 20
    on_click 20,forumPanoramic
end_sub
' ------------------------------------------------------------------------------
forumPanoramic:
    ' animation du logo Panoramic
    2d_target_is 20
    2d_fill_off
    2d_pen_color 0,150,0
    2d_rectangle 0,0,90,90

    execute "https://panoramic.1fr1.net/"
return
' ------------------------------------------------------------------------------
afficherApropos:
    ' afficher la fentre "A-propos"
    inactive 3
    inactive 11
    show 40

    ' couleur du bouton "A-propos"
    2d_target_is 13
    2d_flood 1,1,0,110,0
    2d_flood 36,27,0,110,0
    2d_flood 53,27,0,110,0
    2d_flood 63,27,0,110,0
    2d_flood 75,27,0,110,0
return
' ------------------------------------------------------------------------------
fermerApropos:
    hide 40
    active 3
    active 11
return
' ------------------------------------------------------------------------------
afficherReglesJeu:
     show 55

    ' couleur du bouton "Rgle du jeu"
    2d_target_is 12
    2d_flood 1,1,0,110,0
    2d_flood 18,9,0,110,0
    2d_flood 41,14,0,110,0
    2d_flood 73,14,0,110,0
return
' ------------------------------------------------------------------------------
nouvellePartie:
    nouveauJeu()
return
' ------------------------------------------------------------------------------
sub nouveauJeu()
    dim_local n%
    inactive 3
    for n% = 3 to 5
        sprite_position n%,trou%(n%,2),trou%(n%,3)-14
        sprite_show n%
        trou%(n%,0) = n% :' numro du sprite occupant le trou
        trou%(n%,1) = 1 :' bille prsente dans le trou
    next n%

    for n% = 10 to 12
        sprite_position n%,trou%(n%,2),trou%(n%,3)-14
        sprite_show n%
        trou%(n%,0) = n% :' numro du sprite occupant le trou
        trou%(n%,1) = 1 :' bille prsente dans le trou
    next n%

    for n% = 15 to 35
        sprite_position n%,trou%(n%,2),trou%(n%,3)-14
        sprite_show n%
        trou%(n%,0) = n% :' numro du sprite occupant le trou
        trou%(n%,1) = 1 :' bille prsente dans le trou
    next n%
    
    for n% = 38 to 40
        sprite_position n%,trou%(n%,2),trou%(n%,3)-14
        sprite_show n%
        trou%(n%,0) = n% :' numro du sprite occupant le trou
        trou%(n%,1) = 1 :' bille prsente dans le trou
    next n%

    for n% = 45 to 47
        sprite_position n%,trou%(n%,2),trou%(n%,3)-14
        sprite_show n%
        trou%(n%,0) = n% :' numro du sprite occupant le trou
        trou%(n%,1) = 1 :' bille prsente dans le trou
    next n%

    jeu% = 0
    active 3
end_sub
' ------------------------------------------------------------------------------
redim0:
    ' Redimension de la fentre FORM 0
    off_resize 0
    width 0,width(0) - width_client(0) + 984
    height 0,height(0) - height_client(0) + 650
    on_resize 0,redim0
return
' ------------------------------------------------------------------------------
survol11:
    ' survol du bouton "Nouvelle partie"
    off_mouse_move 11
    on_mouse_move 0,survol0

    ' couleur du bouton "Nouvelle partie"
    2d_target_is 11
    2d_flood 1,1,0,150,0
    2d_flood 32,14,0,150,0
    2d_flood 32,38,0,150,0
return
' ------------------------------------------------------------------------------
survol12:
    ' survol du bouton "Rgle du jeu"
    off_mouse_move 12
    on_mouse_move 0,survol0

    ' couleur du bouton "Rgle du jeu"
    2d_target_is 12
    2d_flood 1,1,0,150,0
    2d_flood 18,9,0,150,0
    2d_flood 41,14,0,150,0
    2d_flood 73,14,0,150,0
return
' ------------------------------------------------------------------------------
survol13:
    ' survol du bouton "A-propos"
    off_mouse_move 13
    on_mouse_move 0,survol0

    ' couleur du bouton "A-propos"
    2d_target_is 13
    2d_flood 1,1,0,150,0
    2d_flood 36,27,0,150,0
    2d_flood 53,27,0,150,0
    2d_flood 63,27,0,150,0
    2d_flood 75,27,0,150,0
return
' ------------------------------------------------------------------------------
survol0:
    ' survol en dehors d'un bouton
    off_mouse_move 0
    on_mouse_move 11,survol11
    on_mouse_move 12,survol12
    on_mouse_move 13,survol13
    on_mouse_move 20,survol20
    
    ' couleur du bouton "Nouvelle partie"
    2d_target_is 11
    2d_flood 1,1,0,110,0
    2d_flood 32,14,0,110,0
    2d_flood 32,38,0,110,0

    ' couleur du bouton "Rgle du jeu"
    2d_target_is 12
    2d_flood 1,1,0,110,0
    2d_flood 18,9,0,110,0
    2d_flood 41,14,0,110,0
    2d_flood 73,14,0,110,0

    ' couleur du bouton "A-propos"
    2d_target_is 13
    2d_flood 1,1,0,110,0
    2d_flood 36,27,0,110,0
    2d_flood 53,27,0,110,0
    2d_flood 63,27,0,110,0
    2d_flood 75,27,0,110,0
    
    ' animation du logo Panoramic
    2d_target_is 20
    2d_fill_off
    2d_pen_color 0,150,0
    2d_rectangle 0,0,90,90
return
' ------------------------------------------------------------------------------
survol20:
    off_mouse_move 20
    on_mouse_move 0,survol0

    ' animation du logo Panoramic
    2d_target_is 20
    2d_fill_off
    2d_pen_color 255,255,255
    2d_rectangle 0,0,90,90
return    
' ------------------------------------------------------------------------------
redim55:
    off_resize 55
    width 55,455
    height 55,685
    on_resize 55,redim55
return
' ------------------------------------------------------------------------------
quitter:
    terminate
return