' Creer des degrads d'une teinte
' Marc - Mai 2022
' crit en langage Panoramic

dim r%,v%,b%
dim t,s,l

label choixTeinte

interfaceUtilisateur()

end
' ------------------------------------------------------------------------------
sub interfaceUtilisateur()
    dim_local pas%, n%
    left 0,(screen_x - width(0))/2
    top 0,(screen_y - height(0))/2
    color 0,255,255,255

    ' dessiner la barre du choix de la teinte
    picture 1
    width 1,360
    height 1,30
    top 1,50
    left 1,110
    2d_target_is 1
    cursor_cross 1
    on_click 1,choixTeinte
    
    ' colorier la barre du chois de la teinte
    s = 1 :' valeurs admises dans l'intervalle [0,1]
    l = 0.50 :' valeurs admises dans l'intervalle [0,1]
    n% = 0
    for t = 0 to 1 step 0.002777778
        TSL2RVB(t,s,l)
        2d_pen_color r%,v%,b%
        2d_line n%,0,n%,30
        n% = n% + 1
    next t

    ' dessiner la barre de dgrads
    pas% = 110
    for n% = 2 to 26
        picture n%
        left n%,pas%
        top n%,120
        width n%,14
        height n%,30
        pas% = pas% + 14
    next n%

    ' lgendes
    alpha 30
    top 30,35
    left 30,110
    caption 30,"Cliquez sur une teinte pour obtenir des dgrads"
end_sub
' ------------------------------------------------------------------------------
sub creerDegrade()
    dim_local pas, n%
    RVB2TSL(r%,v%,b%)
    pas = 0
    for n% = 2 to 26
        TSL2RVB(t,s,pas)
        color n%,r%,v%,b%
        pas = pas + 0.04
    next n%
end_sub
' ------------------------------------------------------------------------------
sub RVB2TSL(r1,v1,b1)
    dim_local mini, maxi, ecart

    ' conversion rvb dans l'intervalle [0,1]
    r1 = r1 / 255
    v1 = v1 / 255
    b1 = b1 / 255

   ' recherche de la plus grande valeur parmi les composantes r,v,b
    maxi = max(r1,max(v1,b1))

    ' recherche de la plus petite valeur parmi les composantes r,v,b  
    mini = min(r1,min(v1,b1))

    ' calcul luminance l
    l = (maxi + mini) / 2

    ' calcul de l'cart entre la valeur mini et maxi
    ecart = maxi - mini

    ' si ecart est nul alors t et s sont nuls
    if ecart = 0
        t = 0
        s = 0
    else      
 ' calcul de la saturation s
 if l < 0.5 then s = ecart / (maxi + mini)
 if l >= 0.5 then s = ecart / (2 - maxi - mini )

        ' calcul de la teinte t
 if r1 = maxi then t = ( v1 - b1 ) / ecart
 if v1 = maxi then t = 2 + ((b1 - r1) / ecart)
 if b1 = maxi then t = 4 + ((r1 - v1) / ecart)
    end_if

    ' conversion de la teinte dans l'interval [0,1]
    t = t / 6
end_sub
' ------------------------------------------------------------------------------
sub TSL2RVB(t1,s1,l1)
    dim_local var1,var2

    If s1 = 0
        r% = int(l1*255)
        v% = int(l1*255)
        b% = int(l1*255)
    else
        if (l1 < 0.5)
            var2 = l1 * (1 + s1)
        else
            var2 = (l1 + s1) - (s1 * l1)
        end_if
        var1 = 2 * l1 - var2

        r% = 255 * teinteRVB(var1,var2,t1 + (1 / 3))
        v% = 255 * teinteRVB(var1,var2,t1 )
        b% = 255 * teinteRVB(var1,var2,t1 - (1 / 3))
   end_If
end_sub
' ------------------------------------------------------------------------------
fnc teinteRVB(v1,v2,vT)
   if vT < 0 then vT = vT + 1
   if vT > 1 then vT = vT - 1
   if  6 * vT < 1 then result (v1 + (v2 - v1) * 6 * vT) : exit_fnc
   if  2 * vT < 1 then result (v2 )  : exit_fnc
   if  3 * vT < 2 then result (v1 + (v2 - v1) * ((2 / 3) - vT) * 6)  : exit_fnc
   result v1
end_fnc
' ------------------------------------------------------------------------------
choixteinte:
    ' dterminer les valeurs RVB de la teinte clique
    r% = color_pixel_red(1,mouse_x_position(1),mouse_y_position(1))
    v% = color_pixel_green(1,mouse_x_position(1),mouse_y_position(1))
    b% = color_pixel_blue(1,mouse_x_position(1),mouse_y_position(1))

    creerDegrade()
return
' ------------------------------------------------------------------------------