' Rception satellites GNSS (Golocalisation et Navigation par un Systme de Satellites)
' Dcodage trames NMEA 0183
' Module GNSS PA1616S de chez Adafruit
' Rception GNSS :
'   - GPS (satellites amricains)
' Marc  - Avril 2022
' Programme crit en langage Panoramic

dim portCom%, parity%, sPortCom$, sBaudRate$, sParity$, sDataBit$, sStopBit$, serialOnOff% 
dim repertoire$, info$, boucle%, buffer$, trame$, char$, char1$, recept$, pos%
dim fin$, i%, j%, champ%, donnee$, field$, analyse%, memoCible%
dim GPRMC$(40), GPVTG$(40), GPGGA$(40), GPGSA$(40), GPGSV$(100), GLGSV$(100), GPGLL$(40) 
dim latitude$, longitude$, hr$, dt$, kh$, tmp, temp$
dim kph, mm, dd, ss, kn, cap, sat, nTrame%, prn$ 

label afficheFenetreSerial, fermerFenetreSerial, creerLiaisonSerie, onOffSerie
label choixPortCom, choixBaudrate, choixNbBits, choixParity, choixBitstop
label analyserData, clearData, enregistrer, quitter

repertoire$ = dir_current$ + "\"
fin$ = chr$(13) + chr$(10)
memoCible% = 16

interfaceUtilisateur()
chargerFichierConfiguration()
start()

end


sub start()
    if sPortCom$ = ""
        trigger_click 2
    end_if
end_sub


sub interfaceUtilisateur()
    width 0,width(0) - width_client(0) + 1170
    height 0,height(0) - height_client(0) + 700
    top 0,(screen_y - height(0)) / 2
    left 0,(screen_x - width(0)) / 2 
    color 0,50,50,50
    caption 0,"Panoramic GNSS monitor pour le module PA1616S Adafruit"
    on_close 0,quitter

    serial 35
    
    boutonOnOff(20,45)
    boutonSerialConfig(20,85)
    boutonClear(20,125)
    boutonOverwiew(20,165)
    creerFenetreTrafficSat(130,19)
    creerTitre(35,220)
    creerAffichageGPRMC(130,370)
    creerAffichageGPVTG(130,370)
    creerAffichageGPGGA(130,370)
    creerAffichageGPGSA(130,370)
    creerAffichageGPGSV(130,370)
    creerAffichageGLGSV(130,370)
    creerAffichageGPGLL(130,370)
    creerAffichageGlobal(130,370)
    creerFenetreSerial()
end_sub

sub boutonOnOff(x%,y%)
    button_picture 1
    left 1,x%
    top 1,y%
    width 1,90
    height 1,30
    button_picture_target_is_picture
    width 1,15
    height 1,15
    color 1,255,0,0
    caption 1,"  ON/OFF"
    on_click 1,onOffSerie
    inactive 1
end_sub

sub boutonSerialConfig(x%,y%)
    button 2
    top 2,y%
    left 2,x%
    width 2,90
    height 2,30
    caption 2,"Serial settings"
    on_click 2,afficheFenetreSerial
end_sub

sub boutonClear(x%,y%)
    button 3
    top 3,y%
    left 3,x%
    width 3,90
    height 3,30
    caption 3,"Clear Data"
    on_click 3,clearData
end_sub

sub boutonOverwiew(x%,y%)
    button 4
    top 4,y%
    left 4,x%
    width 4,90
    height 4,30
    caption 4,"Overview"
    on_click 4,analyserData
end_sub

sub creerFenetreTrafficSat(x%,y%)
    alpha 10
    top 10,y%
    left 10,x% + 10
    font_color 10,255,255,255
    font_name 10,"Arial"
    font_size 10,12
    caption 10,"NMEA data log:"

    memo 11
    top 11,y% + 25
    left 11,x%
    width 11,1010
    height 11,300
    bar_vertical 11
    color 11,0,0,0
    font_size 11,10
    font_color 11,255,255,255
end_sub

sub creerTitre(x%,y%)
    picture 40
    width 40,53
    height 40,453
    top 40,y%
    left 40,x%
    color 40,50,50,50
    
    2d_target_is 40
    2d_pen_color 255,255,0
    ' lettre r
    2d_line 16,2,26,2
    2d_line 16,2,16,8
    2d_line 17,7,17,11
    2d_line 18,10,18,12
    2d_line 19,11,19,13
    2d_line 20,12,20,14
    2d_line 20,13,23,13
    2d_line 22,14,24,14
    2d_line 17,15,23,15
    2d_line 17,15,17,25
    2d_line 17,24,51,24
    2d_line 50,24,50,14
    2d_line 30,15,51,15
    2d_line 27,14,31,14
    2d_line 26,13,28,13
    2d_line 25,12,27,12
    2d_line 25,10,25,13
    2d_line 24,2,24,11
    ' lettre O
    2d_line 29,31,39,31
    2d_line 38,32,42,32
    2d_line 41,33,44,33
    2d_line 43,34,45,34
    2d_line 44,35,47,35
    2d_line 46,36,48,36
    2d_line 47,36,47,39
    2d_line 48,38,48,40
    2d_line 49,39,49,42
    2d_line 50,41,50,46
    2d_line 51,45,51,55
    2d_line 50,54,50,58
    2d_line 49,57,49,60
    2d_line 48,59,48,62
    2d_line 47,61,47,63
    2d_line 46,62,46,64
    2d_line 45,63,45,65
    2d_line 43,64,46,64
    2d_line 41,65,44,65
    2d_line 38,66,42,66
    2d_line 29,67,39,67
    2d_line 26,66,30,66
    2d_line 24,65,27,65
    2d_line 23,64,25,64
    2d_line 21,63,24,63
    2d_line 20,62,22,62
    2d_line 20,60,20,63
    2d_line 19,59,19,61
    2d_line 18,57,18,60
    2d_line 17,53,17,58
    2d_line 16,44,16,54
    2d_line 17,41,17,45
    2d_line 18,39,18,42
    2d_line 19,37,19,40
    2d_line 20,36,20,38
    2d_line 21,35,21,37
    2d_line 22,34,22,36
    2d_line 22,34,25,34
    2d_line 24,33,27,33
    2d_line 26,32,30,32
    2d_line 28,41,39,41
    2d_line 38,42,42,42
    2d_line 41,43,43,43
    2d_line 42,44,44,44
    2d_line 43,45,45,45
    2d_line 44,45,44,53
    2d_line 43,52,43,55
    2d_line 42,54,42,56
    2d_line 41,55,41,57
    2d_line 38,56,42,56
    2d_line 29,57,39,57
    2d_line 26,56,30,56
    2d_line 25,55,27,55
    2d_line 24,54,26,54
    2d_line 24,52,24,55
    2d_line 23,45,23,53
    2d_line 24,44,24,46
    2d_line 25,43,25,45
    2d_line 26,42,26,44
    2d_line 26,42,29,42
    ' lettre t
    2d_line 17,71,25,71
    2d_line 24,71,24,80
    2d_line 24,79,43,79
    2d_line 42,78,44,78
    2d_line 43,77,45,77
    2d_line 44,71,44,78
    2d_line 43,71,51,71
    2d_line 50,71,50,74
    2d_line 51,73,51,82
    2d_line 50,81,50,84
    2d_line 49,83,49,86
    2d_line 48,85,48,87
    2d_line 46,86,49,86
    2d_line 44,87,47,87
    2d_line 24,88,45,88
    2d_line 24,88,24,94
    2d_line 17,93,25,93
    2d_line 17,88,17,94
    2d_line 10,88,18,88
    2d_line 9,87,11,87
    2d_line 9,83,9,88
    2d_line 8,79,8,84
    2d_line 7,79,7,81
    2d_line 7,79,18,79
    2d_line 17,71,17,80
    ' lettre i
    2d_line 4,100,9,100
    2d_line 8,101,10,101
    2d_line 9,102,11,102
    2d_line 10,103,12,103
    2d_line 11,103,11,109
    2d_line 10,108,10,110
    2d_line 9,109,11,109
    2d_line 8,110,10,110
    2d_line 4,111,9,111
    2d_line 3,110,5,110
    2d_line 2,109,4,109
    2d_line 1,108,3,108
    2d_line 1,103,1,109
    2d_line 1,103,3,103
    2d_line 2,102,4,103
    2d_line 3,101,5,101
    2d_line 17,101,51,101
    2d_line 50,101,50,111
    2d_line 17,110,51,110
    2d_line 17,101,17,111
    ' lettre n
    2d_line 25,119,51,119
    2d_line 50,119,50,129
    2d_line 27,128,51,128
    2d_line 25,129,28,129
    2d_line 24,130,26,130
    2d_line 23,131,25,131
    2d_line 23,131,23,139
    2d_line 23,138,25,138
    2d_line 24,139,26,139
    2d_line 25,140,27,140
    2d_line 26,141,28,141
    2d_line 27,142,51,142
    2d_line 50,142,50,152
    2d_line 17,151,51,151
    2d_line 17,142,17,152
    2d_line 17,142,23,142
    2d_line 22,140,22,143
    2d_line 20,140,23,140
    2d_line 19,139,21,139
    2d_line 18,138,20,138
    2d_line 18,136,18,139
    2d_line 17,134,17,137
    2d_line 16,127,16,135
    2d_line 17,124,17,128
    2d_line 18,123,18,125
    2d_line 19,122,19,124
    2d_line 19,122,21,122
    2d_line 20,121,23,121
    2d_line 22,120,26,120
    ' lettre o
    2d_line 29,158,39,158
    2d_line 38,159,42,159
    2d_line 41,160,44,160
    2d_line 43,161,45,161
    2d_line 44,162,47,162
    2d_line 46,163,48,163
    2d_line 47,163,47,166
    2d_line 48,165,48,167
    2d_line 49,166,49,169
    2d_line 50,168,50,173
    2d_line 51,172,51,182
    2d_line 50,181,50,185
    2d_line 49,184,49,187
    2d_line 48,186,48,189
    2d_line 47,188,47,190
    2d_line 46,189,46,191
    2d_line 45,190,45,192
    2d_line 43,191,46,191
    2d_line 41,192,44,192
    2d_line 38,193,42,193
    2d_line 29,194,39,194
    2d_line 26,193,30,193
    2d_line 24,192,27,192
    2d_line 23,191,25,191
    2d_line 21,190,24,190
    2d_line 20,189,22,189
    2d_line 20,187,20,190
    2d_line 19,186,19,188
    2d_line 18,184,18,187
    2d_line 17,180,17,185
    2d_line 16,171,16,181
    2d_line 17,168,17,172
    2d_line 18,166,18,169
    2d_line 19,164,19,167
    2d_line 20,163,20,165
    2d_line 21,162,21,164
    2d_line 22,161,22,163
    2d_line 22,161,25,161
    2d_line 24,160,27,160
    2d_line 26,159,30,159
    2d_line 28,168,39,168
    2d_line 38,169,42,169
    2d_line 41,170,43,170
    2d_line 42,171,44,171
    2d_line 43,172,45,172
    2d_line 44,172,44,180
    2d_line 43,179,43,182
    2d_line 42,181,42,183
    2d_line 41,182,41,184
    2d_line 38,183,42,183
    2d_line 29,184,39,184
    2d_line 26,183,30,183
    2d_line 25,182,27,182
    2d_line 24,181,26,181
    2d_line 24,179,24,182
    2d_line 23,172,23,180
    2d_line 24,171,24,173
    2d_line 25,170,25,172
    2d_line 26,169,26,171
    2d_line 26,169,29,169
    ' lettre m
    2d_line 25,200,51,200
    2d_line 50,200,50,210
    2d_line 27,209,51,209
    2d_line 25,210,28,210
    2d_line 24,211,26,211
    2d_line 23,212,25,212
    2d_line 23,212,23,219
    2d_line 24,218,24,221
    2d_line 24,220,27,220
    2d_line 26,221,29,221
    2d_line 28,222,51,222
    2d_line 50,222,50,232
    2d_line 27,231,51,231
    2d_line 25,232,28,232
    2d_line 24,233,26,233
    2d_line 23,234,25,234
    2d_line 23,234,23,241
    2d_line 24,240,24,243
    2d_line 25,242,25,244
    2d_line 25,243,28,243
    2d_line 27,244,51,244
    2d_line 50,244,50,254
    2d_line 17,253,51,253
    2d_line 17,244,17,254
    2d_line 17,244,23,244
    2d_line 22,242,22,245
    2d_line 20,242,23,242
    2d_line 19,241,21,241
    2d_line 19,239,19,242
    2d_line 18,238,18,240
    2d_line 17,235,17,239
    2d_line 16,229,16,236
    2d_line 17,227,17,230
    2d_line 18,225,18,228
    2d_line 19,224,19,226
    2d_line 19,224,22,224
    2d_line 22,221,22,224
    2d_line 21,220,21,222
    2d_line 20,219,20,221
    2d_line 19,218,19,220
    2d_line 18,217,18,219
    2d_line 17,214,17,218
    2d_line 16,207,16,215
    2d_line 17,205,17,208
    2d_line 18,204,18,206
    2d_line 19,203,19,205
    2d_line 20,202,20,204
    2d_line 20,202,23,202
    2d_line 22,201,26,201
    ' lettre S
    2d_line 5,282,14,282
    2d_line 12,282,12,285
    2d_line 11,284,11,288
    2d_line 10,287,10,298
    2d_line 11,297,11,300
    2d_line 12,299,12,301
    2d_line 13,300,13,302
    2d_line 13,301,19,301
    2d_line 18,300,20,300
    2d_line 19,299,21,299
    2d_line 20,298,22,298
    2d_line 21,296,21,299
    2d_line 22,294,22,297
    2d_line 23,292,23,295
    2d_line 24,290,24,293
    2d_line 25,288,25,291
    2d_line 26,286,26,289
    2d_line 27,285,27,287
    2d_line 28,284,28,286
    2d_line 29,283,29,285
    2d_line 30,282,30,284
    2d_line 31,281,31,283
    2d_line 31,281,35,281
    2d_line 34,280,42,280
    2d_line 41,281,45,281
    2d_line 44,282,46,282
    2d_line 45,283,47,283
    2d_line 46,284,48,284
    2d_line 47,285,49,285
    2d_line 48,285,48,288
    2d_line 49,287,49,290
    2d_line 50,289,50,294
    2d_line 51,293,51,305
    2d_line 50,304,50,309
    2d_line 49,308,49,312
    2d_line 39,311,50,311
    2d_line 40,310,42,310
    2d_line 41,308,41,312
    2d_line 42,306,42,309
    2d_line 43,303,43,307
    2d_line 44,294,44,304
    2d_line 43,292,43,295
    2d_line 42,291,42,293
    2d_line 41,290,41,292
    2d_line 36,290,42,290
    2d_line 34,291,37,291
    2d_line 34,291,34,294
    2d_line 33,293,33,295
    2d_line 32,294,32,297
    2d_line 31,296,31,299
    2d_line 30,298,30,302
    2d_line 29,301,29,304
    2d_line 28,303,28,306
    2d_line 27,305,27,307
    2d_line 26,306,26,308
    2d_line 25,307,25,309
    2d_line 24,308,24,310
    2d_line 22,309,25,309
    2d_line 20,310,23,310
    2d_line 13,311,21,311
    2d_line 11,310,14,310
    2d_line 9,309,12,309
    2d_line 8,308,10,308
    2d_line 7,307,9,307
    2d_line 6,306,8,306
    2d_line 6,304,6,307
    2d_line 5,302,5,305
    2d_line 4,298,4,303
    2d_line 3,287,3,299
    2d_line 4,283,4,288
    2d_line 5,282,5,284
    ' lettre S
    2d_line 5,320,14,320
    2d_line 12,320,12,323
    2d_line 11,322,11,326
    2d_line 10,325,10,336
    2d_line 11,335,11,338
    2d_line 12,337,12,339
    2d_line 13,338,13,340
    2d_line 13,339,19,339
    2d_line 18,338,20,338
    2d_line 19,337,21,337
    2d_line 20,336,22,336
    2d_line 21,334,21,337
    2d_line 22,332,22,335
    2d_line 23,330,23,333
    2d_line 24,328,24,331
    2d_line 25,326,25,329
    2d_line 26,324,26,327
    2d_line 27,323,27,325
    2d_line 28,322,28,324
    2d_line 29,321,29,323
    2d_line 30,320,30,322
    2d_line 31,319,31,321
    2d_line 31,319,35,319
    2d_line 34,318,42,318
    2d_line 41,319,45,319
    2d_line 44,320,46,320
    2d_line 45,321,47,321
    2d_line 46,322,48,322
    2d_line 47,323,49,323
    2d_line 48,323,48,326
    2d_line 49,325,49,328
    2d_line 50,327,50,332
    2d_line 51,331,51,343
    2d_line 50,342,50,347
    2d_line 49,346,49,350
    2d_line 39,349,50,349
    2d_line 40,348,42,348
    2d_line 41,346,41,350
    2d_line 42,344,42,347
    2d_line 43,341,43,345
    2d_line 44,332,44,342
    2d_line 43,330,43,333
    2d_line 42,329,42,331
    2d_line 41,328,41,330
    2d_line 36,328,42,328
    2d_line 34,329,37,329
    2d_line 34,329,34,332
    2d_line 33,331,33,333
    2d_line 32,332,32,335
    2d_line 31,334,31,337
    2d_line 30,336,30,340
    2d_line 29,339,29,342
    2d_line 28,341,28,344
    2d_line 27,343,27,345
    2d_line 26,344,26,346
    2d_line 25,345,25,347
    2d_line 24,346,24,348
    2d_line 22,347,25,347
    2d_line 20,348,23,348
    2d_line 13,349,21,349
    2d_line 11,348,14,348
    2d_line 9,347,12,347
    2d_line 8,346,10,346
    2d_line 7,345,9,345
    2d_line 6,344,8,344
    2d_line 6,342,6,345
    2d_line 5,340,5,343
    2d_line 4,336,4,341
    2d_line 3,325,3,337
    2d_line 4,321,4,326
    2d_line 5,320,5,322
    ' lettre N
    2d_line 4,358,51,358
    2d_line 50,358,50,369
    2d_line 18,389,50,367
    2d_line 19,389,51,367
    2d_line 18,389,18,392
    2d_line 18,391,51,391
    2d_line 50,391,50,401
    2d_line 4,400,51,400
    2d_line 4,389,4,401
    2d_line 4,389,35,368
    2d_line 5,389,36,368
    2d_line 35,367,35,370
    2d_line 4,367,36,367
    2d_line 4,358,4,368          
    ' lettre G
    2d_line 24,410,48,410
    2d_line 47,411,49,411
    2d_line 48,411,48,414
    2d_line 49,413,49,417
    2d_line 50,416,50,421
    2d_line 51,420,51,433
    2d_line 50,432,50,437
    2d_line 49,436,49,440
    2d_line 48,439,48,442
    2d_line 47,441,47,443
    2d_line 46,442,46,444
    2d_line 45,443,45,446
    2d_line 44,445,44,447
    2d_line 42,446,45,446
    2d_line 41,447,43,447
    2d_line 39,448,42,448
    2d_line 37,449,40,449
    2d_line 33,450,38,450
    2d_line 23,451,34,451
    2d_line 19,450,24,450
    2d_line 17,449,20,449
    2d_line 15,448,18,448
    2d_line 13,447,16,447
    2d_line 12,446,14,446
    2d_line 11,445,13,445
    2d_line 10,444,12,444
    2d_line 9,443,11,443
    2d_line 8,442,10,442
    2d_line 7,441,9,441
    2d_line 7,439,7,442
    2d_line 6,437,6,440
    2d_line 5,435,5,438
    2d_line 4,430,4,436
    2d_line 3,418,3,431
    2d_line 4,414,4,419
    2d_line 5,412,5,415
    2d_line 5,412,15,412
    2d_line 13,412,13,415
    2d_line 12,414,12,419
    2d_line 11,418,11,431
    2d_line 12,430,12,434
    2d_line 13,433,13,436
    2d_line 14,435,14,437
    2d_line 15,436,15,438
    2d_line 16,437,16,439
    2d_line 17,438,17,440
    2d_line 17,439,20,439
    2d_line 19,440,23,440
    2d_line 22,441,34,441
    2d_line 33,440,37,440
    2d_line 36,439,38,439
    2d_line 37,438,40,438
    2d_line 39,437,41,437
    2d_line 40,436,42,436
    2d_line 41,434,41,437
    2d_line 42,431,42,435
    2d_line 43,422,43,432
    2d_line 42,420,42,423
    2d_line 32,420,43,420
    2d_line 32,420,32,430
    2d_line 24,429,33,429
    2d_line 24,410,24,430
end_sub

sub creerAffichageGPRMC(x%,y%)
    dim_local texte$, finLigne$
    command_target_is 0
    finLigne$ = chr$(32)+string$(150,chr$(46))
    
    create_hide
    panel 100
    width 100,1024
    height 100,310
    color 100,50,50,50
    left 100,x%
    top 100,y%
    create_show
    
    command_target_is 100

    picture 101
    width 101,1024
    height 101,310
    color 101,50,50,50
    
    list 102
    top 102,50
    left 102,0
    width 102,500
    height 102,250
    color 102,0,0,0
    font_color 102,255,255,255
    font_name 102,"Arial"
    font_size 102,10
    item_add 102,"Message ID" + finLigne$
    item_add 102,"UTC time, the format is hhmmss.sss" + finLigne$
    item_add 102,"Positioning status, A=effective positioning, V=invalid positioning" + finLigne$
    item_add 102,"Latitude, the format is ddmm.mmmmmmm" + finLigne$
    item_add 102,"Latitude hemisphere, N or S (north latitude or south latitude)" + finLigne$
    item_add 102,"Longitude, the format is dddmm.mmmmmmm" + finLigne$
    item_add 102,"Longitude hemisphere, E or W (east longitude or west longitude)" + finLigne$
    item_add 102,"Ground speed in knots" + finLigne$
    item_add 102,"Ground heading (take true north as the reference datum)" + finLigne$
    item_add 102,"UTC date, the format is ddmmyy (day, month, year" + finLigne$
    item_add 102,"Magnetic declination (000.0~180.0 degrees)" + finLigne$
    item_add 102,"Magnetic declination direction, E (east) or W (west)" + finLigne$
    item_add 102,"Mode positioning (A=autonomous, D=differential, E=estimation, N=invalid data)" + finLigne$
    item_add 102,"Statement end marker" + finLigne$
    item_add 102,"XOR check value of all bytes starting from $ to *" + finLigne$
    
    memo 103
    top 103,50
    left 103,480
    width 103,100
    height 103,250
    color 103,0,0,0
    font_color 103,255,255,255
    font_name 103,"Arial"
    font_size 103,10

    ' titre
    alpha 104
    top 104,10
    left 104,206
    font_color 104,255,255,255
    font_name 104,"Arial"
    font_size 104,20
    caption 104,"$GPRMC"
    
    ' titre (suite)
    alpha 105
    top 105,17
    left 105,336
    font_color 105,255,255,255
    font_name 105,"Arial"
    font_size 105,16
    font_italic 105
    caption 105,"Recommended Minimum Navigation Information "
  
    ' heure
    alpha 107
    top 107,75
    left 107,650
    font_color 107,255,255,255
    font_name 107,"Arial"
    font_size 107,12
    caption 107,"UTC time:"
    
    ' date
    alpha 108
    top 108,120
    left 108,650
    font_color 108,255,255,255
    font_name 108,"Arial"
    font_size 108,12
    caption 108,"UTC date:"

    ' latitude
    alpha 109
    top 109,165
    left 109,650
    font_color 109,255,255,255
    font_name 109,"Arial"
    font_size 109,12
    caption 109,"Latitude:"

    ' longitude
    alpha 110
    top 110,210
    left 110,650
    font_color 110,255,255,255
    font_name 110,"Arial"
    font_size 110,12
    caption 110,"Longitude:"

    ' vitesse au sol
    alpha 111
    top 111,255
    left 111,650
    font_color 111,255,255,255
    font_name 111,"Arial"
    font_size 111,12
    caption 111,"Ground speed kph:"

    ' indication de l'heure
    alpha 115
    top 115,72
    left 115,810
    font_color 115,255,255,0
    font_name 115,"Consolas"
    font_size 115,14
   
    ' indication de la date
    alpha 116
    top 116,117
    left 116,810
    font_color 116,255,255,0
    font_name 116,"Consolas"
    font_size 116,14
    
    ' indication de la latitude
    alpha 117
    top 117,162
    left 117,810
    font_color 117,255,255,0
    font_name 117,"Consolas"
    font_size 117,14
    
    ' indication de la longitude
    alpha 118
    top 118,207
    left 118,810
    font_color 118,255,255,0
    font_name 118,"Consolas"
    font_size 118,14
    
    ' indication de la vitesse en km/h
    alpha 119
    top 119,252
    left 119,810
    font_color 119,255,255,0
    font_name 119,"Consolas"
    font_size 119,14

    hide 100
end_sub

sub creerAffichageGPVTG(x%,y%)
    dim_local texte$, finLigne$
    command_target_is 0
    finLigne$ = chr$(32)+string$(150,chr$(46))
    
    create_hide
    panel 130
    width 130,1024
    height 130,310
    color 130,50,50,50
    left 130,x%
    top 130,y%
    create_show

    command_target_is 130

    picture 131
    width 131,1024
    height 131,310
    color 131,50,50,50
    
    list 132
    top 132,90
    left 132,0
    width 132,500
    height 132,205
    color 132,0,0,0
    font_color 132,255,255,255
    font_name 132,"Arial"
    font_size 132,10
    item_add 132,"Message ID" + finLigne$
    item_add 132,"Track made good, degrees True" + finLigne$
    item_add 132,"Fixed text 'T' indicates that track made good is relative to true north" + finLigne$
    item_add 132,"Track made good, degrees Magnetic" + finLigne$
    item_add 132,"Fixed text 'M' indicates Magnetic track indicator" + finLigne$
    item_add 132,"Speed over ground in knots" + finLigne$
    item_add 132,"Nautical speed indicator (N = Knots)" + finLigne$
    item_add 132,"Speed over ground in kilometres/hour" + finLigne$
    item_add 132,"Kilometre/hour speed indicator (K = kph)" + finLigne$
    item_add 132,"Mode positioning (A=autonomous, D=differential, E=estimation, N=invalid data)" + finLigne$
    item_add 132,"Statement end marker" + finLigne$
    item_add 132,"XOR check value of all bytes starting from $ to *" + finLigne$
    
    memo 133
    top 133,90
    left 133,480
    width 133,100
    height 133,205
    color 133,0,0,0
    font_color 133,255,255,255
    font_name 133,"Arial"
    font_size 133,10

    ' titre
    alpha 134
    top 134,30
    left 134,263
    font_color 134,255,255,255
    font_name 134,"Arial"
    font_size 134,20
    caption 134,"$GPVTG"
    
    ' titre (suite)
    alpha 135
    top 135,37
    left 135,393
    font_color 135,255,255,255
    font_name 135,"Arial"
    font_size 135,16
    font_italic 135
    caption 135,"Track made good and ground speed "

    ' lgende vitesse au sol en Noeuds
    alpha 136
    top 136,187
    left 136,650
    font_color 136,255,255,255
    font_name 136,"Arial"
    font_size 136,12
    caption 136,"Ground speed in knots:"

    ' lgende  vitesse au sol en km/h  
    alpha 137
    top 137,247
    left 137,650
    font_color 137,255,255,255
    font_name 137,"Arial"
    font_size 137,12
    caption 137,"Ground speed in kph:"

    ' lgende cap par rapport au nord  
    alpha 138
    top 138,127
    left 138,650
    font_color 138,255,255,255
    font_name 138,"Arial"
    font_size 138,12
    caption 138,"Track in degrees true:"

    ' indication de "track, degrees true"
    alpha 143
    top 143,125
    left 143,820
    font_color 143,255,255,0
    font_name 143,"Consolas"
    font_size 143,14

    ' indication de la vitesse en noeuds
    alpha 144
    top 144,185
    left 144,820
    font_color 144,255,255,0
    font_name 144,"Consolas"
    font_size 144,14
    
    ' indication de la vitesse en km/h
    alpha 145
    top 145,245
    left 145,820
    font_color 145,255,255,0
    font_name 145,"Consolas"
    font_size 145,14

    ' dessiner boussole
    creerBoussole(880,73)

    hide 130
end_sub

sub creerBoussole(x%,y%)
    picture 139
    hide 139
    width 139,281
    height 139,281
    color 139,50,50,50

    2d_target_is 139
    2d_pen_color 255,255,255
    tracerCercle(140,140,140)
    2d_flood 75,75,255,255,255

    ' aiguille cot rouge
    2d_pen_color 200,0,0
    2d_poly_from 140,4
    2d_poly_to 114,140
    2d_poly_to 166,140
    2d_poly_to 140,4
    2d_flood 137,77,200,0,0

    ' aiguille cot gris
    2d_poly_from 114,140
    2d_poly_to 140,276 
    2d_poly_to 166,140
    2d_flood 135,163,200,200,200    
    image 140
    2d_image_copy 140,0,0,281,281

    command_target_is 0

    scene3d 141
    parent 141,130
    width 141,71
    height 141,71
    left 141,x%
    top 141,y%
    color 141,50,50,50
    3d_plane 142
    3d_v_tile 142,1
    3d_u_tile 142,1
    cam_position 0,0,55
    3d_image_texture 142,140
end_sub

sub tracerCercle(cx%,cy%,rayon%)
    dim_local x%, y%, m%
    x% = 0
    y% = rayon%             
    m% = 5 - 4*rayon%       
    while x% <= y%
        2d_point x%+cx%,y%+cy%
        2d_point x%*(-1)+cx%,y%+cy%
        2d_point x%+cx%,y%*(-1)+cy%
        2d_point x%*(-1)+cx%,y%*(-1)+cy%
        2d_point y%+cx%,x%+cy%
        2d_point y%+cx%,x%*(-1)+cy%
        2d_point y%*(-1)+cx%,x%+cy%
        2d_point y%*(-1)+cx%,x%*(-1)+cy%
        if m% > 0	
            y% = y% - 1
            m% = m% - 8*y%
        end_if
        x% = x% + 1
        m% = m% + 8*x% + 4
    end_while
end_sub


sub creerAffichageGPGGA(x%,y%)
    dim_local texte$, finLigne$
    command_target_is 0
    finLigne$ = chr$(32)+string$(150,chr$(46))
    
    create_hide
    panel 160
    width 160,1024
    height 160,310
    color 160,50,50,50
    left 160,x%
    top 160,y%
    create_show

    command_target_is 160

    picture 161
    width 161,1024
    height 161,310
    color 161,50,50,50
    
    list 162
    top 162,10
    left 162,0
    width 162,500
    height 162,290
    color 162,0,0,0
    font_color 162,255,255,255
    font_name 162,"Arial"
    font_size 162,10
    item_add 162,"Message ID" + finLigne$
    item_add 162,"UTC time, the format is hhmmss.sss" + finLigne$
    item_add 162,"Latitude, the format is ddmm.mmmmmmm" + finLigne$
    item_add 162,"Latitude hemisphere, N or S (north latitude or south latitude)" + finLigne$
    item_add 162,"Longitude, the format is dddmm.mmmmmmm" + finLigne$
    item_add 162,"Longitude hemisphere, E or W (east longitude or west longitude)" + finLigne$
    item_add 162,"Position Fix Indicator" + finLigne$
    item_add 162,"Number of satellites in use. May be different to the number in view" + finLigne$
    item_add 162,"HDOP : Horizontal Dilution of Precision" + finLigne$
    item_add 162,"Antenna altitude above/below mean sea level" + finLigne$
    item_add 162,"Units of antenna altitude (M = meters)" + finLigne$
    item_add 162,"Undulation - the relationship between the geoid and the WGS84 ellipsoid" + finLigne$
    item_add 162,"Units of undulation (M = meters)" + finLigne$
    item_add 162,"Age of correction data (in seconds)" + finLigne$
    item_add 162,"Differential base station ID" + finLigne$
    item_add 162,"Statement end marker" + finLigne$
    item_add 162,"XOR check value of all bytes starting from $ to *" + finLigne$
    
    memo 163
    top 163,10
    left 163,480
    width 163,100
    height 163,290
    color 163,0,0,0
    font_color 163,255,255,255
    font_name 163,"Arial"
    font_size 163,10

    ' titre
    alpha 164
    top 164,26
    left 164,631
    font_color 164,255,255,255
    font_name 164,"Arial"
    font_size 164,20
    caption 164,"$GPGGA"
    
    ' titre (suite)
    alpha 165
    top 165,33
    left 165,767
    font_color 165,255,255,255
    font_name 165,"Arial"
    font_size 165,16
    font_italic 165
    caption 165,"Fix data and undulation "

    ' lgende time
    alpha 166
    top 166,90
    left 166,650
    font_color 166,255,255,255
    font_name 166,"Arial"
    font_size 166,12
    caption 166,"UTC time:"

    ' lgende latitude
    alpha 167
    top 167,130
    left 167,650
    font_color 167,255,255,255
    font_name 167,"Arial"
    font_size 167,12
    caption 167,"Latitude:"

    ' lgende longitude
    alpha 168
    top 168,170
    left 168,650
    font_color 168,255,255,255
    font_name 168,"Arial"
    font_size 168,12
    caption 168,"Longitude:"

    ' lgende nombre de satellites utiliss
    alpha 169
    top 169,210
    left 169,650
    font_color 169,255,255,255
    font_name 169,"Arial"
    font_size 169,12
    caption 169,"Number of satellites:"

    ' lgende altitude en metres
    alpha 170
    top 170,250
    left 170,650
    font_color 170,255,255,255
    font_name 170,"Arial"
    font_size 170,12
    caption 170,"Antenna altitude:"

    ' indication de l'heure UTC
    alpha 171
    top 171,88
    left 171,810
    font_color 171,255,255,0
    font_name 171,"Consolas"
    font_size 171,14
    
    ' indication de la latitude
    alpha 172
    top 172,128
    left 172,810
    font_color 172,255,255,0
    font_name 172,"Consolas"
    font_size 172,14
    
    ' indication de la longitude
    alpha 173
    top 173,168
    left 173,810
    font_color 173,255,255,0
    font_name 173,"Consolas"
    font_size 173,14
    
    ' nombre de satellites utiliss
    alpha 174
    top 174,208
    left 174,810
    font_color 174,255,255,0
    font_name 174,"Consolas"
    font_size 174,14

    ' indication altitude en mtres
    alpha 175
    top 175,248
    left 175,810
    font_color 175,255,255,0
    font_name 175,"Consolas"
    font_size 175,14

    hide 160
end_sub

sub creerAffichageGPGSA(x%,y%)
    dim_local texte$, finLigne$
    command_target_is 0
    finLigne$ = chr$(32)+string$(150,chr$(46))
    
    create_hide
    panel 190
    width 190,1024
    height 190,310
    color 190,50,50,50
    left 190,x%
    top 190,y%
    create_show

    command_target_is 190

    picture 191
    width 191,1024
    height 191,310
    color 191,50,50,50
    
    list 192
    top 192,0
    left 192,445
    width 192,300
    height 192,310
    color 192,0,0,0
    font_color 192,255,255,255
    font_name 192,"Arial"
    font_size 192,9
    item_add 192,"Message ID" + finLigne$
    item_add 192,"Mode 2D / 3D: A=Automatique M=Manual" + finLigne$
    item_add 192,"Mode: 1=Fix not available 2=2D 3=3D" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"PRN number of satellite used in solution" + finLigne$
    item_add 192,"Position dilution of precision (PDOP)" + finLigne$
    item_add 192,"Horizontal dilution of precision (HDOP)" + finLigne$
    item_add 192,"Vertical dilution of precision (VDOP)" + finLigne$
    item_add 192,"Statement end marker" + finLigne$
    item_add 192,"XOR check value of all bytes starting from $ to *" + finLigne$
    
    memo 193
    top 193,0
    left 193,725
    width 193,100
    height 193,310
    color 193,0,0,0
    font_color 193,255,255,255
    font_name 193,"Arial"
    font_size 193,9

    memo 194
    top 194,0
    left 194,820
    width 194,100
    height 194,310
    color 194,0,0,0
    font_color 194,255,255,255
    font_name 194,"Arial"
    font_size 194,9

    ' titre
    alpha 195
    top 195,35
    left 195,166
    font_color 195,255,255,255
    font_name 195,"Arial"
    font_size 195,20
    caption 195,"$GPGSA"
    
    ' titre (suite)
    alpha 196
    top 196,80
    left 196,103
    font_color 196,255,255,255
    font_name 196,"Arial"
    font_size 196,16
    font_italic 196
    caption 196,"DOP and active satellites "


    alpha 197
    top 197,155
    left 197,75
    font_color 197,255,255,255
    font_name 197,"Arial"
    font_size 197,12
    caption 197,"PRN numbers of satellites used in solution:"

    alpha 198
    top 198,185
    left 198,95
    font_color 198,255,255,255
    font_name 198,"Arial"
    font_size 198,12
    caption 198,"01 to 32 = GPS satellite"
     
    alpha 199
    top 199,215
    left 199,95
    font_color 199,255,255,255
    font_name 199,"Arial"
    font_size 199,12
    caption 199,"65 to 96 =  GLONASS satellite"

    hide 190
end_sub

sub creerAffichageGPGSV(x%,y%)
    dim_local texte$, finLigne$
    command_target_is 0
    finLigne$ = chr$(32)+string$(150,chr$(46))
    
    create_hide
    panel 220
    width 220,1024
    height 220,310
    color 220,50,50,50
    left 220,x%
    top 220,y%
    create_show

    command_target_is 220

    picture 221
    width 221,1024
    height 221,310
    color 221,50,50,50
    
    list 222
    top 222,5
    left 222,440
    width 222,270
    height 222,300
    color 222,0,0,0
    font_color 222,255,255,255
    font_size 222,8
    item_add 222,"Message ID" + finLigne$
    item_add 222,"Total number of messages" + finLigne$
    item_add 222,"Message number" + finLigne$
    item_add 222,"Total number of satellites in view" + finLigne$
    item_add 222,"Satellite PRN number" + finLigne$
    item_add 222,"Elevation in degrees" + finLigne$
    item_add 222,"Azimuth in degrees True" + finLigne$
    item_add 222,"SNR (C/No) 00-99dB" + finLigne$
    item_add 222,"Satellite PRN number" + finLigne$
    item_add 222,"Elevation in degrees" + finLigne$
    item_add 222,"Azimuth in degrees True" + finLigne$
    item_add 222,"SNR (C/No) 00-99dB" + finLigne$
    item_add 222,"Satellite PRN number" + finLigne$
    item_add 222,"Elevation in degrees" + finLigne$
    item_add 222,"Azimuth in degrees True" + finLigne$
    item_add 222,"SNR (C/No) 00-99dB" + finLigne$
    item_add 222,"Satellite PRN number" + finLigne$
    item_add 222,"Elevation in degrees" + finLigne$
    item_add 222,"Azimuth in degrees True" + finLigne$
    item_add 222,"SNR (C/No) 00-99dB" + finLigne$
    item_add 222,"Statement end marker" + finLigne$
    item_add 222,"XOR check value of all bytes starting from $ to *" + finLigne$
    
    memo 223
    top 223,5
    left 223,707
    width 223,70
    height 223,300
    color 223,0,0,0
    font_color 223,255,255,255
    font_size 223,8

    memo 224
    top 224,5
    left 224,775
    width 224,70
    height 224,300
    color 224,0,0,0
    font_color 224,255,255,255
    font_size 224,8

    memo 225
    top 225,5
    left 225,843
    width 225,70
    height 225,300
    color 225,0,0,0
    font_color 225,255,255,255
    font_size 225,8

    memo 226
    top 226,5
    left 226,911
    width 226,70
    height 226,300
    color 226,0,0,0
    font_color 226,255,255,255
    font_size 226,8

    ' titre
    alpha 227
    top 227,40
    left 227,165
    font_color 227,255,255,255
    font_name 227,"Arial"
    font_size 227,20
    caption 227,"$GPGSV"
    
    ' titre (suite)
    alpha 228
    top 228,77
    left 228,117
    font_color 228,255,255,255
    font_name 228,"Arial"
    font_size 228,16
    font_italic 228
    caption 228,"GPS satellites in view "

    ' affichage bargraphes
    j% = 60
    for i% = 229 to 244
        progress_bar i%
        top i%,170
        left i%,j%
        vertical i%
        width i%,15
        height i%,101
        min i%,0
        max i%,99
        j% = j% + 21
    next i%

    ' affichage des Id PRN reus
    alpha 245
    top 245,275
    left 245,25
    font_color 245,255,255,0
    font_name 245,"Consolas"
    font_size 245,10
    
    ' lgende
    alpha 246
    top 246,145
    left 246,112
    font_color 246,255,255,255
    font_name 246,"Arial"
    font_size 246,10
    caption 246,"Total number of satellites in view:"
    
    ' affichage du nombre de satellites reus
    alpha 247
    top 247,145
    left 247,308
    font_color 247,255,255,0
    font_name 247,"Arial"
    font_size 247,10
    
    ' lgende "SNR"
    alpha 248
    top 248,196
    left 248,45
    font_color 248,0,130,255
    font_name 248,"Arial"
    font_bold 248
    font_size 248,10
    caption 248,"S"+chr$(10)+"N"+CHR$(10)+"R"

    ' rectangle dcor bleu sour le titre
    2d_target_is 221
    2d_pen_color 0,120,215
    2d_fill_color 0,120,215
    2d_rectangle 112,102,328,112
    
    hide 220
end_sub

sub creerAffichageGLGSV(x%,y%)
    dim_local texte$, finLigne$
    command_target_is 0
    finLigne$ = chr$(32)+string$(150,chr$(46))
    
    create_hide
    panel 250
    width 250,1024
    height 250,310
    color 250,50,50,50
    left 250,x%
    top 250,y%
    create_show

    command_target_is 250

    picture 251
    width 251,1024
    height 251,310
    color 251,50,50,50
    
    list 252
    top 252,5
    left 252,440
    width 252,270
    height 252,300
    color 252,0,0,0
    font_color 252,255,255,255
    font_size 252,8
    item_add 252,"Message ID" + finLigne$
    item_add 252,"Total number of messages" + finLigne$
    item_add 252,"Message number" + finLigne$
    item_add 252,"Total number of satellites in view" + finLigne$
    item_add 252,"Satellite PRN number" + finLigne$
    item_add 252,"Elevation in degrees" + finLigne$
    item_add 252,"Azimuth in degrees True" + finLigne$
    item_add 252,"SNR (C/No) 00-99dB" + finLigne$
    item_add 252,"Satellite PRN number" + finLigne$
    item_add 252,"Elevation in degrees" + finLigne$
    item_add 252,"Azimuth in degrees True" + finLigne$
    item_add 252,"SNR (C/No) 00-99dB" + finLigne$
    item_add 252,"Satellite PRN number" + finLigne$
    item_add 252,"Elevation in degrees" + finLigne$
    item_add 252,"Azimuth in degrees True" + finLigne$
    item_add 252,"SNR (C/No) 00-99dB" + finLigne$
    item_add 252,"Satellite PRN number" + finLigne$
    item_add 252,"Elevation in degrees" + finLigne$
    item_add 252,"Azimuth in degrees True" + finLigne$
    item_add 252,"SNR (C/No) 00-99dB" + finLigne$
    item_add 252,"Statement end marker" + finLigne$
    item_add 252,"XOR check value of all bytes starting from $ to *" + finLigne$
    
    memo 253
    top 253,5
    left 253,707
    width 253,70
    height 253,300
    color 253,0,0,0
    font_color 253,255,255,255
    font_size 253,8

    memo 254
    top 254,5
    left 254,775
    width 254,70
    height 254,300
    color 254,0,0,0
    font_color 254,255,255,255
    font_size 254,8

    memo 255
    top 255,5
    left 255,843
    width 255,70
    height 255,300
    color 255,0,0,0
    font_color 255,255,255,255
    font_size 255,8

    memo 256
    top 256,5
    left 256,911
    width 256,70
    height 256,300
    color 256,0,0,0
    font_color 256,255,255,255
    font_size 256,8

    ' titre
    alpha 257
    top 257,40
    left 257,165
    font_color 257,255,255,255
    font_name 257,"Arial"
    font_size 257,20
    caption 257,"$GLGSV"
    
    ' titre (suite)
    alpha 258
    top 258,77
    left 258,87
    font_color 258,255,255,255
    font_name 258,"Arial"
    font_size 258,16
    font_italic 258
    caption 258,"GLONASS satellites in view "

    ' affichage bargraphes
    j% = 60
    for i% = 259 to 274
        progress_bar i%
        top i%,170
        left i%,j%
        vertical i%
        width i%,15
        height i%,101
        min i%,0
        max i%,99
        j% = j% + 21
    next i%

    ' affichage des Id PRN reus
    alpha 275
    top 275,275
    left 275,25
    font_color 275,255,255,0
    font_name 275,"Consolas"
    font_size 275,10
    
    ' lgende
    alpha 276
    top 276,145
    left 276,112
    font_color 276,255,255,255
    font_name 276,"Arial"
    font_size 276,10
    caption 276,"Total number of satellites in view:"
    
    ' affichage du nombre de satellites reus
    alpha 277
    top 277,145
    left 277,308
    font_color 277,255,255,0
    font_name 277,"Arial"
    font_size 277,10
    
    ' lgende "SNR"
    alpha 278
    top 278,196
    left 278,45
    font_color 278,0,130,255
    font_name 278,"Arial"
    font_bold 278
    font_size 278,10
    caption 278,"S"+chr$(10)+"N"+CHR$(10)+"R"

    ' rectangle dcor bleu sour le titre
    2d_target_is 251
    2d_pen_color 0,120,215
    2d_fill_color 0,120,215
    2d_rectangle 82,102,356,112
    
    hide 250
end_sub

sub creerAffichageGPGLL(x%,y%)
    dim_local texte$, finLigne$
    command_target_is 0
    finLigne$ = chr$(32)+string$(150,chr$(46))
    
    create_hide
    panel 280
    width 280,1024
    height 280,310
    color 280,50,50,50
    left 280,x%
    top 280,y%
    create_show

    command_target_is 280

    picture 281
    width 281,1024
    height 281,310
    color 281,50,50,50
    
    list 282
    top 282,90
    left 282,0
    width 282,500
    height 282,170
    color 282,0,0,0
    font_color 282,255,255,255
    font_name 282,"Arial"
    font_size 282,10
    item_add 282,"Message ID" + finLigne$
    item_add 282,"Latitude, the format is ddmm.mmmmmmm" + finLigne$
    item_add 282,"Latitude hemisphere, N or S (north latitude or south latitude)" + finLigne$
    item_add 282,"Longitude, the format is dddmm.mmmmmmm" + finLigne$
    item_add 282,"Longitude hemisphere, E or W (east longitude or west longitude)" + finLigne$
    item_add 282,"UTC time, the format is hhmmss.sss" + finLigne$
    item_add 282,"Data status: A=Data valid, V=Data invalid" + finLigne$
    item_add 282,"Mode positioning (A=autonomous, D=differential, E=estimation, N=invalid data)" + finLigne$
    item_add 282,"Statement end marker" + finLigne$
    item_add 282,"XOR check value of all bytes starting from $ to *" + finLigne$
    
    memo 283
    top 283,90
    left 283,480
    width 283,100
    height 283,170
    color 283,0,0,0
    font_color 283,255,255,255
    font_name 283,"Arial"
    font_size 283,10

    ' titre
    alpha 284
    top 284,40
    left 284,343
    font_color 284,255,255,255
    font_name 284,"Arial"
    font_size 284,20
    caption 284,"$GPGLL"
    
    ' titre (suite)
    alpha 285
    top 285,47
    left 285,473
    font_color 285,255,255,255
    font_name 285,"Arial"
    font_size 285,16
    font_italic 285
    caption 285,"Geographic Position "

    ' heure
    alpha 286
    top 286,120
    left 286,650
    font_color 286,255,255,255
    font_name 286,"Arial"
    font_size 286,12
    caption 286,"UTC time:"
    
    ' latitude
    alpha 287
    top 287,165
    left 287,650
    font_color 287,255,255,255
    font_name 287,"Arial"
    font_size 287,12
    caption 287,"Latitude:"

    ' longitude
    alpha 288
    top 288,210
    left 288,650
    font_color 288,255,255,255
    font_name 288,"Arial"
    font_size 288,12
    caption 288,"Longitude:"

    ' indication de l'heure
    alpha 289
    top 289,118
    left 289,780
    font_color 289,255,255,0
    font_name 289,"Consolas"
    font_size 289,14
   
    ' indication de la latitude
    alpha 290
    top 290,162
    left 290,780
    font_color 290,255,255,0
    font_name 290,"Consolas"
    font_size 290,14
    
    ' indication de la longitude
    alpha 291
    top 291,207
    left 291,780
    font_color 291,255,255,0
    font_name 291,"Consolas"
    font_size 291,14

    hide 280
end_sub

sub creerAffichageGlobal(x%,y%)
    dim_local n%, x1%
    command_target_is 0

    create_hide
    panel 13
    width 13,1024
    height 13,310
    left 13,x%
    top 13,y%
    create_show

    command_target_is 13

    picture 14
    width 14,1024
    height 14,310
    color 14,50,50,50
    
    for n% = 15 to 27 step 2
        alpha n%
        font_name n%,"Arial"
        font_size n%,11
        color n%,50,50,50
        font_color n%,255,255,255
        top n%,1
        left n%,x1%+25
        cursor_point n%
        on_click n%,analyserData
        
        memo n%+1
        top n%+1 ,25
        left n%+1,x1%
        height n%+1,280
        width n%+1,110
        color n%+1,0,0,0
        font_color n%+1,255,255,255
        on_click n%+1,analyserData

        x1% = x1% + 150
    next n%
    
    caption 15,"$GPRMC"
    caption 17,"$GPVTG"
    caption 19,"$GPGGA"
    caption 21,"$GPGSA"
    caption 23,"$GPGSV"
    caption 25,""
    caption 27,""
end_sub

sub creerFenetreSerial()
    dim_local n%
    command_target_is 0

    create_hide
    panel 70
    height 70,300
    width 70,290
    top 70,(height_client(0) - height(70))/2
    left 70,(width_client(0) - width(70))/2
    create_show
    
    ' picture fond du PANEL 70
    picture 71
    width 71,290
    height 71,300
    parent 71,70
    color 71,240,240,240
    2d_target_is 71
    2d_fill_off
    2d_pen_color 112,112,112
    2d_rectangle 0,0,290,300
    
    ' bandeau haut du PANEL 2
    picture 72
    parent 72,70
    width 72,287
    height 72,25
    top 72,1
    left 72,1
    2d_target_is 72
    2d_pen_color 0,0,60
    2d_fill_color 0,0,60
    2d_rectangle 10,9,13,16
    2d_rectangle 9,10,14,15
    2d_rectangle 8,11,15,14
    2d_line 14,12,47,12
    2d_line 18,11,20,11
    2d_line 19,10,21,10
    2d_line 20,9,23,9
    2d_line 22,8,24,8
    2d_line 23,7,26,7
    2d_line 25,6,28,6
    2d_rectangle 28,5,33,8
    2d_rectangle 29,4,32,9
    2d_line 23,13,25,13
    2d_line 24,14,26,14
    2d_line 25,15,28,15
    2d_line 27,16,29,16
    2d_line 28,17,31,17
    2d_line 30,18,35,18
    2d_rectangle 34,16,39,21
    2d_line 42,8,42,17
    2d_line 43,9,43,16
    2d_line 44,10,44,15
    2d_line 45,11,45,14
    2d_pen_color 0,0,0
    2d_fill_color 0,0,0
    2d_fill_off
    print_target_is 72
    print_locate 56,5
    print "Serial Port Configuration"

    ' croix blanche sur fond rouge
    picture 73    
    parent 73,70
    width 73,45
    height 73,24
    left 73,244
    top 73,1
    color 73,232,17,35
    2d_target_is 73
    2d_pen_color 241,107,118
    2d_line 18,7,27,16
    2d_line 17,8,26,17
    2d_line 17,15,26,6
    2d_line 18,16,27,7
    2d_pen_color 255,255,255
    2d_line 17,7,27,17
    2d_line 17,16,27,6
    cursor_point 73
    on_click 73,fermerFenetreSerial
    
    ' n port COM
    combo 74
    parent 74,70
    top 74,50
    left 74,124
    width 74,100
    height 74,25
    for n% = 1 to 255
        item_add 74,"COM" + str$(n%)
    next n%
    on_change 74,choixPortCom
    
    ' vitesse en bauds
    combo 75
    parent 75,70
    top 75,90
    left 75,124
    width 75,100
    height 75,25
    item_add 75,"110"
    item_add 75,"300"
    item_add 75,"600"
    item_add 75,"1200"
    item_add 75,"2400"
    item_add 75,"4800"
    item_add 75,"9600"
    item_add 75,"14400"
    item_add 75,"19200"
    item_add 75,"38400"
    item_add 75,"57600"
    item_add 75,"115200"
    on_change 75,choixBaudrate
    
    ' donnes : nombre bits
    combo 76
    parent 76,70
    top 76,130
    left 76,124
    width 76,100
    item_add 76,"5"
    item_add 76,"6"
    item_add 76,"7"
    item_add 76,"8"
    on_change 76,choixNbBits
    
    ' parit
    combo 77  
    parent 77,70
    top 77,170
    left 77,124
    width 77,100
    item_add 77,"Aucune"
    item_add 77,"Impaire"
    item_add 77,"Paire"
    on_change 77,choixParity
    
    ' bits d'arrt
    combo 78
    parent 78,70
    top 78,210
    left 78,124
    width 78,100
    item_add 78,"1"
    item_add 78,"1.5"
    item_add 78,"2"
    on_change 78,choixBitstop
 
    ' bouton "Dfinir par dfaut"
    button 80
    parent 80,70
    top 80,260
    left 80,21
    width 80,108
    caption 80,"Set defaults"
    cursor_point 80
    on_click 80,enregistrer

    ' bouton "OK"
    button 81
    parent 81,70
    top 81,260
    left 81,161
    width 81,108
    caption 81,"OK"
    cursor_point 81
    on_click 81,creerLiaisonSerie

    ' legendes
    alpha 85
    parent 85,70
    top 85,53
    left 85,94
    caption 85,"Port:"
    
    alpha 86
    parent 86,70
    top 86,93
    left 86,67
    caption 86,"Baud rate:"
    
    alpha 87
    parent 87,70
    top 87,133
    left 87,71
    caption 87,"Data bits:"

    alpha 88
    parent 88,70
    top 88,173
    left 88,86
    caption 88,"Parity:"
    
    alpha 89
    parent 89,70
    top 89,213
    left 89,72
    caption 89,"Stop bits:"

    show 13
end_sub

sub receptionSat()
    while boucle% = 1
        recept$ = serial_read$(35)
        for i% = 1 to len(recept$)
            char$ = mid$(recept$,i%,1)
            if char$ <> chr$(10)
                buffer$ = buffer$ + char$
            else
                item_add 11,buffer$
                if analyse% > 0
                    affichageDetaille()
                else
                    affichageGlobal()
                end_if
            end_if
        next i%
    end_while            
end_sub

sub affichageGlobal()
    if instr(buffer$,"$GPRMC") = 1
        memoCible% = 16
    end_if
    if instr(buffer$,"$GPVTG") = 1
        memoCible% = 18
    end_if        
    if instr(buffer$,"$GPGGA") = 1
        memoCible% = 20
    end_if        
    if instr(buffer$,"$GPGSA") = 1
        memoCible% = 22
    end_if        
    if instr(buffer$,"$GPGSV") = 1
        memoCible% = 24
    end_if        
    if instr(buffer$,"$GLGSV") = 1
        memoCible% = 26
    end_if        
    if instr(buffer$,"$GPGLL") = 1
        memoCible% = 28
    end_if        

    for j% = 1 to len(buffer$)
        char1$ = mid$(buffer$,j%,1)
        if char1$ = chr$(44) or char1$ = chr$(42)
            char1$ = fin$
        end_if
        donnee$ = donnee$ + char1$
    next j%
    text memoCible%,donnee$
    donnee$ = ""
    buffer$=""
end_sub


sub affichageDetaille()
    if analyse% = 1 then affichageGPRMC()
    if analyse% = 2 then affichageGPVTG()
    if analyse% = 3 then affichageGPGGA()
    if analyse% = 4 then affichageGPGSA()
    if analyse% = 5 then affichageGPGSV()
    if analyse% = 6 then affichageGLGSV()
    if analyse% = 7 then affichageGPGLL()
end_sub

sub affichageGPRMC()
    champ% = 1
    if instr(buffer$,"$GPRMC") = 1
        for j% = 1 to len(buffer$)
            char1$ = mid$(buffer$,j%,1)
            if char1$ = chr$(44) :' caractre virgule
                GPRMC$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$
                field$ = ""
            end_if
            if char1$ = chr$(42) :' caractre toile
                char1$ = fin$ + chr$(42) + fin$
                field$ = "" 
            end_if
            donnee$ = donnee$ + char1$
            if instr(char1$,chr$(10)) = 0
                field$ = field$ + char1$
            end_if
        next j%
        text 103,donnee$
        field$ = ""
        champ% = 1

        ' mise en forme et affichage heure 
        if len(GPRMC$(2)) > 6 and numeric(GPRMC$(2)) = 1
            temp$ = left$(GPRMC$(2),2)
            tmp = val(temp$) :' supp zro non significatif
            hr$ = str$(tmp) + chr$(58)
            hr$ = hr$ + mid$(GPRMC$(2),3,2) + chr$(58)
            hr$ = hr$ + mid$(GPRMC$(2),5,2)
            while len(hr$) < 8
                hr$ = chr$(32) + hr$
            end_while
            caption 115,hr$
        else
            caption 115,""
        end_if
            
        ' mise en fome et affichage date
        if len(GPRMC$(10)) > 5
            dt$ = left$(GPRMC$(10),2) + chr$(47)
            dt$ = dt$ + mid$(GPRMC$(10),3,2) + chr$(47)
            dt$ = dt$ + "20" + mid$(GPRMC$(10),5,2)
            caption 116,dt$
        else    
            caption 116,""
        end_if
         
        ' mise en forme et affichage latitude
        if numeric(GPRMC$(4)) = 1
            ' traitement des degrs
            tmp = val(GPRMC$(4))
            dd = int(tmp /100)
            latitude$ = str$(dd) + chr$(186) + chr$(32)
            ' traitement des minutes
            mm = tmp - (dd*100)
            mm = int(mm)
            latitude$ = latitude$ + str$(mm) + chr$(39) + chr$(32)
            ' traitement des secondes
            tmp = instr(GPRMC$(4),chr$(46))
            temp$ = mid$(GPRMC$(4),tmp,len(GPRMC$(4)))  
            ss = val(temp$)
            ss = ss * 60
            latitude$ = latitude$ + str$(ss) + chr$(34) + chr$(32)
            ' ajout point cardinal
            latitude$ = latitude$ + GPRMC$(5)
            ' affichage latidude
            caption 117,latitude$
        else
            caption 117,""
        end_if        

       ' mise en forme et affichage longitude
        if numeric(GPRMC$(6)) = 1
            ' traitement des degrs
            tmp = val(GPRMC$(6))
            dd = int(tmp /100)
            longitude$ = str$(dd) + chr$(186) + chr$(32)
            ' traitement des minutes
            mm = tmp - (dd*100)
            mm = int(mm)
            longitude$ = longitude$ + str$(mm) + chr$(39) + chr$(32)
            ' traitement des secondes
            tmp = instr(GPRMC$(6),chr$(46))
            temp$ = mid$(GPRMC$(6),tmp,len(GPRMC$(6)))  
            ss = val(temp$)
            ss = ss * 60
            longitude$ = longitude$ + str$(ss) + chr$(34) + chr$(32)
            ' ajout point cardinal
            longitude$ = longitude$ + GPRMC$(7)
            ' affichage longitude
            caption 118,longitude$
        else
            caption 118,""
        end_if        

        ' mise en forme et affichage vitesse au sol
        if numeric(GPRMC$(8)) = 1
        kph = val(GPRMC$(8))
            kph = kph * 1.852
            kph = int(kph)
            caption 119,str$(kph) + " kph (km/h)"
        else
            caption 119,""
        end_if    
    end_if    
    donnee$ = ""
    buffer$ = ""
end_sub

sub affichageGPVTG()
    champ% = 1
    if instr(buffer$,"$GPVTG") = 1
        for j% = 1 to len(buffer$)
            char1$ = mid$(buffer$,j%,1)
            if char1$ = chr$(44) :' caractre virgule
                GPVTG$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$
                field$ = ""
            end_if
            if char1$ = chr$(42) :' caractre toile
                char1$ = fin$ + chr$(42) + fin$
                field$ = "" 
            end_if
            donnee$ = donnee$ + char1$
            if instr(char1$,chr$(10)) = 0
                field$ = field$ + char1$
            end_if
        next j%
        text 133,donnee$
        field$ = ""
        champ% = 1

        ' affichage vitesse km/h 
        if numeric(GPVTG$(8)) = 1
            kph = val(GPVTG$(8))
            kph = int(kph)
            caption 145,str$(kph) + " kph (km/h)"
        end_if    

        ' affichage vitesse kn
        if numeric(GPVTG$(6)) = 1
            kn = val(GPVTG$(6))
            kn = int(kn)
            caption 144,str$(kn) + " kn (MPH)"
        end_if    

        ' affichage direction en degrs
        if numeric(GPVTG$(2)) = 1
            cap = val(GPVTG$(2))
            cap = int(cap)
            caption 143, str$(cap) + chr$(176) 
        ' orientation boussole
            3D_Z_ROTATE 142,(cap*(-1))
        else
            caption 143, "" 
        end_if
    end_if
    donnee$ = ""
    buffer$ = ""
end_sub

sub affichageGPGGA()
    champ% = 1
    if instr(buffer$,"$GPGGA") = 1
        for j% = 1 to len(buffer$)
            char1$ = mid$(buffer$,j%,1)
            if char1$ = chr$(44) :' caractre virgule
                GPGGA$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$
                field$ = ""
            end_if
            if char1$ = chr$(42) :' caractre toile
                char1$ = fin$ + chr$(42) + fin$
                field$ = "" 
            end_if
            donnee$ = donnee$ + char1$
            if instr(char1$,chr$(10)) = 0
                field$ = field$ + char1$
            end_if
        next j%
        text 163,donnee$
        field$ = ""
        champ% = 1

        ' mise en forme et affichage heure 
        if len(GPGGA$(2)) > 6 and numeric(GPGGA$(2)) = 1
            temp$ = left$(GPGGA$(2),2)
            tmp = val(temp$) :' supp zro non significatif
            hr$ = str$(tmp) + chr$(58)
            hr$ = hr$ + mid$(GPGGA$(2),3,2) + chr$(58)
            hr$ = hr$ + mid$(GPGGA$(2),5,2)
            while len(hr$) < 8
                hr$ = chr$(32) + hr$
            end_while
            caption 171,hr$
        else
            caption 171,""
        end_if
            
        ' mise en forme et affichage latitude
        if numeric(GPGGA$(3)) = 1
            ' traitement des degrs
            tmp = val(GPGGA$(3))
            dd = int(tmp /100)
            latitude$ = str$(dd) + chr$(186) + chr$(32)
            ' traitement des minutes
            mm = tmp - (dd*100)
            mm = int(mm)
            latitude$ = latitude$ + str$(mm) + chr$(39) + chr$(32)
            ' traitement des secondes
            tmp = instr(GPGGA$(3),chr$(46))
            temp$ = mid$(GPGGA$(3),tmp,len(GPGGA$(3)))  
            ss = val(temp$)
            ss = ss * 60
            latitude$ = latitude$ + str$(ss) + chr$(34) + chr$(32)
            ' ajout point cardinal
            latitude$ = latitude$ + GPGGA$(4)
            ' affichage latidude
            caption 172,latitude$
        else
            caption 172,""
        end_if        

       ' mise en forme et affichage longitude
        if numeric(GPGGA$(5)) = 1
            ' traitement des degrs
            tmp = val(GPGGA$(5))
            dd = int(tmp /100)
            longitude$ = str$(dd) + chr$(186) + chr$(32)
            ' traitement des minutes
            mm = tmp - (dd*100)
            mm = int(mm)
            longitude$ = longitude$ + str$(mm) + chr$(39) + chr$(32)
            ' traitement des secondes
            tmp = instr(GPGGA$(5),chr$(46))
            temp$ = mid$(GPGGA$(5),tmp,len(GPGGA$(5)))  
            ss = val(temp$)
            ss = ss * 60
            longitude$ = longitude$ + str$(ss) + chr$(34) + chr$(32)
            ' ajout point cardinal
            longitude$ = longitude$ + GPGGA$(6)
            ' affichage longitude
            caption 173,longitude$
        else
            caption 173,""
        end_if        

        ' affichage nombre de satellites
        if numeric(GPGGA$(8)) = 1
            sat = val(GPGGA$(8))
            caption 174,str$(sat) 
        else
            caption 174,"0"
        end_if
            
        ' affichage altitude
        if numeric(GPGGA$(10)) = 1
            sat = val(GPGGA$(10))
            caption 175,str$(sat) + " m" 
        else
            caption 175,""
        end_if

    end_if
    donnee$ = ""
    buffer$ = ""
end_sub

sub affichageGPGSA()
    champ% = 1
    if nTrame% <> 193 and nTrame% <> 194
        nTrame% = 193
    end_if
    if instr(buffer$,"$GPGSA") = 1
        for j% = 1 to len(buffer$)
            char1$ = mid$(buffer$,j%,1)
            if char1$ = chr$(44) :' caractre virgule
'                GPGSA$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$
                field$ = ""
            end_if
            if char1$ = chr$(42) :' caractre toile
                char1$ = fin$ + chr$(42) + fin$
                field$ = "" 
            end_if
            donnee$ = donnee$ + char1$
            if instr(char1$,chr$(10)) = 0
                field$ = field$ + char1$
            end_if
        next j%
        text nTrame%,donnee$
        field$ = ""
        champ% = 1
        nTrame% = 194
    else
        nTrame% = 193
    end_if
    donnee$ = ""
    buffer$ = ""
end_sub

sub affichageGPGSV()
    if nTrame% < 223 or nTrame% > 226
        nTrame% = 223
        champ% = 1
    end_if
    if instr(buffer$,"$GPGSV") = 1
        for j% = 1 to len(buffer$)
            char1$ = mid$(buffer$,j%,1)
            if char1$ = chr$(44) :' caractre virgule
                GPGSV$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$
                field$ = ""
            end_if
            if char1$ = chr$(42) :' caractre toile
                GPGSV$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$ + chr$(42) + fin$
                field$ = "" 
            end_if
            donnee$ = donnee$ + char1$
            if instr(char1$,chr$(10)) = 0
                field$ = field$ + char1$
            end_if
        next j%
        text nTrame%,donnee$
        field$ = ""
        nTrame% = nTrame% + 1 

        ' affichage du nombre de satellites en vue
        caption 247,GPGSV$(4)

        ' affichage bargraphe rception satellites 1re trame
        if numeric(GPGSV$(8))=1
            position 229,val(GPGSV$(8))
        else
            position 229,0
        end_if    

        if numeric(GPGSV$(12))=1
            position 230,val(GPGSV$(12))
        else
            position 230,0
        end_if    

        if numeric(GPGSV$(16))=1
            position 231,val(GPGSV$(16))
        else
            position 231,0
        end_if    

        if numeric(GPGSV$(20))=1
            position 232,val(GPGSV$(20))
        else
            position 232,0
        end_if

        ' affichage bargraphe rception satellites 2me trame
        if numeric(GPGSV$(28))=1
            position 233,val(GPGSV$(28))
        else
            position 233,0
        end_if    

        if numeric(GPGSV$(32))=1
            position 234,val(GPGSV$(32))
        else
            position 234,0
        end_if    

        if numeric(GPGSV$(36))=1
            position 235,val(GPGSV$(36))
        else
            position 235,0
        end_if    

        if numeric(GPGSV$(40))=1
            position 236,val(GPGSV$(40))
        else
            position 236,0
        end_if    

        ' affichage bargraphe rception satellites 3me trame
        if numeric(GPGSV$(48))=1
            position 237,val(GPGSV$(48))
        else
            position 237,0
        end_if    

        if numeric(GPGSV$(52))=1
            position 238,val(GPGSV$(52))
        else
            position 238,0
        end_if    

        if numeric(GPGSV$(56))=1
            position 239,val(GPGSV$(56))
        else
            position 239,0
        end_if    

        if numeric(GPGSV$(60))=1
            position 240,val(GPGSV$(60))
        else
            position 240,0
        end_if    

        ' affichage bargraphe rception satellites 4me trame
        if numeric(GPGSV$(68))=1
            position 241,val(GPGSV$(68))
        else
            position 241,0
        end_if    

        if numeric(GPGSV$(72))=1
            position 242,val(GPGSV$(72))
        else
            position 242,0
        end_if    

        if numeric(GPGSV$(76))=1
            position 243,val(GPGSV$(76))
        else
            position 243,0
        end_if    

        if numeric(GPGSV$(80))=1
            position 244,val(GPGSV$(80))
        else
            position 244,0
        end_if    

        prn$ = "PRN: " + GPGSV$(5) + " " + GPGSV$(9) + " " + GPGSV$(13) + " " + GPGSV$(17) + " "
        prn$ = prn$ + GPGSV$(25) + " " + GPGSV$(29) + " " + GPGSV$(33) + " " + GPGSV$(37) + " "
        prn$ = prn$ + GPGSV$(45) + " " + GPGSV$(49) + " " + GPGSV$(53) + " " + GPGSV$(57) + " "
        prn$ = prn$ + GPGSV$(65) + " " + GPGSV$(69) + " " + GPGSV$(73) + " " + GPGSV$(77)  
        caption 245,prn$
    else
        if champ% > 4
            for j% = champ% to 77
                GPGSV$(j%) = ""    
            next j%
        end_if    
        nTrame% = 223
        champ% = 1
    end_if
    donnee$ = ""
    buffer$ = ""
end_sub

sub affichageGLGSV()
    if nTrame% < 253 or nTrame% > 256
        nTrame% = 253
        champ% = 1
    end_if
    if instr(buffer$,"$GLGSV") = 1
        for j% = 1 to len(buffer$)
            char1$ = mid$(buffer$,j%,1)
            if char1$ = chr$(44) :' caractre virgule
                GLGSV$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$
                field$ = ""
            end_if
            if char1$ = chr$(42) :' caractre toile
                GLGSV$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$ + chr$(42) + fin$
                field$ = "" 
            end_if
            donnee$ = donnee$ + char1$
            if instr(char1$,chr$(10)) = 0
                field$ = field$ + char1$
            end_if
        next j%
        text nTrame%,donnee$
        field$ = ""
        nTrame% = nTrame% + 1 

        ' affichage du nombre de satellites en vue
        caption 277,GLGSV$(4)

        ' affichage bargraphe rception satellites 1re trame
        if numeric(GLGSV$(8))=1
            position 259,val(GLGSV$(8))
        else
            position 259,0
        end_if    

        if numeric(GLGSV$(12))=1
            position 260,val(GLGSV$(12))
        else
            position 260,0
        end_if    

        if numeric(GLGSV$(16))=1
            position 261,val(GLGSV$(16))
        else
            position 261,0
        end_if    

        if numeric(GLGSV$(20))=1
            position 262,val(GLGSV$(20))
        else
            position 262,0
        end_if

        ' affichage bargraphe rception satellites 2me trame
        if numeric(GLGSV$(28))=1
            position 263,val(GLGSV$(28))
        else
            position 263,0
        end_if    

        if numeric(GLGSV$(32))=1
            position 264,val(GLGSV$(32))
        else
            position 264,0
        end_if    

        if numeric(GLGSV$(36))=1
            position 265,val(GLGSV$(36))
        else
            position 265,0
        end_if    

        if numeric(GLGSV$(40))=1
            position 266,val(GLGSV$(40))
        else
            position 266,0
        end_if    

        ' affichage bargraphe rception satellites 3me trame
        if numeric(GLGSV$(48))=1
            position 267,val(GLGSV$(48))
        else
            position 267,0
        end_if    

        if numeric(GLGSV$(52))=1
            position 268,val(GLGSV$(52))
        else
            position 268,0
        end_if    

        if numeric(GLGSV$(56))=1
            position 269,val(GLGSV$(56))
        else
            position 269,0
        end_if    

        if numeric(GLGSV$(60))=1
            position 270,val(GLGSV$(60))
        else
            position 270,0
        end_if    

        ' affichage bargraphe rception satellites 4me trame
        if numeric(GLGSV$(68))=1
            position 271,val(GLGSV$(68))
        else
            position 271,0
        end_if    

        if numeric(GLGSV$(72))=1
            position 272,val(GLGSV$(72))
        else
            position 272,0
        end_if    

        if numeric(GLGSV$(76))=1
            position 273,val(GLGSV$(76))
        else
            position 273,0
        end_if    

        if numeric(GLGSV$(80))=1
            position 274,val(GLGSV$(80))
        else
            position 274,0
        end_if    

        prn$ = "PRN: " + GLGSV$(5) + " " + GLGSV$(9) + " " + GLGSV$(13) + " " + GLGSV$(17) + " "
        prn$ = prn$ + GLGSV$(25) + " " + GLGSV$(29) + " " + GLGSV$(33) + " " + GLGSV$(37) + " "
        prn$ = prn$ + GLGSV$(45) + " " + GLGSV$(49) + " " + GLGSV$(53) + " " + GLGSV$(57) + " "
        prn$ = prn$ + GLGSV$(65) + " " + GLGSV$(69) + " " + GLGSV$(73) + " " + GLGSV$(77)  
        caption 275,prn$
    else
        if champ% > 4
            for j% = champ% to 77
                GLGSV$(j%) = ""    
            next j%
        end_if    
        nTrame% = 253
        champ% = 1
    end_if
    donnee$ = ""
    buffer$ = ""
end_sub

sub affichageGPGLL()
    champ% = 1
    if instr(buffer$,"$GPGLL") = 1
        for j% = 1 to len(buffer$)
            char1$ = mid$(buffer$,j%,1)
            if char1$ = chr$(44) :' caractre virgule
                GPGLL$(champ%) = field$
                champ% = champ% + 1
                char1$ = fin$
                field$ = ""
            end_if
            if char1$ = chr$(42) :' caractre toile
                char1$ = fin$ + chr$(42) + fin$
                field$ = "" 
            end_if
            donnee$ = donnee$ + char1$
            if instr(char1$,chr$(10)) = 0
                field$ = field$ + char1$
            end_if
        next j%
        text 283,donnee$
        field$ = ""
        champ% = 1

        ' mise en forme et affichage heure 
        if len(GPGLL$(6)) > 6 and numeric(GPGLL$(6)) = 1
            temp$ = left$(GPGLL$(6),2)
            tmp = val(temp$) :' supp zro non significatif
            hr$ = str$(tmp) + chr$(58)
            hr$ = hr$ + mid$(GPGLL$(6),3,2) + chr$(58)
            hr$ = hr$ + mid$(GPGLL$(6),5,2)
            while len(hr$) < 8
                hr$ = chr$(32) + hr$
            end_while
            caption 289,hr$
        else
            caption 289,""
        end_if
            
        ' mise en forme et affichage latitude
        if numeric(GPGLL$(2)) = 1
            ' traitement des degrs
            tmp = val(GPGLL$(2))
            dd = int(tmp /100)
            latitude$ = str$(dd) + chr$(186) + chr$(32)
            ' traitement des minutes
            mm = tmp - (dd*100)
            mm = int(mm)
            latitude$ = latitude$ + str$(mm) + chr$(39) + chr$(32)
            ' traitement des secondes
            tmp = instr(GPGLL$(2),chr$(46))
            temp$ = mid$(GPGLL$(2),tmp,len(GPGLL$(2)))  
            ss = val(temp$)
            ss = ss * 60
            latitude$ = latitude$ + str$(ss) + chr$(34) + chr$(32)
            ' ajout point cardinal
            latitude$ = latitude$ + GPGLL$(3)
            ' affichage latidude
            caption 290,latitude$
        else
            caption 290,""
        end_if        

           ' mise en forme et affichage longitude
        if numeric(GPGLL$(4)) = 1
            ' traitement des degrs
            tmp = val(GPGLL$(4))
            dd = int(tmp /100)
            longitude$ = str$(dd) + chr$(186) + chr$(32)
            ' traitement des minutes
            mm = tmp - (dd*100)
            mm = int(mm)
            longitude$ = longitude$ + str$(mm) + chr$(39) + chr$(32)
            ' traitement des secondes
            tmp = instr(GPGLL$(4),chr$(46))
            temp$ = mid$(GPGLL$(4),tmp,len(GPGLL$(4)))  
            ss = val(temp$)
            ss = ss * 60
            longitude$ = longitude$ + str$(ss) + chr$(34) + chr$(32)
            ' ajout point cardinal
            longitude$ = longitude$ + GPGLL$(5)
            ' affichage longitude
            caption 291,longitude$
        else
            caption 291,""
        end_if        
    end_if
    donnee$ = ""
    buffer$ = ""
end_sub

afficheFenetreSerial:
    inactive 1
    show 70
return

choixPortCom:
    sPortCom$ = item_index$(74)
return

choixBaudrate:
    sBaudRate$ = item_index$(75)
return

choixNbBits:
    sDataBit$ = item_index$(76)
return

choixParity:
    sParity$ = item_index$(77)
return

choixBitstop:
    sStopBit$ = item_index$(78)
return

fermerFenetreSerial:
    hide 70
return

analyserData:
    select number_click
        case 4 :' bouton "Overview"
            analyse% = 0
            show 13
            hide 100
            hide 130
            hide 160
            hide 190
            hide 220
            hide 250
            hide 280            
        case 15 :' objet alpha 15 "GPRMC"
            analyse% = 1
            show 100
            hide 13
        case 16 :' objet memo 16 "GPRMC"
            analyse% = 1
            show 100
            hide 13
        case 17 :' objet alpha 17 "GPVTG"
            analyse% = 2
            show 130
            hide 13
        case 18 :' objet memo 18 "GPVTG"
            analyse% = 2
            show 130
            hide 13
        case 19 :' objet alpha 19 "GPGGA"
            analyse% = 3
            show 160
            hide 13
        case 20 :' objet memo 20 "GPGGA"
            analyse% = 3
            show 160
            hide 13
        case 21 :' objet alpha 19 "GPGSA"
            analyse% = 4
            show 190
            hide 13
        case 22 :' objet memo 20 "GPGSA"
            analyse% = 4
            show 190
            hide 13
        case 23 :' objet alpha 19 "GPGSV"
            analyse% = 5
            show 220
            hide 13
        case 24 :' objet memo 20 "GPGSV"
            analyse% = 5
            show 220
            hide 13
        case 25 :' objet alpha 19 "GLGSV"
            return
            analyse% = 6
            show 250
            hide 13
        case 26 :' objet memo 20 "GLGSV"
            return
            analyse% = 6
            show 250
            hide 13
        case 27 :' objet alpha 19 "GPGLL"
            return
            analyse% = 7
            show 280
            hide 13
        case 28 :' objet memo 20 "GPGLL"
            return
            analyse% = 7
            show 280
            hide 13
    end_select
return

clearData:
    clear 11
    clear 16
    clear 18
    clear 20
    clear 22
    clear 24
    clear 26
    clear 28 
return

creerLiaisonSerie:
    if sPortCom$ = ""
        info$ = "Veuillez configurer le port COM !"
        if message_warning_ok(info$) > 0
            show 70
        end_if
        return
    end_if

    portCom% = val(mid$(sPortCom$,4,len(sPortCom$)))    
    serial_close 35

    if serial_port_exists(portCom%) = 0
        info$ = "Le port " + sPortCom$ + " n'est pas disponible !" + chr$(13) + chr$(13)
        info$ = info$ + "Vrifiez les connexions lectriques ainsi que le numro de port COM attribu."
        if message_error_ok(info$) < 2
            return
        end_if 
    end_if
    
    hide 70
    
    if sParity$ = "Aucune" then parity% = 0
    if sParity$ = "Impaire" then parity% = 1
    if sParity$ = "Paire" then parity% = 2

    serial_port 35,portCom%
    serial_baudrate 35,val(sBaudRate$)
    serial_databits 35,val(sDataBit$)
    serial_parity 35,parity%
    serial_stopbits 35,val(sStopBit$)
    serial_open 35
    active 1
return

onOffSerie:
    if serialOnOff% = 0
        serialOnOff% = 1
        color 1,0,255,0
        inactive 2
        boucle% = 1
        recept$ = serial_read$(35)
        recept$=""
        receptionSat()
    else
        boucle% = 0
        serialOnOff% = 0
        color 1,255,0,0
        active 2
    end_if
return

enregistrer:
    file_open_write 30,repertoire$ + "moniteur_gnss.cfg"
        file_writeln 30,sPortCom$
        file_writeln 30,sBaudRate$
        file_writeln 30,sDataBit$
        file_writeln 30,sParity$
        file_writeln 30,sStopBit$
    file_close 30
return

sub chargerFichierConfiguration()
    ' charger fichier configuration s'il existe
    if file_exists(repertoire$ + "moniteur_gnss.cfg") = 1
        file_open_read 31,repertoire$ + "moniteur_gnss.cfg"
            sPortCom$ = file_readln$(31)
            sBaudRate$ = file_readln$(31)
            sDataBit$ = file_readln$(31)
            sParity$ = file_readln$(31)
            sStopBit$ = file_readln$(31)
        file_close 31  
        trigger_click 81
    else
        ' valeurs par dfaut
        sPortCom$ = ""
        sBaudRate$ = "9600"
        sDataBit$ = "8"
        sParity$ = "Aucune"
        sStopBit$ ="1"
    end_if

    text 74,sPortCom$
    text 75,sBaudRate$
    text 76,sDataBit$
    text 77,sParity$
    text 78,sStopBit$
end_sub

quitter:
    boucle% = 0
return