
rem ============================================================================
rem                     Rotation dun point
rem ============================================================================
rem Matrice de rotation dun point P(x,y) dun angle phi en degr.
rem Pour le point P(x,y) on applique la matrice de rotation suivante :
rem       _    _      _                      _     _   _
rem      |      |    |                        |   |     |
rem      |  x  |    |   cos(phi)   -sin(phi) |   |  x  |
rem      |      |  = |                        | * |     |
rem      |  y  |    |   sin(phi)    cos(phi) |   |  y  |
rem      |_    _|    |_                      _|   |_   _|
rem
rem Ce qui donne le point P(x,y) :
rem        
rem        
rem           x = x * cos(phi) - y * sin(phi)   
rem                                                          
rem           y = y * cos(phi) + x * sin(phi)  
rem        
rem
rem ============================================================================
rem Info:
rem Pour faire tourner une figure, il suffit de faire tourner tous les points
rem qui dfinissent cette figure.
rem ============================================================================

dim x,y,xprime,yprime,x0,y0,phi
picture  10 : full_space 10 : 2d_target_is 10 : print_target_is 10 : font_bold 10
caption 0,"Rotation d'un point P(x,y) ----> P'(x',y')"
x0 = width_client(10)/2 : y0 = height_client(10)/2
degrees : ' On travaille en degr
2d_line 0,y0,2*x0,y0  : ' axe des x
2d_line x0,0,x0,2*y0  : ' axe des y
x = 150 : y = 60      : ' coordonnes du point qui subira la rotation
2d_pen_color 0,0,255  : 2d_pen_width 2
2d_line x0,y0,x0+x,y0-y : ' trac d'un segment (vecteur)
2d_pen_color 0,0,0    : 2d_pen_width 1
2d_line x0+x,y0-y,x0+x,y0 : 2d_line x0+x,y0-y,x0,y0-y
print_locate x0+x+5,y0-y-6 : print "P"
print_locate x0+x-5,y0+5   : print "y"
print_locate x0-10,y0-y-6  : print "x"
' pause 1000
phi = 90 : ' angle de rotation
xprime = x * cos(phi) - y * sin(phi)  : ' coordonne x aprs rotation
yprime = y * cos(phi) + x * sin(phi)  : ' coordonne y aprs rotation
2d_pen_color 255,0,0 : 2d_pen_width 2
2d_line x0,y0,x0+xprime,y0-yprime
2d_pen_color 0,0,0   : 2d_pen_width 1
2d_line x0+xprime,y0-yprime,x0,y0-yprime : 2d_line x0+xprime,y0-yprime,x0+xprime,y0
print_locate x0+xprime,y0-yprime-15 : print "P'"
print_locate x0-12,y0-yprime-15 : print "x'"
print_locate x0+xprime,y0+5     : print "y'"
2d_pen_color 0,200,0 :  2d_pen_width 2
2d_arc x0,y0,20,110,22
print_locate x0+10,y0-30 : print "phi"
print_locate 10,300 : print "Le point P(x,y)"
print "   a subi une rotation d'un angle phi dans"
print "   le sens trigonomtrique pour devenir "
print "   le point P'(x',y')"
rem ============================================================================