' Panoramic => Arduino UNO
' Logiciel de dmonstration
' Commandes locale et distante de 6 LEDs
' Marc - Fvrier 2022
' Ecrit en langage Panoramic

dim portCom%, recept$, i%, portD%

label onOffSerial, choixPortCom, actionLed, redim0, serialReceive, quitter

dessinerInterfaceUtilisateur()

end


sub dessinerInterfaceUtilisateur()
    width 0,width(0) - width_client(0) + 590
    height 0,height(0) - height_client(0) + 180
    left 0,(screen_x - width(0)) / 2
    top 0,(screen_y - height(0)) / 2
    on_resize 0,redim0
    on_close 0,quitter
    caption 0,"PANORAMIC --> Arduino UNO  Dmonstration : Commande distante et locale de 6 LEDs"
    creerModuleSerial()
    creerModuleInterfaceGpio()
end_sub


sub creerModuleSerial()
    dim_local n%

    command_target_is 0

    container 1
    width 1,100
    height 1,150
    left 1,15
    top 1,15
    caption 1,"Serial"
  
    command_target_is 1
    
    combo 2
    parent 2,1
    width 2,70
    top 2,30
    left 2,15
    for n% = 1 to 255
        item_add 2,"COM" + str$(n%)
    next n%
    on_change 2,choixPortCom

    switch1 3
    parent 3,1
    width 3,50
    top 3,70
    left 3,25
    caption 3,"Off|On"
    on_click 3,onOffSerial
    inactive 3
end_sub


sub creerModuleInterfaceGpio()
    dim_local n%,e%,numeroGpio%
    command_target_is 0
    
    container 10
    width 10,445
    height 10,150
    top 10,15
    left 10,130
    caption 10,"GPIO"
    
    ' dessiner les interrupteurs de commande des GPIO
    numeroGpio% = 2
    e% = 23
    
    for n% = 12 to 17
        switch1 n%
        parent n%,10
        width n%,50
        top n%,70
        left n%,e%
        caption n%,str$(numeroGpio%)+": Off|"+str$(numeroGpio%)+": On"
        on_click n%, actionLed
        inactive n%
        e% = e% + 70
        numeroGpio% = numeroGpio% + 1
    next n%
    
    ' dessiner LEDs au dessus des interrupteurs de commande GPIO
    e% = 36
    for n% = 42 to 47
        led1 n%
        parent n%,10
        top n%,28
        left n%,e%
        color n%,127,127,127
        e% = e% + 70
    next n%
end_sub


choixPortCom:
    portCom% = item_index(2)
    if serial_port_exists(portCom%) = 0
        if message_warning_ok("COM"+str$(portCom%) + " : Liaison srie inexistante !") < 2
            inactive 3 :' interrupteur on/off Serial
            return
        end_if    
    end_if
    active 3 :' interrupteur on/off Serial
return


onOffSerial:
    if checked(3) = 0
        inactive 2
        initialisationLiaisonSerie()
        serial_open 60
        on_receive 60,serialReceive
        for i% = 12 to 17
            active i%
        next i%
    else
        if object_exists(60) = 1
            serial_close 60
            active 2
            for i% = 12 to 17
                inactive i%
            next i%
        end_if
    end_if        
return


sub initialisationLiaisonSerie()
    if object_exists(60) = 0
        serial 60
    end_if
    serial_port 60,portCom%
    serial_baudrate 60,9600
    serial_databits 60,8
    serial_parity 60,0
    serial_stopbits 60,1
end_sub


actionLed:
    select number_click
        case 12 :' LED 1
            if checked(12) = 0
                color 42,0,255,0
                portd% = bin_or(portd%,4)
            else
                color 42,127,127,127
                portd% = bin_and(portd%,251)
            end_if

        case 13 :' LED 2
            if checked(13) = 0
                color 43,0,255,0
                portd% = bin_or(portd%,8)
            else
                color 43,127,127,127
                portd% = bin_and(portd%,247)
            end_if

        case 14 :' LED 3
            if checked(14) = 0
                color 44,0,255,0
                portd% = bin_or(portd%,16)
            else
                color 44,127,127,127
                portd% = bin_and(portd%,239)
            end_if

        case 15 :' LED 4
            if checked(15) = 0
                color 45,0,255,0
                portd% = bin_or(portd%,32)
            else
                color 45,127,127,127
                portd% = bin_and(portd%,223)
            end_if

        case 16 :' LED 5
            if checked(16) = 0
                color 46,0,255,0
                portd% = bin_or(portd%,64)
            else
                color 46,127,127,127
                portd% = bin_and(portd%,191)
            end_if

        case 17 :' LED 6
            if checked(17) = 0
                color 47,0,255,0
                portd% = bin_or(portd%,128)
            else
                color 47,127,127,127
                portd% = bin_and(portd%,127)
            end_if
    end_select

    serial_write 60,chr$(portD%)
return


serialReceive:
    recept$ = serial_read$(60)
    portD% = asc(recept$)

    if bin_and(portD%,4) = 4 :' LED n 1
         mark_off 12
         color 42,0,255,0
    else
         mark_on 12
         color 42,127,127,127
    end_if

    if bin_and(portD%,8) = 8 :' LED n 2
         mark_off 13
         color 43,0,255,0
    else
         mark_on 13
         color 43,127,127,127
    end_if
    
    if bin_and(portD%,16) = 16 :' LED n 3
         mark_off 14
         color 44,0,255,0
    else
         mark_on 14
         color 44,127,127,127
    end_if
    
    if bin_and(portD%,32) = 32 :' LED n 4
         mark_off 15
         color 45,0,255,0
    else
         mark_on 15
         color 45,127,127,127
    end_if
    
    if bin_and(portD%,64) = 64 :' LED n 5
         mark_off 16
         color 46,0,255,0
    else
         mark_on 16
         color 46,127,127,127
    end_if
    
    if bin_and(portD%,128) = 128 :' LED n 6
         mark_off 17
         color 47,0,255,0
    else
         mark_on 17
         color 47,127,127,127
    end_if
return


redim0:
    width 0,width(0) - width_client(0) + 590
    height 0,height(0) - height_client(0) + 180
return


quitter:
    if object_exists(60) = 1
        serial_close 60
    end_if    
return