' Panoramic => Arduino UNO
' Logiciel de dmonstration
' Commande de 2 LEDs et 2 servomoteurs
' Marc - Fvrier 2022

' Cablage :
' une LED connecte sur la pin 8 de l'Arduino
' une LED connecte sur la pin 9 de l'Arduino
' un servomoteur connect sur la pin 10 de l'Arduino
' un servomoteur connect sur la pin 11 de l'Arduino

dim portCom%, i%

label onOffSerial, choixPortCom, actionLed, actionServo, redim0, quitter

dessinerInterfaceUtilisateur()

end


sub dessinerInterfaceUtilisateur()
    width 0,width(0) - width_client(0) + 745
    height 0,height(0) - height_client(0) + 180
    left 0,(screen_x - width(0)) / 2
    top 0,(screen_y - height(0)) / 2
    on_resize 0,redim0
    on_close 0,quitter
    caption 0,"PANORAMIC --> Arduino UNO       Dmonstration : Commande de 2 LEDs et de 2 servomoteurs"
    creerModuleSerial()
    creerModuleInterfaceGpio()
end_sub


sub creerModuleSerial()
    dim_local n%

    command_target_is 0

    container 1
    width 1,100
    height 1,150
    left 1,15
    top 1,15
    caption 1,"Serial"
  
    command_target_is 1
    
    combo 2
    parent 2,1
    width 2,70
    top 2,30
    left 2,15
    for n% = 1 to 255
        item_add 2,"COM" + str$(n%)
    next n%
    on_change 2,choixPortCom

    switch1 3
    parent 3,1
    width 3,50
    top 3,70
    left 3,25
    caption 3,"Off|On"
    on_click 3,onOffSerial
    inactive 3
end_sub


sub creerModuleInterfaceGpio()
    dim_local n%,e%,numeroGpio%
    command_target_is 0
    
    container 10
    width 10,600
    height 10,150
    top 10,15
    left 10,130
    caption 10,"GPIO"
    
    ' dessiner les interrupteurs de commande des GPIO
    numeroGpio% = 8
    e% = 23
    
    for n% = 12 to 13
        switch1 n%
        parent n%,10
        width n%,50
        top n%,70
        left n%,e%
        caption n%,str$(numeroGpio%)+": Off|"+str$(numeroGpio%)+": On"
        on_click n%, actionLed
        inactive n%
        e% = e% + 70
        numeroGpio% = numeroGpio% + 1
    next n%
    
    ' dessiner LEDs au dessus des interrupteurs de commande GPIO
    e% = 36
    for n% = 42 to 43
        led1 n%
        parent n%,10
        top n%,28
        left n%,e%
        color n%,127,127,127
        e% = e% + 70
    next n%

    ' dessiner track_bar des servomoteurs et lgendes
    track_bar 14
    parent 14,10
    left 14,200
    top 14,70
    min 14,0
    max 14,18
    position 14,9
    on_change 14,actionServo    
    inactive 14

    track_bar 15
    parent 15,10
    left 15,400
    top 15,70
    min 15,0
    max 15,18
    position 15,9
    on_change 15,actionServo
    inactive 15    

    alpha 16
    parent 16,10
    top 16,30
    left 16,208
    font_size 16,11
    caption 16,"Servomoteur PIN 10"

    alpha 17
    parent 17,10
    top 17,30
    left 17,408
    font_size 17,11
    caption 17,"Servomoteur PIN 11"
end_sub


choixPortCom:
    portCom% = item_index(2)
    if serial_port_exists(portCom%) = 0
        if message_warning_ok("COM"+str$(portCom%) + " : Liaison srie inexistante !") < 2
            inactive 3 :' interrupteur on/off Serial
            return
        end_if    
    end_if
    active 3 :' interrupteur on/off Serial
return


onOffSerial:
    if checked(3) = 0
        inactive 2
        initialisationLiaisonSerie()
        serial_open 60
        for i% = 12 to 15
            active i%
        next i%
    else
        if object_exists(60) = 1
            serial_close 60
            active 2
            for i% = 12 to 15
               inactive i%
            next i%
        end_if
    end_if        
return


sub initialisationLiaisonSerie()
    if object_exists(60) = 0
        serial 60
    end_if
    serial_port 60,portCom%
    serial_baudrate 60,115200
    serial_databits 60,8
    serial_parity 60,0
    serial_stopbits 60,1
end_sub


actionLed:
    select number_click
        case 12
            if checked(12) = 0
                serial_write 60,"<1>1f"
                color 42,0,255,0
            else
                serial_write 60,"<1>0f"
                color 42,127,127,127
            end_if

        case 13
            if checked(13) = 0
                serial_write 60,"<2>1f"
                color 43,0,255,0
            else
                serial_write 60,"<2>0f"
                color 43,127,127,127
            end_if
    end_select
return


actionServo:
    select number_change
        case 14
            serial_write 60,"<3>"+ str$(position(14)*10) + "f"

        case 15
            serial_write 60,"<4>"+ str$(position(15)*10) + "f"
    end_select
return


redim0:
    width 0,width(0) - width_client(0) + 745
    height 0,height(0) - height_client(0) + 180
return


quitter:
    if object_exists(60) = 1
        serial_close 60
    end_if    
return